pro extractGui_event,event

    widget_control,event.id,get_uvalue=uval
    widget_control,event.top,get_uvalue=pState

    case uval of
        ;'SaveROI':(*pState).ObjFile = !false
        ;'SaveOBJ':(*pState).ObjFile = !true
        'multiple':begin
        files = dialog_pickfile(/multiple,filter='*.roi',/read,path=(*pState).path)
        (*pState).multipleFiles = n_elements(files)
        (*pState).pFileList = ptr_new(files)
    end
    'SaveASCII':(*pState).asciiFile = not (*pState).asciiFile
    'Extract':(*pState).extract = not (*pState).extract
    ;'start':begin
    ;	widget_control,(*pState).startid[0],get_value=temp1
    ;	widget_control,(*pState).startid[1],get_value=temp2
    ;	widget_control,(*pState).startid[2],get_value=temp3
    ;	widget_control,(*pState).startid[3],get_value=temp4
    ;	widget_control,(*pState).startid[4],get_value=temp5
    ;	widget_control,(*pState).startid[5],get_value=temp6
    ;	(*pState).start_time.month = temp1
    ;	(*pState).start_time.day = temp2
    ;	(*pState).start_time.hour = temp3
    ;	(*pState).start_time.minute = temp4
    ;	(*pState).start_time.sec = temp5
    ;	(*pState).start_time.msec = temp6
    ;end
    ;'stop':begin
    ;	widget_control,(*pState).stopid[0],get_value=temp1
    ;	widget_control,(*pState).stopid[1],get_value=temp2
    ;	widget_control,(*pState).stopid[2],get_value=temp3
    ;	widget_control,(*pState).stopid[3],get_value=temp4
    ;	widget_control,(*pState).stopid[4],get_value=temp5
    ;	widget_control,(*pState).stopid[5],get_value=temp6
    ;	(*pState).stop_time.month = temp1
    ;	(*pState).stop_time.day = temp2
    ;	(*pState).stop_time.hour = temp3
    ;	(*pState).stop_time.minute = temp4
    ;	(*pState).stop_time.sec = temp5
    ;	(*pState).stop_time.msec = temp6

    ;end
    'MedianFilt':begin
    widget_control,event.id, get_value = temp
    (*pState).MedianFilters = temp
end
'Threshold':begin
widget_control,event.id, get_value = temp
(*pState).Thresh = temp
end
'Gradient':begin
widget_control,event.id, get_value = temp
(*pState).GradientThresh = temp
end
'proceed':begin
(*pState).ok = !true
widget_control,event.top,/destroy
end
'cancel':widget_control,event.top,/destroy
else:
endcase

end

Function ExtractGUI, pStateInfo

    Forward_function convertFromSeconds

    tlb = widget_base(title='Auto Extract',/col,xOffset = 300,yOffset = 100)

    autobase = widget_base(tlb,/row)
    autobase1 = widget_base(autobase,/row,/frame)
    ultiple = widget_button(autobase1,value = 'Choose multiple files', UVALUE='multiple')
    ;	saveROI = widget_button(autobase1,value = 'Save to ROI file', UVALUE='SaveROI')
    ;	saveMIN = widget_button(autobase1,value = 'Save to OBJ file', UVALUE='SaveOBJ')
    autobase2 = widget_base(autobase,/row,/nonexclusive,/frame)
    ;saveMIN = widget_button(autobase2,value = 'Save to OBJ file', UVALUE='SaveOBJ')
    saveASCII = widget_button(autobase2,value = 'Save ASCII LOG files', UVALUE='SaveASCII')
    extract = widget_button(autobase2,value = 'Extract Features', UVALUE='Extract')
    widget_control,extract,set_button = !true

    ;start_time = {times}
    ; get first frame time
    ;start_time.month = (*p(*pStateInfo).).FileHead.month
    ;start_time = convertFromSeconds((*(*p(*pStateInfo).).pFileScan)[(*(*p(*pStateInfo).).pImgPosIndx)[(*p(*pStateInfo).).ImgPos-1]].hTime,(*p(*pStateInfo).).fileHead.year)
    ;start_time.msec = (*(*p(*pStateInfo).).pFileScan)[(*(*p(*pStateInfo).).pImgPosIndx)[(*p(*pStateInfo).).ImgPos-1]].msec

    ;stop_time = {times}
    ;get last frame time
    ;last_frame = n_elements((*(*p(*pStateInfo).).pImgPosIndx)) - 1


    ;stop_time.month = (*p(*pStateInfo).).FileHead.month
    ;stop_time = convertFromSeconds((*(*p(*pStateInfo).).pFileScan)[(*(*p(*pStateInfo).).pImgPosIndx)[last_frame]].hTime,(*p(*pStateInfo).).fileHead.year)
    ;stop_time.msec = (*(*p(*pStateInfo).).pFileScan)[(*(*p(*pStateInfo).).pImgPosIndx)[last_frame]].msec

    ;timesbase = widget_base(tlb,/col,/frame)

    ;	box_size = 5
    ;	b311 = widget_base(timesbase,/row)
    ;		StrMon = cw_field(b311,value=start_time.month ,/int,xsize=box_size,uvalue ='start',/all,title= 'Start Time:')
    ;		StrDay = cw_field(b311,value=start_time.day   ,/int,xsize=box_size,uvalue ='start',/all,title=':')
    ;		StrHr  = cw_field(b311,value=start_time.hour  ,/int,xsize=box_size,uvalue ='start',/all,title=':')
    ;		StrMin = cw_field(b311,value=start_time.minute,/int,xsize=box_size,uvalue ='start',/all,title=':')
    ;		StrSec = cw_field(b311,value=start_time.sec   ,/int,xsize=box_size,uvalue ='start',/all,title=':')
    ;		StrMSec= cw_field(b311,value=start_time.msec  ,/int,xsize=box_size,uvalue ='start',/all,title=':')

    ;	b312 = widget_base(timesbase,/row)
    ;		StpMon = cw_field(b312,value=stop_time.month ,/int,xsize=box_size,uvalue ='stop',/all,title= 'Stop Time:')
    ;		StpDay = cw_field(b312,value=stop_time.day   ,/int,xsize=box_size,uvalue ='stop',/all,title=':')
    ;		StpHr  = cw_field(b312,value=stop_time.hour  ,/int,xsize=box_size,uvalue ='stop',/all,title=':')
    ;		StpMin = cw_field(b312,value=stop_time.minute,/int,xsize=box_size,uvalue ='stop',/all,title=':')
    ;		StpSec = cw_field(b312,value=stop_time.sec   ,/int,xsize=box_size,uvalue ='stop',/all,title=':')
    ;		StpMSec= cw_field(b312,value=stop_time.msec  ,/int,xsize=box_size,uvalue ='stop',/all,title=':')

    ;-----------------------------------------------------
    ; Base for extraction options
    ExtractBase = WIDGET_BASE(tlb, /COL, SPACE=1, /BASE_ALIGN_CENTER, UVALUE='ProcButtons', /frame)
    label = widget_label(extractBase,value='Select Processing Parameters')

    controlBase1 = widget_base(extractBase,/row)
    MedFilter = WIDGET_SLIDER(controlBase1, MIN=0, MAX=20, TITLE='Median Filter Order', VALUE = 12, UVALUE='MedianFilt')
    space = widget_label(controlBase1,value = '   ')
    DimsTh = WIDGET_SLIDER(controlBase1,  MIN=-100, MAX=150, TITLE='ROI Darkness Threshold', VALUE = -25, UVALUE='Threshold')
    space = widget_label(controlBase1,value = '   ')
    DarkTh = WIDGET_SLIDER(controlBase1, MIN=10, MAX=400, TITLE='Gradient Threshold', VALUE = 40, UVALUE='Gradient')

    choiceBase = widget_base(tlb,/row)
    proceed = widget_button(choiceBase,value='Proceed',uvalue='proceed')
    cancel = widget_button(choiceBase,value='Cancel',uvalue='cancel')

    pState = ptr_new({MedianFilters:12,GradientThresh:40,Thresh:-25,ObjFile:!true,asciiFile:!false,extract:!true,ok:!false, multipleFiles:1,pFileList:ptr_new(),$
        path:(*pStateInfo).path})


    ;pState = ptr_new({ start_time:start_time,startID:[StrMon,StrDay,StrHr,StrMin,StrSec,StrMSec],$
    ;					stop_time:stop_time,stopID:[StpMon,StpDay,StpHr,StpMin,StpSec,StpMSec],$
    ;					MedianFilters:12,GradientThresh:40,Thresh:-25,ObjFile:!true,asciiFile:!false,ok:!false})

    widget_control,tlb,set_uvalue = pstate
    widget_control,tlb,/realize
    xmanager,'extractgui',tlb  ;, group = (*p(*pStateInfo).).main

    parameters = *pState
    ptr_free,pState
    return,parameters

end
