pro a3vcpiview_HK_plots_alone,ave_info
    ; this is to make two tms traces (M1V1, M2V2) in each of 3 pannel of a window.
    ; when a reset button is click, all methods M1, M2 and Variables V1, V2 will
    ; be set to default values.
    ave_info={startnanoseconds:0LL,endnanoseconds:0LL,$
        starttime:0LL,endtime:0LL,$
        shh:0,smm:0,sss:0,ehh:0,emm:0,ess:0,$
        plot_string:'00:00:00',binfilename:'00'}; added this on April 13, 2006.

    DEFSYSV, '!ZOOM_START_STRING' , ""
    DEFSYSV, '!ZOOM_END_STRING' , ""
    DEFSYSV, '!CurrentHFname' , ''
    DEFSYSV, '!CurrentHPname' , ''

    title_str='Ploting the House Keeping data'
    ;time_periods='aaaa to bbbbb'
    ;create top level base
    tlb=widget_base(title=title_str,/column,xsize=12.5*72,ysize=9*72,xoffset=30)
    L1base=widget_base(tlb,/row);      ;xoffset to place in offset the computer screen.
    ;timetext=widget_text(L1base,xsize=25,ysize=1,value=time_periods)
    helpnote=widget_button(L1base,value='Help Notes',uvalue='Help')
    save_config  =widget_button(L1base,value='save_config',uvalue='save_config')
    load_config  =widget_button(L1base,value='load_config',uvalue='load_config')
    save_png  =widget_button(L1base,value='save_png',uvalue='save_png')
    print_png =widget_button(L1base,value='Print',uvalue='ToPrinter')
    save_ascii =widget_button(L1base,value='save_ascii',uvalue='save_ascii')
    resetbut=widget_button(L1base,value='Reset',uvalue='Reset')
    plotit  =widget_button(L1base,value='Update',uvalue='Redraw')
    butns = ['All','Zm']
    plot_ave_onlyID= CW_BGroup(L1base,butns,/row,/exclusive,button_uvalue=[0,1],uvalue='plot_ave_only',/no_release)
    widget_control,plot_ave_onlyID,set_value=0
    ;********************************** added this on september 5, 2006 ************************
    ;start and Endtime base
    left_base= widget_base(L1base,/col,/frame)
    b311 = widget_base(L1base,/row)
    label1=widget_label(b311,value='ST:',FONT = 'ARIAL*BOLD*14')
    StartHoursID        = cw_field(b311,title='',value=0,/int,xsize=2,uvalue ='starthh',/all)
    StartMinutesID      = cw_field(b311,title='',value=0,/int,xsize=2,uvalue ='startmm',/all)
    StartSecondsID      = cw_field(b311,title='',value=0,/int,xsize=2,uvalue ='startss',/all)
    ;sbutton=widget_button(b311,value='|',uvalue='ST0')

    b312 = widget_base(L1base,/row)
    label2=widget_label(b312,value='ET:',FONT = 'ARIAL*BOLD*14')
    EndHoursID         = cw_field(b312,title='',value=0,/int,xsize=2,uvalue ='etarthh',/all)
    EndMinutesID       = cw_field(b312,title='',value=0,/int,xsize=2,uvalue ='etartmm',/all)
    EndSecondsID       = cw_field(b312,title='',value=0,/int,xsize=2,uvalue ='etartss',/all)
    ;*******************************************************************************************

    L2base=widget_base(tlb,/row);  for tms draw and left-side widget_buttons.
    tmsDraw=widget_draw(L2base,xsize=9.5*72,ysize=560);  7.5*72); 540/3=180
    tmsbutbase=widget_base(L2base,/column)
    A_Variables= ['none','Hdiode0','Hdiode21','Hdiode42','Hdiode64','Hdiode85','Hdiode106','Hdiode127',$
        'Vdiode0','Vdiode21','Vdiode42','Vdiode64','Vdiode85','Vdiode106','Vdiode127',$
        'rawsp1','rawsp2','HtxArmT','HrxArmT',$
        'VtxArmT','VrxArmT','HtxTipT','HrxTipT',$
        'ROBTemp','DSPBTemp','FVslTemp','Temp9','Temp10',$
        'FPltTemp','PSupTemp','N5VSupply', 'P5VSupply',$
        'CanInterPress','VertPartD','HorizPartD',$
        'HorizLaserD','VertLaserD','tas']

    B_Variables= ['none','Hdiode0','Hdiode21','Hdiode42','Hdiode64','Hdiode85','Hdiode106','Hdiode127',$
        'Vdiode0','Vdiode21','Vdiode42','Vdiode64','Vdiode85','Vdiode106','Vdiode127',$
        'rawsp1','rawsp2','HtxArmT','HrxArmT',$
        'VtxArmT','VrxArmT','HtxTipT','HrxTipT',$
        'ROBTemp','DSPBTemp','FVslTemp','Temp9','Temp10',$
        'FPltTemp','PSupTemp','N5VSupply', 'P5VSupply',$
        'CanInterPress','VertPartD','HorizPartD',$
        'HorizLaserD','VertLaserD','tas']

    C_Variables= ['none','Hdiode0','Hdiode21','Hdiode42','Hdiode64','Hdiode85','Hdiode106','Hdiode127',$
        'Vdiode0','Vdiode21','Vdiode42','Vdiode64','Vdiode85','Vdiode106','Vdiode127',$
        'rawsp1','rawsp2','HtxArmT','HrxArmT',$
        'VtxArmT','VrxArmT','HtxTipT','HrxTipT',$
        'ROBTemp','DSPBTemp','FVslTemp','Temp9','Temp10',$
        'FPltTemp','PSupTemp','N5VSupply', 'P5VSupply',$
        'CanInterPress','VertPartD','HorizPartD',$
        'HorizLaserD','VertLaserD','tas']
    tmsbutbase_a=widget_base(tmsbutbase,/column,/frame,ysize=180)
    ;do the first pannel for concentration trace 1 and trace 2
    label1=widget_label(tmsbutbase_a,value='Pannel 1: default: H.diode')
    tmsbutbase1=widget_base(tmsbutbase_a,/row)
    V11droplist=widget_droplist(tmsbutbase1,title='Trace1:',value=A_Variables,uvalue='V11list')
    tmsbutbase2=widget_base(tmsbutbase_a,/row)
    V12droplist=widget_droplist(tmsbutbase2,title='trace2:',value=A_Variables,uvalue='V12list')

    tmsbutbase3=widget_base(tmsbutbase_a,/row)
    V13droplist=widget_droplist(tmsbutbase3,title='Trace3:',value=A_Variables,uvalue='V13list')

    ;do the second panne2 for extinction trace 1 and trace 2
    tmsbutbase_b=widget_base(tmsbutbase,/column,/frame,ysize=180)
    label3=widget_label(tmsbutbase_b,value='Pannel 2: default: V.diode')
    tmsbutbase3=widget_base(tmsbutbase_b,/row)
    V21droplist=widget_droplist(tmsbutbase3,title='Trace1:',value=B_Variables,uvalue='V21list')

    tmsbutbase4=widget_base(tmsbutbase_b,/row)
    V22droplist=widget_droplist(tmsbutbase4,title='Trace2:',value=B_Variables,uvalue='V22list')
    tmsbutbase5=widget_base(tmsbutbase_b,/row)
    V23droplist=widget_droplist(tmsbutbase5,title='Trace3:',value=B_Variables,uvalue='V23list')

    ;do the second panne3 for mass trace 1 and trace 2
    tmsbutbase_c=widget_base(tmsbutbase,/column,/frame,ysize=180)
    label6=widget_label(tmsbutbase_c,value='Pannel 2: default: Tas.Press')
    tmsbutbase5=widget_base(tmsbutbase_c,/row)
    V31droplist=widget_droplist(tmsbutbase5,title='Trace1:',value=C_Variables,uvalue='V31list')
    tmsbutbase6=widget_base(tmsbutbase_c,/row)
    V32droplist=widget_droplist(tmsbutbase6,title='Trace2:',value=C_Variables,uvalue='V32list')
    tmsbutbase6=widget_base(tmsbutbase_c,/row)
    V33droplist=widget_droplist(tmsbutbase6,title='Trace3:',value=C_Variables,uvalue='V33list')

    widget_control, tlb,/realize
    MethodIDs={V11ID:V11droplist,$
        V12ID:V12droplist,$
        V13ID:V13droplist,$
        V21ID:V21droplist,$
        V22ID:V22droplist,$
        V23ID:V23droplist,$
        V31ID:V31droplist,$
        V32ID:V32droplist,$
        V33ID:V33droplist}
    configs={V11:'Hdiode0',V12:'Hdiode64',V13:'Hdiode127',$
        V21:'Vdiode0',V22:'Vdiode64',V23:'Vdiode127',$
        V31:'tas',V32:'CanInterPress',V33:'none'}
    Load_HKdata,ave_info,pHKdata
    npoints=n_elements((*PHKdata).time)
    z300=fltarr(npoints)  ;fltarr(300)
    tmsvalues={y1:z300,y2:z300,y3:z300,y4:z300,y5:z300,y6:z300,y7:z300,y8:z300,y9:z300} ;for ascii file.
    tmslabels={y1:'LHConc',y2:'LVConc',y3:'LHextn',Y4:'LVextn',y5:'LHLwc',y6:'LVLwc',y7:'abc',y8:'abc',y9:'acd'} ; for ascii file
    info={MethodIDs:MethodIDs,$
        A_variables:A_variables,$
        B_variables:B_variables,$
        C_variables:C_variables,$
        configs:configs,ave_info:ave_info,tmsdrawID:tmsdraw,$
        tmsvalues:tmsvalues,tmslabels:tmslabels,$
        pHKdata:pHkdata,$
        plot_ave_only:0 $
        }

    ;use a pointer to pass teh data
    ptr=ptr_new(info,/no_copy); no extra copy is made.

    ;widget_control,tlb,set_uvalue=info; ;because xmanager will always pass a
    ;top level structure data to teh evenet handeler, so it is assigned
    ;in here in a package info to be ready to pass it by xmanager.
    widget_control,/hourglass
    get_HKtms_trace1to9,ptr,xpts,all9yvals,all9MCPNstrings,all9ytitles
    draw_zoomed_HK9tms,ptr,xpts,all9yvals,all9MCPNstrings,all9ytitles

    widget_control,tlb,set_uvalue=ptr;  info;  this replace above ***=info
    xmanager,'a3vcpiview_HK_plots_alone',tlb,/just_reg
    ;*****************************************************
    return
end;   ;end of main program
;***********************************************************
pro a3vcpiview_HK_plots_alone_event,event

    widget_control,event.top,get_uvalue=ptr
    widget_control, event.id,get_uvalue=uval
    case uval of
        'Reset':begin ; reset the traces to be default traces.
        A_Variables= ['none','Hdiode0','Hdiode21','Hdiode42','Hdiode64','Hdiode85','Hdiode106','Hdiode127',$
            'Vdiode0','Vdiode21','Vdiode42','Vdiode64','Vdiode85','Vdiode106','Vdiode127',$
            'rawsp1','rawsp2','HtxArmT','HrxArmT',$
            'VtxArmT','VrxArmT','HtxTipT','HrxTipT',$
            'ROBTemp','DSPBTemp','FVslTemp','Temp9','Temp10',$
            'FPltTemp','PSupTemp','N5VSupply', 'P5VSupply',$
            'CanInterPress','VertPartD','HorizPartD',$
            'HorizLaserD','VertLaserD','tas']

        widget_control,(*ptr).MethodIDs.V11ID,set_value=A_Variables
        widget_control,(*ptr).MethodIDs.V12ID,set_value=A_Variables
        widget_control,(*ptr).MethodIDs.V13ID,set_value=A_Variables

        widget_control,(*ptr).MethodIDs.V21ID,set_value=A_Variables
        widget_control,(*ptr).MethodIDs.V22ID,set_value=A_Variables
        widget_control,(*ptr).MethodIDs.V23ID,set_value=A_Variables

        widget_control,(*ptr).MethodIDs.V31ID,set_value=A_Variables
        widget_control,(*ptr).MethodIDs.V32ID,set_value=A_Variables
        widget_control,(*ptr).MethodIDs.V33ID,set_value=A_Variables

        configs={V11:'Hdiode0',V12:'Hdiode64',V13:'Hdiode127',$
            V21:'Vdiode0',V22:'Vdiode64',V23:'Vdiode127',$
            V31:'TAS',V32:'CanInterPress',V33:'none'}
        (*ptr).configs=configs
    end
    'V11list': (*ptr).configs.V11=((*ptr).A_Variables)(event.index)
    'V12list': (*ptr).configs.V12=((*ptr).A_Variables)(event.index)
    'V13list': (*ptr).configs.V13=((*ptr).A_Variables)(event.index)

    'V21list': (*ptr).configs.V21=((*ptr).B_Variables)(event.index)
    'V22list': (*ptr).configs.V22=((*ptr).B_Variables)(event.index)
    'V23list': (*ptr).configs.V23=((*ptr).B_Variables)(event.index)

    'V31list': (*ptr).configs.V31=((*ptr).C_Variables)(event.index)
    'V32list': (*ptr).configs.V32=((*ptr).C_Variables)(event.index)
    'V33list': (*ptr).configs.V33=((*ptr).C_Variables)(event.index)
    'Redraw': begin
        widget_control,/hourglass
        get_hktms_trace1to9,ptr,xpts,all6yvals,all6MCPNstrings,all3ytitles
        draw_zoomed_HK9tms,ptr,xpts,all6yvals,all6MCPNstrings,all3ytitles
    end

    'starthh': (*ptr).ave_info.shh=event.value
    'startmm': (*ptr).ave_info.smm=event.value
    'startss': (*ptr).ave_info.sss=event.value
    'etarthh': (*ptr).ave_info.ehh=event.value
    'etartmm': (*ptr).ave_info.emm=event.value
    'etartss': (*ptr).ave_info.ess=event.value

    'plot_ave_only': begin
        (*ptr).plot_ave_only=event.value
        if event.value eq 1 then begin
            timeS=(*ptr).ave_info.starttime
            timeE=(*ptr).ave_info.endtime
            time=[timeS,TimeE]
            ave_info=(*ptr).ave_info
            starttime=(ave_info.shh*3600LL+ave_info.smm*60LL+ave_info.sss*1LL)*1000000000LL
            (*ptr).ave_info.startnanoseconds=starttime
            endtime=(ave_info.ehh*3600LL+ave_info.emm*60LL+ave_info.ess*1LL)*1000000000LL
            (*ptr).ave_info.endnanoseconds=endtime

        endif
    end
    'save_config':begin; save the config_set into an ascii file.
    outputfilename=!currentHPname+'Config_HouseKeeping_variable.ascii'
    ;outputfilename='C:\2dsview-ver32\Config_HouseKeeping_variable.ascii'
    openw,6,outputfilename
    printf,6,(*ptr).configs(0)
    close,6
end

'load_config':begin; load the config_file and assign it back into.
pathnm=strmid(!currentHpname,0,strlen(!currentHpname)-1)
in_configs_file=dialog_pickfile(filter='*HouseKeeping_variable*.ascii',path=pathnm)
if in_configs_file eq '' then return
openr,6,in_configs_file
input_string='abcdf'
readF,6,input_string;  ;input_string={ L1 H binc L1 V binc L1 ******
close,6
substring=strsplit(input_string,' ',/extract);substring(0)="{"; substring(1)="L1"
(*ptr).configs.V11=substring(1)
(*ptr).configs.V12=substring(2)
(*ptr).configs.V13=substring(3)

(*ptr).configs.V21=substring(4)
(*ptr).configs.V22=substring(5)
(*ptr).configs.V23=substring(6)

(*ptr).configs.V31=substring(7)
(*ptr).configs.V32=substring(8)
(*ptr).configs.V33=strmid(substring(9),0,strlen(substring(9))-1)
widget_control,(*ptr).MethodIDs.V11ID,set_value=substring(1)
widget_control,(*ptr).MethodIDs.V12ID,set_value=substring(2)
widget_control,(*ptr).MethodIDs.V13ID,set_value=substring(3)
widget_control,(*ptr).MethodIDs.V21ID,set_value=substring(4)
widget_control,(*ptr).MethodIDs.V22ID,set_value=substring(5)
widget_control,(*ptr).MethodIDs.V23ID,set_value=substring(6)
widget_control,(*ptr).MethodIDs.V31ID,set_value=substring(7)
widget_control,(*ptr).MethodIDs.V32ID,set_value=substring(8)
widget_control,(*ptr).MethodIDs.V33ID,set_value=strmid(substring(9),0,strlen(substring(9))-1)
end
'save_png':  save_hktms_png,ptr
'ToPrinter': send_hktms_png_to_printer,ptr
'save_ascii':write_hktms_ascii,ptr
'Help':  begin
    display_hktms_help_message
end
else:
endcase

widget_control,event.top,set_uvalue=ptr;  put the info back to xmanager
end;  ;end of event handler
;****************************************************

;****************************************************
pro get_HKtms_trace1to9,ptr,xxx,all9yvals,all9MCPNstrs,all9ytitles
    widget_control,/hourglass
    pHKdata=(*ptr).pHkdata
    xxx=(*pHKdata).time
    ;for pannel 1
    this_param  =(*ptr).configs.V11
    get_one_hktms_trace,pHkdata,this_param,y11,str11
    if this_param ne 'none' then ytitle_str1=this_param  else ytitle_str1=' '

    this_param  =(*ptr).configs.V12
    get_one_hktms_trace,pHKdata,this_param,y12,str12
    if this_param ne 'none' then ytitle_str1=ytitle_str1+' '+this_param

    this_param  =(*ptr).configs.V13
    get_one_hktms_trace,pHKdata,this_param,y13,str13
    if this_param ne 'none' then ytitle_str1=ytitle_str1+' '+this_param

    ;for pannel 2
    this_param  =(*ptr).configs.V21
    get_one_hktms_trace,pHKdata,this_param,y21,str21
    if this_param ne 'none' then ytitle_str2=this_param else ytitle_str2=' '
    this_param  =(*ptr).configs.V22
    get_one_hktms_trace,pHKdata,this_param,y22,str22
    if this_param ne 'none' then ytitle_str2=ytitle_str2+' '+this_param
    this_param  =(*ptr).configs.V23
    get_one_hktms_trace,pHKdata,this_param,y23,str23
    if this_param ne 'none' then ytitle_str2=ytitle_str2+' '+this_param
    ;for pannel 3
    this_param  =(*ptr).configs.V31
    get_one_hktms_trace,pHKdata,this_param,y31,str31
    if this_param ne 'none' then ytitle_str3=this_param else ytitle_str3=' '
    this_param  =(*ptr).configs.V32
    get_one_hktms_trace,pHKdata,this_param,y32,str32
    if this_param ne 'none' then ytitle_str3=ytitle_str3+' '+this_param
    this_param  =(*ptr).configs.V33
    get_one_hktms_trace,pHKdata,this_param,y33,str33
    if this_param ne 'none' then ytitle_str3=ytitle_str3+' '+this_param

    all9yvals   ={y1:y11, y2:y12, y3:y13, y4:y21, y5:y22, y6:y23,y7:y31,y8:y32,y9:y33}
    all9MCPNstrs={s1:str11,s2:str12,s3:str13,s4:str21,s5:str22,s6:str23,s7:str31,s8:str32,s9:str33}
    all9ytitles =[ytitle_str1,ytitle_str2,ytitle_str3]
    ;assign the values to the pointer to save it for saving to ascii file use at later.
    (*ptr).tmsvalues=all9yvals
    (*ptr).tmslabels=all9MCPNstrs

end; end of get_psd_trace1to8,ptr,xpts,y11,y12,y21,y22,y31,y32,y41,y42

;*****************************************************************************
pro Load_HKdata,ave_info,pHKdata
    widget_control,/hourglass
    ;read in the data file and assign the values.
    ; infile = strmid(!currentHPname,0,strlen(!currentHPname)-5) + $
    ;      'HK_TXT' +   strmid(!currentHFname,strpos(!currentHFname,"horiz")+5,12) + '.2DS'

    infile=dialog_pickfile(filter='HK_TXT*.2DSCPI',Get_Path=pathnm)

    !CurrentHFname=infile
    !CurrentHPname=pathnm
    ave_info.binfilename=infile

    ;get the time first.
    result=read_ascii(infile,data_start=5,count=nnn)
    openR,1,infile
    dummy='ab'
    readF,1,format='(A////)',dummy; read a line and then skip 4 lines.
    ;assign arrays for the readin parameters
    hh  =intarr(nnn)
    mm  =intarr(nnn)
    ss  =intarr(nnn)
    ms  =intarr(nnn)
    us  =intarr(nnn)
    ns  =intarr(nnn)
    time=Long64(nnn)
    Hdiode0 = fltarr(nnn);  voltage;  0 element
    Hdiode64 = fltarr(nnn);           64 element
    Hdiode127 = fltarr(nnn);           127 element
    Vdiode0 = fltarr(nnn);            0
    Vdiode64 = fltarr(nnn);           64
    Vdiode127 = fltarr(nnn);           127
    rawsp1 = fltarr(nnn);         RAW + supply
    rawsp2 = fltarr(nnn);         RAW - supply

    HtxArmT = fltarr(nnn);   Horizontal TX arm temperature
    HrxArmT = fltarr(nnn)
    VtxArmT = fltarr(nnn)
    VrxArmT = fltarr(nnn)

    HtxTipT = fltarr(nnn);   Horizontal TX Tip temperature
    HrxTipT = fltarr(nnn)
    ROBTemp = fltarr(nnn)
    DSPBTemp = fltarr(nnn)
    FVslTemp = fltarr(nnn); Forward Vessel Temp.
    Temp9    = fltarr(nnn)
    Temp10   = fltarr(nnn)
    FPltTemp = fltarr(nnn)
    PSupTemp = fltarr(nnn);  Power supply temp.
    N5VSupply   = fltarr(nnn)
    P5VSupply   = fltarr(nnn)
    CanInterPress = fltarr(nnn)
    Hdiode21            = fltarr(nnn);    element 21
    Hdiode42            = fltarr(nnn);    element 42
    Hdiode85            = fltarr(nnn)
    Hdiode106           = fltarr(nnn)
    Vdiode21            = fltarr(nnn);    element 21
    Vdiode42            = fltarr(nnn);    element 42
    Vdiode85            = fltarr(nnn)
    Vdiode106           = fltarr(nnn)
    VertPartD       = fltarr(nnn);,
    HorizPartD       = fltarr(nnn);,
    HorizLaserD     = fltarr(nnn);,
    VertLaserD      = fltarr(nnn);,
    Hdiode1 =fltarr(nnn)
    Hdiode2 =fltarr(nnn)
    Hdiode3 =fltarr(nnn)
    Hdiode4 =fltarr(nnn)
    Hdiode5 =fltarr(nnn)
    Hdiode6 =fltarr(nnn)
    tas =fltarr(nnn)
    for i=0L,long(nnn)-1L do begin
        ;read one line at a time.
        thisline='abcdefg'
        readF,1,format='(1A)',thisline;   ; the line conains following parameters.
        ;year,mmddhhmmss,roinumber,arrtime,ts,deadTime,length,width,areaA,perimP,$
        S = STRSPLIT(thisline, ' ', /EXTRACT)
        S = strjoin(S)
        S = strsplit(S,':',/extract)
        S=strjoin(S,',')
        S=strsplit(S,',',/extract)
        hh(i)=S(0)
        mm(i)=S(1)
        ss(i)=S(2)
        ms(i)=S(3)
        us(i)=S(4)
        ns(i)=S(5)
        Hdiode0(i)=S(6)*1.0;  voltage;  0 element
        Hdiode64(i)=S(7)*1.0;           64 element
        Hdiode127(i)=S(8)*1.0;           127 element
        Vdiode0(i)=S(9)*1.0;            0
        Vdiode64(i)=S(10)*1.0;           64
        Vdiode127(i)=S(11)*1.0;           127
        rawsp1(i)=S(12)*1.0;         RAW + supply
        rawsp2(i)=S(13)*1.0;         RAW - supply

        HtxArmT(i)=S(14)*1.0;   Horizontal TX arm temperature
        HrxArmT(i)=S(15)*1.0
        VtxArmT(i)=S(16)*1.0
        VrxArmT(i)=S(17)*1.0

        HtxTipT(i)=S(18)*1.0;   Horizontal TX Tip temperature
        HrxTipT(i)=S(19)*1.0
        ROBTemp(i)=S(20)*1.0
        DSPBTemp(i)=S(21)*1.0
        FVslTemp(i)=S(22)*1.0; Forward Vessel Temp.
        Temp9(i)   =S(23)*1.0
        Temp10(i)  =S(24)*1.0
        FPltTemp(i)=S(25)*1.0
        PSupTemp(i)=S(26)*1.0;  Power supply temp.
        N5VSupply(i)  =S(27)*1.0
        P5VSupply(i)  =S(28)*1.0
        CanInterPress(i)=S(29)*1.0
        Hdiode21 (i)          =S(30)*1.0;    element 21
        Hdiode42 (i)          =S(31)*1.0;    element 42
        Hdiode85 (i)          =S(32)*1.0
        Hdiode106(i)          =S(33)*1.0
        Vdiode21 (i)          =S(34)*1.0;    element 21
        Vdiode42 (i)          =S(35)*1.0;    element 42
        Vdiode85 (i)          =S(36)*1.0
        Vdiode106(i)          =S(37)*1.0
        VertPartD(i)      =S(38)*1.0/0.024414;,   Counts per seconds
        HorizPartD(i)      =S(39)*1.0/0.024414;, counts per seconds
        HorizLaserD(i)    =S(40)*1.0;,
        VertLaserD(i)     =S(41)*1.0;,
        TAS(i)            =S(42);  true air speed.
    endfor
    close,1
    ;select the only the part of data from the start-time and end-time of the zoomed periods.
    time=(hh*3600LL+mm*60LL+ss*1LL)*1000000000LL+ms*1000000LL+us*1000LL+ns*1LL
    start_seconds=time(0); ave_info.startnanoseconds/1000000000.0
    end_seconds  =time(n_elements(time)-1); ave_info.endnanoseconds/1000000000.0
    ave_info.startTime=start_seconds
    ave_info.endTime  =end_seconds

    index=where(time ge start_seconds and time le end_seconds,contG)
    indexGT= where(time ge start_seconds,contG1)

    if contG eq 0 and contG1 eq 0 then begin
        rr=dialog_message([['There is no house keeping data after the zoomed'],$
            ['time period. Only show the last HK point.']],/information)
        index=[nnn-2,nnn-2]
    endif

    if contG eq 0 and contG1 ge 1 then begin
        rr=dialog_message([['There is only one point of keeping data for the zoomed'],$
            ['time period. Show the latter Point, ']],/information)
        index=[indexGT(0),indexGT(0)]
    endif
    index=indgen(n_elements(time))
    time=time(index)
    Hdiode0=Hdiode0(index)
    Hdiode21=Hdiode21(index)
    Hdiode42=Hdiode42(index)
    Hdiode64=Hdiode64(index)
    Hdiode85=Hdiode85(index)
    Hdiode106=Hdiode106(index)
    Hdiode127=Hdiode127(index)

    Vdiode0= Vdiode0(index)
    Vdiode21= Vdiode21(index)
    Vdiode42= Vdiode42(index)
    Vdiode64= Vdiode64(index)
    Vdiode85= Vdiode85(index)
    Vdiode106= Vdiode106(index)
    Vdiode127= Vdiode127(index)
    rawsp1=rawsp1(index);         RAW + supply
    rawsp2=rawsp2(index);         RAW - supply

    HtxArmT=HtxArmT(index);   Horizontal TX arm temperature
    HrxArmT=HrxArmT(index)
    VtxArmT=VtxArmT(index)
    VrxArmT=VrxArmT(index)

    HtxTipT=HtxTipT(index);   Horizontal TX Tip temperature
    HrxTipT=HrxTipT(index)
    ROBTemp=ROBTemp(index)
    DSPBTemp=DSPBTemp(index)
    FVslTemp=FVslTemp(index); Forward Vessel Temp.
    Temp9   = Temp9(index)
    Temp10  = Temp10(index)
    FPltTemp= FPltTemp(index)
    PSupTemp= PSupTemp(index);  Power supply temp.
    N5VSupply  = N5VSupply(index)
    P5VSupply  = P5VSupply(index)
    CanInterPress= CanInterPress(index)
    VertPartD      =VertPartD(index);,
    HorizPartD     =HorizPartD(index);,
    HorizLaserD    =HorizLaserD(index);,
    VertLaserD     =VertLaserD(index);,
    tas=tas(index)
    HKdata={time:time,Hdiode0:Hdiode0,Hdiode21:Hdiode21,Hdiode42:Hdiode42,Hdiode64:Hdiode64,Hdiode85:Hdiode85,Hdiode106:Hdiode106,Hdiode127:Hdiode127,$
        Vdiode0:Vdiode0,Vdiode21:Vdiode21,Vdiode42:Vdiode42,Vdiode64:Vdiode64,Vdiode85:Vdiode85,Vdiode106:Vdiode106,Vdiode127:Vdiode127,$
        rawsp1:rawsp1,$
        rawsp2:rawsp2,$
        HtxArmT:HtxArmT,$;   Horizontal TX arm temperature
        HrxArmT:HrxArmT,$
        VtxArmT:VtxArmT,$
        VrxArmT:VrxArmT,$
        HtxTipT:HtxTipT,$;   Horizontal TX Tip temperature
        HrxTipT:HrxTipT,$
        ROBTemp:ROBTemp,$
        DSPBTemp:DSPBTemp,$
        FVslTemp:FVslTemp,$; Forward Vessel Temp.
        Temp9   : Temp9,$
        Temp10  : Temp10,$
        FPltTemp: FPltTemp,$
        PSupTemp: PSupTemp,$;  Power supply temp.
        N5VSupply  : N5VSupply,$
        P5VSupply  : P5VSupply,$
        CanInterPress: CanInterPress,$
        VertPartD      :VertPartD,$
        HorizPartD     :HorizPartD,$
        HorizLaserD    :HorizLaserD,$
        VertLaserD     :VertLaserD,$
        tas:tas}
    pHKdata=ptr_new(HKdata)
end; ;end of load_HKdata,pHKdata
;*****************************************************************************************

pro get_one_hktms_trace,pHKdata,this_param,ypts,strout
    if this_param eq 'none' then begin
        mystring='ypts=(*pHKdata).'+'Hdiode0'
        dummy=execute(mystring)
        ypts=ypts*0.0
        strout='none'
    endif else begin
        mystring='ypts=(*pHKdata).'+this_param;   this_param can be string Hdiode1,Hdiode2,tas, etc.
        dummy=execute(mystring)

        if (strmatch(this_param,'Hdiode*',/fold_case) or strmatch(this_param,'Vdiode*',/fold_case) or $
            strmatch(this_param,'*Supply*',/fold_case) ) then strout=This_param+'(V)'

        if strmatch(this_param,'tas',/fold_case) then strout=this_param+'(m/s)'

        if strmatch(this_param,'rawsp*',/fold_case) then strout=this_param+'(mw)'
        if strmatch(this_param,'CanInterPress',/fold_case) then strout=this_param+'(mB)'

        if (strmatch(this_param,'*ArmT',/fold_case) or strmatch(this_param,'*Temp*',/fold_case) or $
            strmatch(this_param,'*TipT*',/fold_case)  ) then strout=this_param+'(Deg)'

        if (strmatch(this_param,'*PartD',/fold_case) or $
            strmatch(this_param,'*LaserD',/fold_case)) then strout=this_param+'(V)'
    endelse
end; ;end of get_one_hktms_trace
;*****************************************************************************************
;********************************************
pro  Draw_zoomed_HK9tms,ptr,xpts,all9yvals,all9MCPNstrs,all3ytitles
    y11=all9yvals.y1
    y12=all9yvals.y2
    y13=all9yvals.y3
    y21=all9yvals.y4
    y22=all9yvals.y5
    y23=all9yvals.y6
    y31=all9yvals.y7
    y32=all9yvals.y8
    y33=all9yvals.y9
    s11=all9MCPNstrs.s1
    s12=all9MCPNstrs.s2
    s13=all9MCPNstrs.s3
    s21=all9MCPNstrs.s4
    s22=all9MCPNstrs.s5
    s23=all9MCPNstrs.s6
    s31=all9MCPNstrs.s7
    s32=all9MCPNstrs.s8
    s33=all9MCPNstrs.s9

    Widget_Control, (*ptr).tmsdrawid, Get_Value=wid  ; get the window ID for drawing.

    ave_info=(*ptr).ave_info

    forward_function  SPEC_Nano2HMS_struct, strrepl,SPEC_Nano2HMS

    ;delta_s =(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000000.0
    delta_s=(xpts(n_elements(xpts)-2)-xpts(0))/1000000000.0
    if delta_s lt 10000.0 then  $
        delta_s ='HK:  dT='+string(delta_s,format='(F6.1)')+'s'  $
        else delta_s ='HK:  dT='+string(delta_s,format='(I6)')+'s' 

    !ZOOM_START_STRING = SPEC_Nano2HMS(ave_info.StartNanoSeconds)
    !ZOOM_END_STRING =   SPEC_Nano2HMS(ave_info.EndNanoSeconds)
    plot_string = !ZOOM_START_STRING +"-" + !ZOOM_END_STRING

    ave_info.plot_string=plot_string

    message_string ="HKzoomed:"+ !ZOOM_START_STRING + " to " + !ZOOM_END_STRING

    Widget_Control, (*ptr).tmsdrawID, TLB_SET_TITLE = message_string

    ;get the time axis lables from the ave_info
    ;******************************************************
    thisCharsize = Str_Size('A Sample String', 0.25)

    if (*ptr).plot_ave_only eq 0 then begin
        fullrange =xpts(n_elements(xpts)-2) -xpts(0);  0ULL
        binwidth = 0ULL
        fullrange =fullrange; delta_s; ave_info.endNanoseconds - ave_info.startNanoseconds
        binwidth = fullrange/8
        curbin = xpts(0);  ave_info.startNanoseconds
        tnames = StrArr(9)
        FOR i=0,8 DO BEGIN
            tnames(i) =  strtrim(strmid(SPEC_Nano2HMS(curbin),0,8),2)
            curbin += binwidth
        ENDFOR
        xrange=[xpts(0),xpts(n_elements(xpts)-2)]
    endif else begin
        fullrange =ave_info.endNanoseconds - ave_info.startNanoseconds
        binwidth = fullrange/8
        curbin =  ave_info.startNanoseconds
        tnames = StrArr(9)
        FOR i=0,8 DO BEGIN
            tnames(i) =  strtrim(strmid(SPEC_Nano2HMS(curbin),0,8),2)
            curbin += binwidth
        ENDFOR
        xrange=[ave_info.startnanoseconds, ave_info.endnanoseconds]
    endelse

    ;find the range of ave_info.starttime and end time.
    ;***********************************************************

    indexj=where(xpts ge ave_info.startnanoseconds,conta)
    if conta ne 0 then start_index=indexj(0) else start_index=n_elements(xpts)-1
    indexj=where(xpts ge ave_info.endnanoseconds,conta)
    if conta ne 0 then end_index=indexj(0) else end_index=n_elements(xpts)-1
    xave=[xpts(start_index),xpts(start_index),xpts(end_index),xpts(end_index)]
    ;*********************************************************************

    ;-------------------------------
    ;Set up X axis tick labels.
    ;-------------------------------
    !X.TICKNAME = tnames
    !X.TICKS = 8
    ;********************************************************

    WSet, wid
    bluecolor =GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    blackcolor=getColor("Black",!D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)
    greencolor =GetColor("Green", !D.Table_Size-2)

    erase,color='ffffff'x  ; get background to white

    XYOUTS,240,290,"REDRAWING ",color=bluecolor, size=4 , /device
    FOR i=0,5 DO BEGIN  ; seems to be needed to get the "REDRAW" to fully appear
        PRINT, " "
    ENDFOR

    !P.MULTI = [0, 1,3, 0, 0]
    !X.OMARGIN = [1.5,0.0]  ;We need this because the Area plot X axis label extends off the left edge of the window

    ;-------------------------------------------------------------------
    ; Determine which particles we're plotting, H or V
    ;-------------------------------------------------------------------

    xlog_setting = 1;ave_info.AveXLog
    ylog_setting = 0; ave_info.AveYLog

    subfile_str=strsplit(!currentHFname,'\',/extract)
    binfilename=strtrim(subfile_str(n_elements(subfile_str)-1),2)+'   '+delta_s

    ;now get the axis maximum minimums for the plots

    ymin = min([y11,y12,y13])
    ymax = max([y11,y12,y13])
    Yrange_AB=1.05*[ymin,ymax]
    ;xpts=indgen(n_elements(xpts))
    ; stop

    PLOT, xpts,y11, COLOR=bluecolor,$
        YTITLE=all3ytitles(0), Xrange = xrange, YLOG=Ylog_setting,background= whitecolor,$
        TITLE=binfilename+'   '+plot_string,THICK=1, YRANGE=Yrange_AB, charsize=1.8, $
        pos=[0.08,0.72,0.96,0.97],xmargin=[3,1],YSTYLE=1,xstyle=1
    ; xtitle='time  ( blue='+s11+' red='+s12 +' )'
    oplot,xpts,y12,color=redcolor
    oplot,xpts,y13,color=blackcolor
    if (*ptr).plot_ave_only eq 0 then begin
        oplot,xave,[ymin,ymax,ymax,ymin],color=greencolor
    endif
    xyouts,160,377,'time (1:blue='+s11,color=bluecolor,/device
    xyouts,' 2:red='+s12,color=redcolor,/device
    xyouts,' 3:Black='+s13,color=blackcolor,/device
    xyouts,')',color=bluecolor,/device

    ;end of plot 1 of 4 *******************************************************************************

    ymin = min([y21,y22,y23])
    ymax = max([y21,y22,y23])
    Yrange_AB=1.05*[ymin,ymax]

    PLOT,xpts, y21, COLOR=bluecolor,Xrange= xrange, YLOG=ylog_setting,background= whitecolor,$
        THICK=1, YRANGE=1.05*[ymin,ymax],ystyle=1,charsize=1.8,xstyle=1,$
        pos=[0.08,0.41,0.96,0.66],xmargin=[3,1],$
        YTITLE=all3ytitles(1); xtitle='time  ( blue='+s21+' red='+s22 +' )'
    oplot,xpts,y22,COLOR=redColor
    oplot,xpts,y23,color=blackcolor
    if (*ptr).plot_ave_only eq 0 then begin
        oplot,xave,[ymin,ymax,ymax,ymin],color=greencolor
    endif
    xyouts,160,200,'time (1:blue='+s21,color=bluecolor,/device
    xyouts,'  2:red='+s22,color=redcolor,/device
    xyouts,'  3:Black='+s23,color=blackcolor,/device
    xyouts,')',color=bluecolor,/device

    ;end of plot 2 of 4 *******************************************************************************

    ymin = min([y31,y32,y33])
    ymax = max([y31,y32,y33])
    Yrange_AB=1.05*[ymin,ymax]

    PLOT, xpts,y31, COLOR=bluecolor, $
        YTITLE=all3ytitles(2), Xrange = xrange, YLOG=Ylog_setting,background= whitecolor,$
        TITLE=' ', THICK=1, YRANGE=Yrange_AB, charsize=1.80, xstyle=1, $
        pos=[0.08,0.09,0.96,0.34],xmargin=[3,1],YSTYLE=1; xtitle='time( blue='+s31+'red='+s32+')'
    oplot,xpts,y32,color=redColor
    oplot,xpts,y33,color=blackcolor
    if (*ptr).plot_ave_only eq 0 then begin
        oplot,xave,[ymin,ymax,ymax,ymin],color=greencolor
    endif
    xyouts,160,20,'time (1:blue='+s31,color=bluecolor,/device
    xyouts,'  2:red='+s32,color=redcolor,/device
    xyouts,'  3:Black='+s33,color=blackcolor,/device
    xyouts,')',color=bluecolor,/device

    ;end of plot 3 of 3 *******************************************************************
end;  end of Draw-averaged_6tms
;***************************************************************************************

;***************************************************************************************
pro write_HKtms_ascii,ptr

    ;get the output file name.
    ave_info=(*ptr).ave_info
    plot_string=strjoin(strsplit(ave_info.plot_string,':',/extract)); take away':' from the string.
    junk=findfile(!currentHPname+'ascii\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "ascii\"
    outputfilename=!currentHPname+'ascii\HK_TMS_'+plot_string+'.txt'
    ;open file to write
    openw, 77,outputfilename
    printf,77,'2DS_House_Keeping times series plot file generated at ',systime()
    printf,77,ave_info.binfilename;  ;input_filename
    printf,77,'Time period is :',ave_info.plot_string
    printf,77,'The 9 traces are in the following  order:'
    printf,77,format='(A8,1x,9(A13,1x))','hh:mm:ss ',(*ptr).tmslabels
    pHKdata=(*ptr).phkdata
    time=(*pHKdata).time

    y1=(*ptr).tmsvalues.y1
    y2=(*ptr).tmsvalues.y2
    y3=(*ptr).tmsvalues.y3
    y4=(*ptr).tmsvalues.y4
    y5=(*ptr).tmsvalues.y5
    y6=(*ptr).tmsvalues.y6
    y7=(*ptr).tmsvalues.y7
    y8=(*ptr).tmsvalues.y8
    y9=(*ptr).tmsvalues.y9
    nnn=n_elements(y9)
    for i=0,nnn-1 do begin
        thistime=strtrim(strmid(SPEC_Nano2HMS(round(time(i))*100000000LL),0,8),2)
        printf,77,format='(A8,1x,8(E13.4,1x),E13.4)',thistime,y1(i),y2(i),y3(i),y4(i),y5(i),y6(i),y7(i),y8(i),y9(i)
    endfor
    close,77

end; ;end of write_compare_tms_ascii,ptr
;***********************************************************************
pro display_hktms_help_message
    tms_help_message=[['0: The time period has been divided into 300 bins.'],$
        ['                                                  '],$
        ['1. Save config is to save current button setups.'],$
        ['                                                '],$
        ['2. Load config is to load last saved button setups.'],$
        ['   After loading, the droplist has only 1 option,'],$
        ['   click reset and you will have more options again.'],$
        ['                                                '],$
        ['3. Save png is to save the plot as a png file.'],$
        ['                                                '],$
        ['4. Save ascii is to save the plot as an ascii file.'],$
        ['                                                '],$
        ['5. Update is to update the plot of the current setup.'],$
        ['                                                '],$
        ['6. Reset is to set the buttons to the default options.'],$
        ['                                                '],$
        ['7. The parameters are: '],$
        ['   Hdiode1,Hdiode2,Hdiode3,Hdiode4,Hdiode5,Hdiode6,Hdiode7 for horizontal diode array voltage '],$
        ['                       1,64,127 **** are the elements numbers    '],$
        ['   Vdiode1,Vdiode2,Vdiode3,Vdiode4,Vdiode5,Vdiode6,Vdiode7 for Vertical diode array voltage '],$
        ['                       1,64,127 **** are the elements numbers  '],$
        ['   Htx.armT,Hrx.armT,Htx.tipT,Hrx.tipT are Horizontal arm, tip,'],$
        ['                     transmitting, receiving side temperature '],$
        ['   Vtx.armT,Vrx.armT,Vtx.tipT,Vrx.tipT are Vertical arm, tip,'],$
        ['                     transmitting, receiving side temperature '],$
        ['   Tas is true air speed'],$
        ['   Pressure is the 2DS can internal Pressure'],$
        ['                                                '],$
        ['8. To quit looking at HK data, click the kill button on the upper-right-corner'],$
        ['                                                '],$
        ['9. This window is for Looking at the House Keeping data']]
    rrr=dialog_message(tms_help_message,/information)
end
;****************************************************************************
pro save_hktms_png,ptr
    Widget_Control, (*ptr).tmsdrawid, Get_Value=wid  ; get the window ID for drawing.
    ave_info=(*ptr).ave_info
    ;get the output file name.
    plot_string=strjoin(strsplit(ave_info.plot_string,':',/extract)); take away':' from the string.
    junk=findfile(!currentHPname+'png\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "png\"
    outputfilename=!currentHPname+'png\HK_TMS_'+plot_string+'.png'
    wset,wid
    write_png,outputfilename,tvrd(true=1)
end; end of save_tms_png, ptr
;**************************************************************
;************************************************************
pro send_hktms_png_to_printer,ptr
    Widget_Control, (*ptr).tmsdrawid, Get_Value=wid  ; get the window ID for drawing.
    wset,wid
    printwindow,wid,/landscape
end; end of send_tms_png_to_printer
;**************************************************************
;*****************************************************
function SPEC_Nano2HMS, ns
    ; accepts ULL values of nanoseconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    orig_ns = ns

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    hours=ns/NanosecondsPerHour
    if hours GT 0 then  ns = ns - (hours * NanosecondsPerHour)
    minutes=ns/NanosecondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * NanosecondsPerMinute)
    seconds=ns/NanosecondsPerSecond
    if seconds GT 0 then  ns = ns - (seconds * NanosecondsPerSecond)
    milli=ns/NanosecondsPerMilli
    if milli GT 0 then  ns = ns - (milli * NanosecondsPerMilli)
    micro=ns/NanosecondsPerMicro
    if micro GT 0 then  ns = ns - (micro * NanosecondsPerMicro)
    a = string(format = '(%"%2.2d:%2.2d:%2.2d.%3.3d.%3.3d.%3.3d")',hours,minutes,seconds,milli,micro,ns)

    ns = orig_ns

    return,a


end
;*****************************************************
;*****************************************************
function  SPEC_Nano2HMS_struct, ns, time_struct
    ; accepts ULL values of nanoseconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    ts  = { _time_struct, $
        Hours: 0, $
        Minutes: 0, $
        Seconds: 0, $
        Milliseconds: 0, $
        Microseconds: 0, $
        Nanoseconds: 0 }

    time_struct = ({_time_struct})

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    hours=ns/NanosecondsPerHour
    if hours GT 0 then  ns = ns - (hours * NanosecondsPerHour)
    minutes=ns/NanosecondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * NanosecondsPerMinute)
    seconds=ns/NanosecondsPerSecond
    if seconds GT 0 then  ns = ns - (seconds * NanosecondsPerSecond)
    milli=ns/NanosecondsPerMilli
    if milli GT 0 then  ns = ns - (milli * NanosecondsPerMilli)
    micro=ns/NanosecondsPerMicro
    if micro GT 0 then  ns = ns - (micro * NanosecondsPerMicro)

    time_struct.Hours = hours
    time_struct.Minutes = minutes
    time_struct.Seconds = seconds
    time_struct.Milliseconds = milli
    time_struct.Microseconds = micro
    time_struct.Nanoseconds = ns

    a = string(format = '(%"%2.2d:%2.2d:%2.2d.%3.3d.%3.3d.%3.3d")',hours,minutes,seconds,milli,micro,ns)

    return,a

end
;*****************************************************
