PRO MVParticleStrip, info  ; this is for Hparticles
    forward_function Fill_MM_strip

    stripID = 0L
    zoomID  = 0L
    stripBase = 0L
    stripLabel = 0L

    localstate=info.localstate
    lastimg_foffset=info.lastimg_foffset
    firstimg_foffset=info.firstimg_foffset

    strip_info = {stripID:stripID, $               ; widget ID for the strip of bitmaps
        zoomID:zoomID, $
        stripBase:stripBase, $
        stripLabel:stripLabel, $
        FR_button:0L, $
        SSR_button:0L, $
        SSF_button:0L, $
        FF_button:0L, $
        localstate:localstate,$
        lastimg_foffset:lastimg_foffset,$
        firstimg_foffset:firstimg_foffset,$
        time1:0LL,$
        time2:0LL,$
        eventx1:0,$
        eventx2:0 $
        }
    base = WIDGET_BASE(/COLUMN)
    strip_info.stripBase = base
    info.stripBase = base
    particles = Widget_Draw(base,XSize=!STRIP_WIDTH, YSize=128, Event_Pro='SPEC_StripMMV_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    strip_info.stripID = Particles

    info.stripID = Particles

    STRIP_Toolbar = WIDGET_BASE(base, $
        COLUMN=8, $
        FRAME=1, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=256)


    STRIP_dual_label = WIDGET_BASE(STRIP_Toolbar, $
        ROW=1, $
        ; FRAME=1, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=240);;changer from 180 to 240; for showing L7, L8 , L5, PC1 etc.


    ; Generate a label on the bitmap widget that will display the parameters for a single particle

    LABEL_Info = WIDGET_TEXT(STRIP_dual_label, $
        VALUE="", $
        XSIZE = 40, $
        YSIZE=30)
    strip_info.stripLabel = LABEL_Info

    ;mo added this
    strip_toolbar2=widget_base(strip_toolbar,/col)
    strip_toolbar3=widget_base(strip_toolbar2,/row)
    BUTTON_FastBackward = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='FastRewind', $
        XSIZE=40, $
        TOOLTIP="Play Backwards", $
        VALUE=  'RR.bmp', /BITMAP, $
        Event_Pro='VMMplay_reverse_timer_event')



    BUTTON_Rewind = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='Rewind', $
        XSIZE=35, $
        TOOLTIP="Single Step Reverse", $
        VALUE=  'SingleR.bmp', /BITMAP, $
        Event_Pro='VMMParticleStrip_Toolbar_Rewind')

    BUTTON_Forward = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='Forward', $
        XSIZE=35, $
        TOOLTIP="Single Step Forward", $
        ;PUSHBUTTON_EVENTS=1, $
        VALUE= 'SingleF.bmp', /BITMAP, $
        Event_Pro='VMMParticleStrip_Toolbar_Forward')


    BUTTON_FastForward = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='FastForward', $
        XSIZE=40, $
        TOOLTIP="Play Forwards", $
        VALUE=  'FF.bmp', /BITMAP, $
        Event_Pro='VMMplay_forward_timer_event')


    spaceholder1 = WIDGET_LABEL(STRIP_Toolbar3, $
        VALUE= " Speed (in Secs)", $
        XSIZE=110, $
        YSIZE=35)

    dd_list=['0.10','0.25','0.50','1.0']
    STRIP_Dropdown = WIDGET_DROPLIST(STRIP_Toolbar3, $
        FRAME=1, $
        VALUE = dd_list, $
        Event_Pro = 'VMMBitmap_Playback_Speed_event')

    cleaningbutton= WIDGET_button(STRIP_Toolbar2, $
        FRAME=1, $
        VALUE = 'Cleaning by start--End Clicks', $
        Event_Pro ='Cleaning_button_event')

    strip_toolbar4=widget_base(strip_toolbar2,/row)
    label = widget_label(strip_toolbar4,value = 'Label_one_image_as_bad_with_one_click:')
    b341 = widget_base(strip_toolbar4,/exclusive,/row)
    offbutton = widget_button(b341,value='Off',Event_pro='One_click_Cleaning_button_off_event')
    onbutton = widget_button(b341,value='On',Event_pro='One_click_Cleaning_button_on_event')
    if !clean_status eq 3 then begin
        widget_control,onbutton, set_button=1
    endif else widget_control,offbutton, set_button=1

    ;add this for forcing a particle to be accepted again
    ;*****************************************************************************************
    ; strip_toolbar5=widget_base(strip_toolbar2,/row)
    ; label = widget_label(strip_toolbar5,value = 'Force_one_image_as_good_with_one_click:')
    ; b349 = widget_base(strip_toolbar5,/exclusive,/row)
    ; offbutton = widget_button(b349,value='Off',Event_pro='One_click_Force_as_good_button_off_event')
    ; onbutton = widget_button(b349,value='On',Event_pro='One_click_Force_as_good_button_on_event')
    ; if !clean_status eq 4 then begin  ; remember this for forcing a particle be accepted again.
    ; widget_control,onbutton, set_button=1
    ; endif else widget_control,offbutton, set_button=1
    ;*****************************************************************************************


    ; save so we can disble buttons during FF and Fast reverse
    strip_info.FR_button = BUTTON_FastBackward
    strip_info.SSR_button = BUTTON_Rewind
    strip_info.SSF_button = BUTTON_Forward
    strip_info.FF_button = BUTTON_FastForward

    Zoomer_base = WIDGET_BASE(STRIP_Toolbar, $
        MAP=1, $
        UVALUE='BASE_Zoomer', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=!zoom_ysize, $
        XSIZE=!zoom_xsize)

    strip_info.zoomID = Widget_Draw(Zoomer_base,XSize = !zoom_xsize, YSize = !zoom_ysize, Event_Pro='SPEC_StripMMV_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    ;  strip_info.zoomID = Widget_Draw(Zoomer_base,XSize=128, YSize=128, Event_Pro='SPEC_StripH_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    direction=1
    foffset=-1;  -1 means the first time filling in the strip
    foffset=Fill_MM_strip(foffset, localstate, strip_info, direction,localstate.HorV)
    wdelete,!D.window


    Widget_Control, base, Set_UValue=strip_info, /No_Copy
    WIDGET_CONTROL, base, /REALIZE

    XMANAGER, 'MVParticleStrip', base, /JUST_REG

END ; end of zoomHparticlestrip,info
;*********************************************************************
PRO SPEC_StripMMV_event, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,avestripdata,avestripdataV,Mstripdata
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure

    if(event.PRESS GE 1) then  begin
        if event.ID EQ strip_info.zoomID then print, "zoom window clicked"
    end
    ;********************************************************************************
    ; add following to remove noisy particles  by removing one particle at a time.
    if event.Press GE 1 and event.ID eq strip_info.stripID and !clean_status eq 3 then begin
        localstate=strip_info.localstate
        HorV=localstate.HorV;   ;when press down event.type=0; up is 1, motion=0, scroll=3.

        if (event.x GE 0 and event.X LE (!STRIP_WIDTH - 1)) then begin
            timenanoseconds = MStripData(event.X).Nanoseconds
            if HorV eq 'H' then begin
                index=where((*alldataH).nanoseconds eq timenanoseconds)
                if index(0) ne -1 then begin
                    if (*alldataH)(index(0)).reject eq 0 then begin
                        (*alldataH)(index(0)).reject=1
                        reject=1
                    endif  else begin
                        (*alldataH)(index(0)).reject=0
                        reject=0
                    endelse
                    this_index=index(0)
                    ADD_THIS_CLICK_TO_CLICK_action_list_file,this_index,HorV, reject
                endif
            endif

            if HorV eq 'V' then begin
                index=where((*alldataV).nanoseconds eq timenanoseconds)
                if index(0) ne -1 then begin
                    if (*alldataV)(index(0)).reject eq 0 then begin
                        (*alldataV)(index(0)).reject=1
                        reject=1
                    endif else begin
                        (*alldataV)(index(0)).reject=0
                        Reject=0
                    endelse
                    this_index=index(0)
                    ADD_THIS_CLICK_TO_CLICK_action_list_file,this_index,HorV,reject
                endif
            endif
            if index(0) ne -1 then begin; if particles is reject, paint it yellow.
                ;search until the start and end of this image.
                xx1=event.X >0
                while (MStripdata(xx1).Nanoseconds eq MStripdata(event.X).nanoseconds and xx1 gt 0) do begin
                    xx1=xx1-1
                endwhile
                xx2=event.X <998
                while (MStripdata(xx2).Nanoseconds eq MStripdata(event.X).nanoseconds and xx2 lt 998) do begin
                    xx2=xx2+1 <998
                endwhile
                Widget_Control, strip_info.stripID, Get_Value=wid
                WSet, wid
                mylength=xx2-xx1
                myclip = TVRD(xx1,0,mylength,128)
                flig_myclips_color,myclip,mylength,dimension
                if dimension eq 3 then tv,myclip,xx1,0,true=1
                if dimension eq 2 then tv,myclip,xx1,0
            endif; if index(0) ne -1

        endif;endif of if (event.x GE 0 and event.X LE (!STRIP_WIDTH - 1)) then begin
    endif; end if of lable bad one particle a time
    ;********************************************************************************
    ;  add this to remove several particles at a time by drawing a rubber band or two clicks .
    if event.type eq 0 and event.ID eq strip_info.stripID and !clean_status ne 0 then begin;button is pressed down
        localstate=strip_info.localstate
        if !clean_status eq 1 then begin
            if event.type eq 0 and event.ID eq strip_info.stripID then begin
                strip_info.time2= MStripData(event.X).Nanoseconds
                strip_info.eventx2=event.X
                !clean_status =0
                ;find all of the unique time between time1 and time2 in the data
                if localstate.HorV eq 'H' then begin
                    index=where((*alldataH).nanoseconds ge strip_info.time1 and (*alldataH).nanoseconds le strip_info.time2 $
                        and (*alldataH).reject eq 0 and (*alldataH).PC1 eq localstate.pixel, contGG)
                    if contGG gt 0 then (*alldataH)(index).reject=1
                    ADD_ALL_INDEXS_TO_ACTIONLIST,INDEX,LOCALSTate.HorV
                endif; end if localstate.HorV eq 'H'

                if localstate.HorV eq 'V' then begin
                    index=where((*alldataV).nanoseconds ge strip_info.time1 and (*alldataV).nanoseconds le strip_info.time2 $
                        and (*alldataV).reject eq 0 and (*alldataV).PC1 eq localstate.pixel, contGG)
                    if contGG gt 0 then (*alldataV)(index).reject=1
                    ADD_ALL_INDEXS_TO_ACTIONLIST,INDEX,LOCALSTATE.HorV
                endif; end if localstate.HorV eq 'V'

                if (contGG gt 0) then begin
                    Widget_Control, strip_info.stripID, Get_Value=wid
                    WSet, wid
                    mylength=fix(abs(strip_info.eventX2-strip_info.eventX1))
                    myclip = TVRD(strip_info.eventx1,0,mylength,128)
                    yellowblock=bytarr(3,mylength,128)
                    yellowblock(0,*,*)=255
                    yellowblock(1,*,*)=myclip
                    tv,yellowblock,strip_info.eventX1,0,true=1
                endif

            endif; end if venet.type eq 0
        endif; end of if !clean_status eq 1

        if !clean_status eq 2 then begin
            strip_info.time1= MStripData(event.X).Nanoseconds
            strip_info.eventx1=event.X;                                           wait for until it is up.
            print,'time1=',strip_info.time1;   this is teh first particle's time.
            !clean_status=1
        endif

    endif
    ;**********************************************************************************

    if event.ID EQ strip_info.stripID then begin
        if (event.x GE 0 and event.X LE (!STRIP_WIDTH - 1)) then begin

            timestamp = SPEC_Nano2HMS(MStripData(event.X).Nanoseconds)
            ;length = string(format = '(%"Length/L1(um) = %d")',aveStripData(event.X).ImageWords * 10)
            length = string(format = '(%"Length/L1n(um) = %d")',MStripData(event.X).L1n * 10)
            height = string(format = '(%"Height/L2(um) = %d")',MStripData(event.X).L2 * 10)
            area   = string(format = '(%"Area(sq.um) = %6.1d")',MStripData(event.X).Area * 100)
            F1     = string(format = '(%"F1 = %1.1d")',MStripData(event.X).F1)
            PC1    = string(format = '(%"PC1 = %3.1d")',MStripData(event.X).PC1)
            L3    = string(format = '(%"L3 = %9.3f")',1.8*MStripData(event.X).L3)
            L4    = string(format = '(%"L4 = %3.1d")',MStripData(event.X).L4)
            L5    = string(format = '(%"L5 = %3.1d")',Mstripdata(event.X).L5)
            L7    = string(format = '(%"L7 = %8.2f")',MStripData(event.X).L7)
            L8    = string(format = '(%"L8 = %8.2f")',Mstripdata(event.X).L8)
            PC3   = string(format = '(%"PC3 (x,y) = %9.3f,%9.3f")',Mstripdata(event.X).PC3x,Mstripdata(event.X).PC3y)
            PC4   = string(format = '(%"PC4 (x,y) = %9.3f,%9.3f")',Mstripdata(event.X).PC4x,Mstripdata(event.X).PC4y)
            A3    = string(format = '(%"A3 = %9.3f")',Mstripdata(event.X).A3)
            Alexei =   string(format = '(%"A2 (alexei) = %6.1d")',Mstripdata(event.X).Alexei1)
            ; stop
            WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= timestamp + !CRLF $
                + length + !CRLF $
                + height + !CRLF $
                + area   + !CRLF $
                + F1     + !CRLF $
                + PC1    + !CRLF $
                + L3     + !CRLF $
                + L4     + !CRLF $
                + L5     + !CRLF $
                + L7     + !CRLF $
                + L8     + !CRLF $
                + PC3    + !CRLF $
                + PC4    + !CRLF $
                + A3     + !CRLF $
                + Alexei

            if (Mstripdata(event.X).ImageWords GT 0) then begin

                match = Mstripdata(event.X).Nanoseconds
                beginning = LONG(event.X)
                index =  LONG(event.X)
                WHILE ((beginning GE 0) and (Mstripdata(index).Nanoseconds EQ match)) DO BEGIN
                    beginning--
                    if --index LT 0 then index = 0
                ENDWHILE
                if beginning NE 0 then  beginning++

                theend = LONG(event.X)
                index = LONG(event.X)
                WHILE ((theend LE (!STRIP_WIDTH - 1)) and (Mstripdata(index).Nanoseconds EQ match)) DO BEGIN
                    theend++
                    if ++index GT (!STRIP_WIDTH - 1) then index = (!STRIP_WIDTH - 1)  ; can't let us access aveStripData(600)
                ENDWHILE
                if theend NE (!STRIP_WIDTH - 1) then theend--



                Widget_Control, strip_info.stripID, Get_Value=wid
                WSet, wid

                center_y = long(Mstripdata(event.X).PC1)
                center_x = long((theend-beginning)/2 + beginning)

                full_width = 22L
                half_width = 11L

                full_width = 44L
                half_width = 22L

                if (center_x LT half_width) then center_x = half_width
                if (center_x GT (!STRIP_WIDTH - 1)-half_width) then center_x = (!STRIP_WIDTH - 1)-half_width
                if (center_y LT half_width) then center_y = half_width
                if (center_y GT 127-half_width) then center_y = 127-half_width
                x1 = center_x - half_width
                y1 = center_y - half_width
                x_length = full_width
                y_length = full_width

                aa = where(Mstripdata(*).nanoseconds eq match)
                x1 = aa[0]
                x_length = n_elements(aa)

                clip = TVRD(x1,y1,x_length,y_length)

                Widget_Control, strip_info.zoomID, Get_Value=wid
                WSet, wid
                erase,color='ffffff'x  ; get background to white
                ;bigger = rebin(clip,full_width*zoom_value,full_width*zoom_value,/SAMPLE)
                bigger = rebin(clip, x_length * zoom_factor, y_length * !zoom_factor, /SAMPLE)
                tv,bigger

                Widget_Control, strip_info.stripID, Get_Value=wid
                WSet, wid
            end

        end
    end
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
END
;-------------------------------------
pro VMMParticleStrip_Toolbar_Rewind, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV,Mstripdata
    ;*******************************************************************************
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
    ;**************************************************
    firstimg_foffset=strip_info.firstimg_foffset
    lastimg_foffset =strip_info.lastimg_foffset
    localstate=strip_info.localstate
    ;**********************************************************************************
    ;*******************************************************************************
    if localstate.HorV eq 'V' then begin
        Hsubindex=*(localstate.all_index)
        nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
        Hsub_foffset=(*alldataV)(Hsubindex).imageoffset
        L1size_array=(*alldataV)(Hsubindex).Nslice
        foffset=!Foffset
    endif
    if localstate.HorV eq 'H' then begin
        Hsubindex=*(localstate.all_index)
        nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
        Hsub_foffset=(*alldataH)(Hsubindex).imageoffset
        L1size_array=(*alldataH)(Hsubindex).Nslice
        foffset=!Foffset
    endif

    ;get the new offset
    index=where(Hsub_foffset le foffset,number_left)
    if number_left ne 0 then begin
        foffsets_array=reverse(Hsub_foffset(index))
        L1size_array =reverse(L1size_array(index))
        ;find the first particle file_offset and then re-order them
        yoffset=0
        nnn=n_elements(L1size_array) < 500
        for i=0, nnn-1 do begin
            yoffset=yoffset+L1size_array(i)+1
            if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                foffset=foffsets_array(i)
                break
            endif; ;end of if yoffset ge
        endfor
    endif else foffset=firstimg_foffset
    ;finished getting the new start offset
    ;***************************************************************************************

    newoffset = Fill_MM_Strip(foffset,localstate, strip_info,-1,localstate.HorV)

    if !FOFFSET le firstimg_foffset then begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "BEGINNING OF M period REACHED"
    end else begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
    endelse
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
end
;-------------------------------------
pro VMMParticleStrip_Toolbar_Forward, event
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
    ;**************************************************
    firstimg_foffset=strip_info.firstimg_foffset
    lastimg_foffset =strip_info.lastimg_foffset
    localstate=strip_info.localstate
    ;**********************************************************************************
    foffset = !FOFFSET
    newoffset = Fill_MM_Strip(foffset,localstate, strip_info,1,localstate.HorV)
    ; print, "pre,post",pre_offset,newoffset; ; if pre_offset EQ foffset then begin
    if foffset ge lastimg_foffset then begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "END OF M Period REACHED"
    end else begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
    endelse
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure

end;-------------------------------------
;=============================================================
;*****************************************************************************
pro VMMBitmap_Playback_Speed_event, event
    if event.index eq 0 then !PLAYBACK_SPEED = 0.1
    if event.index eq 1 then !PLAYBACK_SPEED = 0.25
    if event.index eq 2 then !PLAYBACK_SPEED = 0.50
    if event.index eq 3 then !PLAYBACK_SPEED = 1.0
end  ;MMBitmap_Playback_Speed_event, event
;*****************************************************************************
pro VMMplay_forward_timer_event, event
    forward_function  Fill_MM_Strip
    IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') THEN BEGIN
        if (!PLAYBACK_ACTIVE eq 0) then begin
            Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
            ;**************************************************
            firstimg_foffset=strip_info.firstimg_foffset
            lastimg_foffset =strip_info.lastimg_foffset
            localstate=strip_info.localstate
            ;**********************************************************************************
            foffset = !FOFFSET
            pre_offset = foffset
            newoffset = Fill_MM_Strip(foffset, localstate,strip_info,1,localstate.HorV)
            ; print, "pre,post",pre_offset,newoffset
            if pre_offset ge lastimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "END OF M Period REACHED"
                !PLAYBACK_ACTIVE = 1
                widget_control, event.ID, SET_VALUE = 'FF.bmp', /BITMAP

                WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=1

            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
                WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED
            endelse


            Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure

        endif
    endif else begin
        Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
        ;**************************************************
        firstimg_foffset=strip_info.firstimg_foffset
        lastimg_foffset =strip_info.lastimg_foffset
        localstate=strip_info.localstate
        ;**********************************************************************************
        if (!PLAYBACK_ACTIVE eq 1) then begin
            !PLAYBACK_ACTIVE = 0
            widget_control, event.ID, SET_VALUE = 'FFon.bmp', /BITMAP
            WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=0
            foffset = !FOFFSET
            pre_offset = foffset
            newoffset = Fill_MM_Strip(foffset, ave_info,strip_info,1,localstate.HorV)
            ; print, "pre,post",pre_offset,newoffset
            if pre_offset EQ lastimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "END OF M Period REACHED"
            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
            endelse
        endif else begin
            !PLAYBACK_ACTIVE = 1
            widget_control, event.ID, SET_VALUE = 'FF.bmp', /BITMAP

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=1
        endelse
        Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
    endelse
end;  end of MMplay_forward_timer_event, event
;*****************************************************************************
pro VMMplay_reverse_timer_event, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV,Mstripdata
    ;*******************************************************************************
    forward_function  Fill_MM_Strip
    IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') THEN BEGIN
        if (!REWIND_ACTIVE eq 0) then begin
            Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
            ;**************************************************
            firstimg_foffset=strip_info.firstimg_foffset
            lastimg_foffset =strip_info.lastimg_foffset
            localstate=strip_info.localstate
            ;**********************************************************************************
            ;*******************************************************************************
            if localstate.HorV eq 'V' then begin
                Hsubindex=*(localstate.all_index)
                nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
                Hsub_foffset=(*alldataV)(Hsubindex).imageoffset
                L1size_array=(*alldataV)(Hsubindex).Nslice
            endif
            if localstate.HorV eq 'H' then begin
                Hsubindex=*(localstate.all_index)
                nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
                Hsub_foffset=(*alldataH)(Hsubindex).imageoffset
                L1size_array=(*alldataH)(Hsubindex).Nslice
            endif

            foffset=!Foffset
            ;get the new offset
            index=where(Hsub_foffset le foffset,number_left)
            if number_left ne 0 then begin
                foffsets_array=reverse(Hsub_foffset(index))
                L1size_array =reverse(L1size_array(index))
                ;find the first particle file_offset and then re-order them
                yoffset=0
                nnn=n_elements(L1size_array) < 500
                for i=0, nnn-1 do begin
                    yoffset=yoffset+L1size_array(i)+1
                    if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                        foffset=foffsets_array(i)
                        break
                    endif; ;end of if yoffset ge
                endfor
            endif else foffset=firstimg_foffset
            ;finished getting the new start offset
            ;***************************************************************************************
            newoffset = Fill_MM_Strip(foffset, localstate,strip_info,-1,localstate.HorV)

            if !FOFFSET le firstimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "BEGINNING OF M Period REACHED"
                !REWIND_ACTIVE = 1
                widget_control, event.ID, SET_VALUE = 'RR.bmp', /BITMAP
                WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=1
            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
                WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED
            endelse
            Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
        endif
    endif else begin
        Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
        ;**************************************************
        firstimg_foffset=strip_info.firstimg_foffset
        lastimg_foffset =strip_info.lastimg_foffset
        localstate=strip_info.localstate
        ;**********************************************************************************
        ;*******************************************************************************
        if localstate.HorV eq 'V' then begin
            Hsubindex=*(localstate.all_index)
            nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
            Hsub_foffset=(*alldataV)(Hsubindex).imageoffset
            L1size_array=(*alldataV)(Hsubindex).Nslice
        endif
        if localstate.HorV eq 'H' then begin
            Hsubindex=*(localstate.all_index)
            nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
            Hsub_foffset=(*alldataH)(Hsubindex).imageoffset
            L1size_array=(*alldataH)(Hsubindex).Nslice
        endif

        foffset=!Foffset
        ;get the new offset
        index=where(Hsub_foffset le foffset,number_left)
        if number_left ne 0 then begin
            foffsets_array=reverse(Hsub_foffset(index))
            L1size_array =reverse(L1size_array(index))
            ;find the first particle file_offset and then re-order them
            yoffset=0
            nnn=n_elements(L1size_array) < 500
            for i=0, nnn-1 do begin
                yoffset=yoffset+L1size_array(i)+1
                if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                    foffset=foffsets_array(i)
                    break
                endif; ;end of if yoffset ge
            endfor
        endif else foffset=firstimg_foffset
        ;finished getting the new start offset
        ;***************************************************************************************
        if (!REWIND_ACTIVE eq 1) then begin
            !REWIND_ACTIVE = 0
            widget_control, event.ID, SET_VALUE = 'RRon.bmp', /BITMAP
            WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=0

            ; foffset = !FOFFSET
            newoffset = Fill_MM_Strip(foffset,localstate,strip_info,-1,localstate.HorV)

            if !FOFFSET le firstimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "BEGINNING OF M Period REACHED"
            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
            endelse
        endif else begin
            !REWIND_ACTIVE = 1
            widget_control, event.ID, SET_VALUE = 'RR.bmp', /BITMAP
            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=1
        endelse
        Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
    endelse
end  ; end of VMMplay_reverse_timer_event, event
;*****************************************************************************
;****************************************************************************
; input the first particle index; that converted to foffset.
; output the last particle index; that converted to the new_file_offset.
; if the input output file offset falls outsize teh ave_start and end offset
; then stop filling and output message that the end of the period is reached.
Function Fill_MM_strip, foffset, localstate, strip_info, direction,HorV

    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV,Mstripdata
    ;*******************************************************************************
    localstate=strip_info.localstate
    HorV=localstate.HorV
    ;*******************************************************************************
    if HorV eq 'H' then begin
        MStripData = REPLICATE({_DerivedDataRev2},!STRIP_WIDTH)
        subindex=*(localstate.all_index)
        nnnn=n_elements(subindex);  there are total of nnnn particles to be displayed.
        sub_foffset=(*alldataH)(subindex).imageoffset
        L1size_array=(*alldataH)(subindex).Nslice
        imgword_array=(*alldataH)(subindex).imageWords
        nanoseconds_array=(*alldataH)(subindex).nanoseconds
    endif

    if HorV eq 'V' then begin
        MStripData = REPLICATE({_DerivedDataRev2},!STRIP_WIDTH)
        subindex=*(localstate.all_index);    *(ave_info.Vsubindex)
        nnnn=n_elements(subindex);  there are total of nnnn particles to be displayed.
        sub_foffset=(*alldataV)(subindex).imageoffset
        L1size_array=(*alldataV)(subindex).Nslice
        imgword_array=(*alldataV)(subindex).imageWords
        nanoseconds_array=(*alldataV)(subindex).nanoseconds
    endif

    firstimage_foffset=sub_foffset(0)
    lastimage_foffset =sub_foffset(nnnn-1)

    if foffset eq -1 then begin
        foffset=firstimage_foffset

        number_left=nnnn < 500;  number of particles left need to be displayed.
        foffsets_array=sub_foffset(0:number_left-1)
        L1size_array =Nslicesize_array(0:number_left-1)
        nanoseconds_array =nanoseconds_array(0:number_left-1)
        imgword_array=imgWord_array(0:number_left-1)
        use_index=subindex(0:number_left-1)
    endif else begin
        index=where(sub_foffset ge foffset,number_left)
        foffsets_array=sub_foffset(index)
        L1size_array =L1size_array(index)
        imgword_array =imgword_array(index)
        nanoseconds_array=nanoseconds_array(index)
        use_index=subindex(index)
    endelse
    ;stop
    if number_left le 0 then begin
        return, lastimage_foffset; 1; no particles left to be displayed.
    endif
    ;stop
    ;********************************************************************************
    ; if  direction=1, then scan forward, if -1, then backward
    ;-------------------------------------------------------------
    ; Handle Rewind
    ;  Reposition the foffset from the current position so that
    ;  we fill the strip with the last particle as the one currently
    ;  pointed to.
    ;-------------------------------------------------------------
    if direction eq -1 then reverse_foffset=foffset
    ;stop
    ; create a filename that is one directory above the Data file's horizyymmddhhmmss.bin that was selected above
    ; Here it doesn't matter what the current file is because we will always have a horiz filename at this point to work with
    ; fname = strmid(!currentHPname,0,strlen(!currentHPname)-5) + 'SORTED' +   strmid(!currentHFname,strpos(!currentHFname,"horiz")+5,12) + '.2DS'
    substrsF=strsplit(!currentHFname,'\',/extract)
    short_filename=substrsF(n_elements(substrsF)-1)
    datestamp = strmid(Short_filename,5,strlen(Short_filename)-9)
    fname = strmid(!currentHPname,0,strlen(!currentHPname)-5) + 'SORTED' + datestamp+ '.2DS'
    OpenR, lun, fname, /Get_Lun

    ; draw the graph in the Strip Widget
    Widget_Control, strip_info.stripID, Get_Value=wid
    WSet, wid

    erase,color='ffffff'x  ; get background to white

    ; Initialize our variables for the display
    yoffset = 0
    firstnano = 0ULL
    lastnano = 0ULL
    strip_index = 0U


    FOR i=0U,number_left-1 DO BEGIN  ; the number_left is not neccessary equal to n_elements(stripdata(*)).

        if (L1size_array(i) GT 0) then begin  ;------------------ ; at begining yoffset=0, as it goes, yoffset increases.
            if firstnano eq 0ULL then firstnano = Nanoseconds_array(i)
            if ((yoffset + L1size_array(i) + 1) GT !STRIP_WIDTH) and (i lt number_left-1) then begin  ;util yoffset reached teh stripwidth.
                lastnano =Nanoseconds_array(i)
                foffset =foffsets_array(i+1)

                ;  i = uint(number_left + 100) ; this stops teh for loop.
                !FOFFSET = foffset
                break
            end else begin ; only fill up to the top of the strip

                ;Image = BytArr(OD.Nslice * 2)
                ;out_array = BytArr(20000)
                ;out_byte_array = BytArr(128,OD.ImageWords + 10)

                ;Slices = L1size_array(i)
                ;WordCount = ImgWord_array(i)

                ;Image = BytArr(WordCount * 2)
                ;out_array = BytArr(16L * Slices)
                ;out_byte_array = BytArr(128L, Slices)

                ;POINT_LUN, lun, fOffsets_array(i)
                ;ReadU, lun, Image

                ;HSums=intarr(Slices)
                ;HMax  = 0
                ;Area = 0UL
                ;Midpoint = 0
                ;Edges = 0
                ;L3 = 0.0
                ;L4 = 0.0
                ;L5 = 0.0
                ;PC3x = 0.0
                ;PC3y = 0.0
                ;PC4x = 0.0
                ;PC4y = 0.0
                ;A3 = 0.0

                ;Err=0

                ;ProcessParticle,  Image, HSums, out_array, out_byte_array, Wordcount, Slices,  HMax, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3


                ;print, out_byte_array
                ;tv, ROTATE(out_byte_array, !IMAGE_ROTATION), yoffset, 0
                ;Hsums=0.0


                WordCount = ImgWord_array(i)
                Slices = L1size_array(i)

                Image_data = BytArr(WordCount * 2)
                out_array = BytArr(16L * Slices)
                out_byte_array = BytArr(128L, Slices)

                POINT_LUN, lun, fOffsets_array(i)
                ReadU, lun, Image_data

                HSums=intarr(Slices)
                HMax  = 0
                Area = 0UL
                Midpoint = 0
                Edges = 0
                L3 = 0.0
                L4 = 0
                L5 = 0
                PC3x = 0.0
                PC3y = 0.0
                PC4x = 0.0
                PC4y = 0.0
                A3 = 0.0
                Roundness1 = 0.0
                Roundness2 = 0.0
                Roundness3 = 0.0
                L1r = 0.0
                maxLength = 0.0
                maxWidth  = 0.0
                perimeter = 0
                perimeterum = 0.
                csp = 0.
                num_satellites = 0.

                Err=0
                ProcessParticle, Image_data, out_array, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , $
                    L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp, num_satellites

                tv, ROTATE(out_byte_array, !IMAGE_ROTATION), yoffset, 0
                Hsums=0.0



                ; Save the pertinent data for each tick on the graph for later display
                FOR z=yoffset, (yoffset + L1size_array(i)+1) DO BEGIN
                    if (z LT !STRIP_WIDTH) then  begin
                        if HorV eq 'H' then MStripData(z) =(*alldataH)(use_index(i));   ???????
                        if HorV eq 'V' then MStripData(z) =(*alldataV)(use_index(i));   ???????
                    endif
                ENDFOR
                yoffset += L1size_array(i) + 1
                foffset=foffsets_array(i); allways update it utile the last particle of the strip

            endelse
        end  ; end of if Nslice size gt 0  -------------------------------------------
    ENDFOR

    if (i EQ number_left) then lastnano = Nanoseconds_array(i-1)
    Close ,lun
    Free_Lun,lun

    channel_name = ""
    ;if (!CURRENT_CHANNEL EQ !H_CHART) THEN channel_name = 'Horizontal'
    ;if (!CURRENT_CHANNEL EQ !V_CHART) THEN channel_name = 'Vertical'
    if HorV eq 'H' then channel_name = 'Horizontal' else  channel_name = 'Vertical'
    Widget_Control, strip_info.stripBase, BASE_SET_TITLE="Zoomed: Showing " + channel_name + $
        " channel from " + SPEC_Nano2HMS(firstnano) + " to " +  SPEC_Nano2HMS(lastnano)

    if (direction EQ -1) then !FOFFSET = reverse_foffset
    if (direction EQ 1) then !Foffset = foffset

    return, foffset
end ; end of fill_MM_strip,offset,localstate,info,direction, HorV
;***********************************************************************************************
pro What_Button_Pressed, event,pressedButton
    ; Checks event.press to find out what kind of button
    ; was pressed in a draw widget.  This is NOT an event handler.
    button = ['NONE', 'LEFT', 'MIDDLE', 'NONE', 'RIGHT']
    pressedbutton=button(event.press)
END ;*******************************************************************
pro  What_Button_Released, event, releasedbutton
    ; Checks event.press to find out what kind of button
    ; was released in a draw widget.  This is NOT an event handler.
    button = ['NONE', 'LEFT', 'MIDDLE', 'NONE', 'RIGHT']
    releasedbutton=button(event.release)
END ;*******************************************************************
;**************************************************************************************
pro Cleaning_button_event,event
    widget_control,event.top, get_uvalue=strip_info,/no_copy
    if !clean_status eq 1 then begin
        rrr=dialog_message(' Click a end point to finish your earlier cleaning first !',/information)
    endif

    if !clean_status eq 0 or !clean_status eq 3 then begin
        !clean_status=2
    endif
    ;if !clean_status eq 2 then begin
    ; rrr=dialog_message(' Click a start point to start your cleaning action !',/information)
    ; endif
    widget_control,event.top, set_uvalue=strip_info,/no_copy
end; end of Cleaning_button_event
;*********************************************************************************
pro One_click_Cleaning_button_off_event,event
    widget_control,event.top, get_uvalue=strip_info,/no_copy
    !clean_status =0
    widget_control,event.top, set_uvalue=strip_info,/no_copy
end; end of Cleaning_button_event
;*********************************************************************************
pro One_click_Cleaning_button_on_event,event
    widget_control,event.top, get_uvalue=strip_info,/no_copy
    !clean_status =3
    widget_control,event.top, set_uvalue=strip_info,/no_copy
end; end of Cleaning_button_event
;*********************************************************************************
;One_click_Force_as_good_button_on_event'
;*********************************************************************************
;pro One_click_Force_as_good_button_off_event,event
; widget_control,event.top, get_uvalue=strip_info,/no_copy
;  !clean_status =0
; widget_control,event.top, set_uvalue=strip_info,/no_copy
;end; end of Cleaning_button_event
;*********************************************************************************
;pro One_click_Force_as_good_button_on_event,event
; widget_control,event.top, get_uvalue=strip_info,/no_copy
;  !clean_status =4
; widget_control,event.top, set_uvalue=strip_info,/no_copy
;end; end of Cleaning_button_event


;pro add_this_click_to_actionlist,this_index,localstate
;if this_index ne -1 then begin
;       actionlist=*(localstate.actionlist)
;       this_action=localstate.HorV+'click  '+strtrim(string(this_index),2)
;       if actionlist(0) eq 'Empty' then begin
;      actionlist=this_action
;       endif else begin
;             actionlist=[actionlist,this_action]
;             endelse
;       localstate.actionlist=ptr_new(actionlist)
;       display_actionlist,localstate
;endif
;end; end of add_this_click_to_actionlist,index(0),localtstate

pro ADD_THIS_CLICK_TO_CLICK_action_list_file,this_index,HorV,reject
    outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'_HVclick_list.txt'
    openw,1,outputfilename,/append
    if this_index ne -1 then begin
        printf,1,HorV+'click  '+ strtrim(string(this_index),2)+' Labeled_As ' + strtrim(reject)
    endif
    close,1
end;  end of save_actionlist_into_a_file,localstate
;*******************************************************************************
PRO ADD_ALL_INDEXS_TO_ACTIONLIST,INDEX,HorV
    NNN=N_ELEMENTS(INDEX)
    ; stop
    FOR I=0, NNN-1 DO BEGIN
        THIS_INDEX=INDEX(I);    put 1 means to label them all as bad.
        ADD_THIS_CLICK_TO_CLICK_action_list_file,this_index,HorV,1
    ENDFOR
END; ADD_ALL_INDEXS_TO_ACTIONLIST,INDEX,LOCALSTATE
;*********************************************************

pro flig_myclips_color, myclip, mylength, dimension
    ; TAF while we do not know what flig or fligging actually might mean,
    ; this routine recolors particle bitmap displays in
    ; the zoomed H and V strip windows from black and white to yellow background

    ;find if it is black and white
    index = where(myclip eq 0, contG)

    if contG gt 0 then begin ; it is white and black, make it to be yellow
        yellowblock=bytarr(3, mylength, 128)
        yellowblock(0,*,*) = 255
        yellowblock(1,*,*) = myclip
        myclip = yellowblock
        dimension = 3
    endif else begin ; it is yellow, make it black and white
        index252 = where(myclip eq 252, contG)

        if contG gt 0 then myclip(index252) = 252

        index0 = where(myclip eq 248, contG )

        if contG gt 0 then myclip(index0) = 0

        dimension = 2
    endelse

end ; flig_myclips_color, myclip
;**************************************


