PRO ZoomedStereoParticleStrip, Hindex,Vindex,info  ; this is for Hparticles
    forward_function Fill_stereo_Strip
    stripID = 0L
    zoomID  = 0L
    stripBase = 0L
    stripLabel = 0L

    ave_info=info.ave_info
    Hlastimg_foffset=info.Hlastimg_foffset
    Hfirstimg_foffset=info.Hfirstimg_foffset
    Vlastimg_foffset=info.Vlastimg_foffset
    Vfirstimg_foffset=info.Vfirstimg_foffset

    strip_info = {stripID:stripID, $               ; widget ID for the strip of bitmaps
        VstripID:0L,$
        zoomID:zoomID, $
        stripBase:stripBase, $
        stripLabel:stripLabel, $
        VstripBase:stripBase, $
        VstripLabel:stripLabel, $
        FR_button:0L, $
        SSR_button:0L, $
        SSF_button:0L, $
        FF_button:0L, $
        ave_info:ave_info,$
        Hlastimg_foffset:Hlastimg_foffset,$
        Hfirstimg_foffset:Hfirstimg_foffset, $
        Vlastimg_foffset:Vlastimg_foffset,   $
        Vfirstimg_foffset:Vfirstimg_foffset, $
        Hindex:Hindex,$
        Vindex:Vindex $
        }
    base = WIDGET_BASE(/COLUMN)
    strip_info.stripBase = base
    info.stripBase = base
    Hparticles = Widget_Draw(base,XSize=!STRIP_WIDTH, YSize=260, Event_Pro='SPEC_StripZoomStereo_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    strip_info.stripID = HParticles       ;128 changed to 260 leave 4 pixels to separate H avd V channel image.

    info.stripID = HParticles

    STRIP_Toolbar = WIDGET_BASE(base, $
        COLUMN=8, $
        FRAME=1, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=256)


    STRIP_dual_label = WIDGET_BASE(STRIP_Toolbar, $
        ROW=1, $
        ; FRAME=1, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=180)


    ; Generate a label on the bitmap widget that will display the parameters for a single particle

    LABEL_Info = WIDGET_TEXT(STRIP_dual_label, $
        VALUE="", $
        XSIZE = 45, $   ; changed from 40 to 45
        YSIZE=30)
    strip_info.stripLabel = LABEL_Info


    BUTTON_FastBackward = WIDGET_BUTTON( STRIP_Toolbar, $
        FONT='9x15', $
        UVALUE='FastRewind', $
        XSIZE=40, $
        TOOLTIP="Play Backwards", $
        VALUE=  'RR.bmp', /BITMAP, $
        Event_Pro='StereoZoomplay_reverse_timer_event')



    BUTTON_Rewind = WIDGET_BUTTON( STRIP_Toolbar, $
        FONT='9x15', $
        UVALUE='Rewind', $
        XSIZE=35, $
        TOOLTIP="Single Step Reverse", $
        VALUE=  'SingleR.bmp', /BITMAP, $
        Event_Pro='StereoZoomParticleStrip_Toolbar_Rewind')

    BUTTON_Forward = WIDGET_BUTTON( STRIP_Toolbar, $
        FONT='9x15', $
        UVALUE='Forward', $
        XSIZE=35, $
        TOOLTIP="Single Step Forward", $
        ;PUSHBUTTON_EVENTS=1, $
        VALUE= 'SingleF.bmp', /BITMAP, $
        Event_Pro='StereoZoomParticleStrip_Toolbar_Forward')


    BUTTON_FastForward = WIDGET_BUTTON( STRIP_Toolbar, $
        FONT='9x15', $
        UVALUE='FastForward', $
        XSIZE=40, $
        TOOLTIP="Play Forwards", $
        VALUE=  'FF.bmp', /BITMAP, $
        Event_Pro='StereoZoomplay_forward_timer_event')


    spaceholder1 = WIDGET_LABEL(STRIP_Toolbar, $
        VALUE= " Speed (in Secs)", $
        XSIZE=110, $
        YSIZE=35)

    dd_list=['0.10','0.25','0.50','1.0']
    STRIP_Dropdown = WIDGET_DROPLIST(STRIP_Toolbar, $
        FRAME=1, $
        VALUE = dd_list, $
        Event_Pro = 'StereoZoomBitmap_Playback_Speed_event')

    ; save so we can disble buttons during FF and Fast reverse
    strip_info.FR_button = BUTTON_FastBackward
    strip_info.SSR_button = BUTTON_Rewind
    strip_info.SSF_button = BUTTON_Forward
    strip_info.FF_button = BUTTON_FastForward

    Zoomer_base = WIDGET_BASE(STRIP_Toolbar, $
        MAP=1, $
        UVALUE='BASE_Zoomer', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=!zoom_ysize+50, $
        XSIZE=!zoom_xsize+50)

    strip_info.zoomID = Widget_Draw(Zoomer_base,XSize = !zoom_xsize+50, YSize = !zoom_xsize+50, Event_Pro='SPEC_StripZoomStereo_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    ;  strip_info.zoomID = Widget_Draw(Zoomer_base,XSize=128, YSize=128, Event_Pro='SPEC_StripH_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    direction=1
    foffset=[0UL,0UL];  0UL means the first time filling in the strip
    ;stop
    foffset=Fill_stereo_Strip(foffset, ave_info, strip_info, direction)
    wdelete,!D.window
    Widget_Control, base, Set_UValue=strip_info, /No_Copy
    WIDGET_CONTROL, base, /REALIZE

    XMANAGER, 'ZoomedStereoParticleStrip', base, /JUST_REG

END ; end of zoomHparticlestrip,info
;*********************************************************************
PRO SPEC_StripZoomStereo_event, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,$
        LastDataV,StripDataV,OneHzH,OneHzV,avestripdata,avestripdataV,SHstripdata,SVstripdata
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
    if(event.PRESS GE 1) then  begin
        if event.ID EQ strip_info.zoomID then print, "zoom window clicked"
    end

    if event.ID EQ strip_info.stripID then begin
        if (event.x GE 0 and event.X LE (!STRIP_WIDTH - 1)) then begin

            ;H particle values
            timestamp = SPEC_Nano2HMS(SHStripData(event.X).Nanoseconds)
            ;length = string(format = '(%"Length/L1(um) = %d")',SHStripData(event.X).ImageWords * 10)
            length = string(format = '(%"Length/L1n(um) = %d")',SHStripData(event.X).L1n * 10)
            height = string(format = '(%"Height/L2(um) = %d")',SHStripData(event.X).L2 * 10)
            area   = string(format = '(%"Area(sq.um) = %6.1d")',SHStripData(event.X).Area * 100)
            F1     = string(format = '(%"F1 = %1.1d")',SHStripData(event.X).F1)
            PC1    = string(format = '(%"PC1 = %3.1d")',SHStripData(event.X).PC1)
            L3    = string(format = '(%"L3 = %9.3f")',SHStripData(event.X).L3)
            L4    = string(format = '(%"L4 = %3.1d")',SHStripData(event.X).L4)
            L5    = string(format = '(%"L5 = %3.1d")',SHStripData(event.X).L5)
            PC3   = string(format = '(%"PC3 (x,y) = %9.3f,%9.3f")',SHStripData(event.X).PC3x,SHStripData(event.X).PC3y)
            PC4   = string(format = '(%"PC4 (x,y) = %9.3f,%9.3f")',SHStripData(event.X).PC4x,SHStripData(event.X).PC4y)
            A3    = string(format = '(%"A3 = %9.3f")',SHStripData(event.X).A3)
            Alexei =   string(format = '(%"Alexei = %6.1d")',SHStripData(event.X).Alexei1)

            ;V particle values
            Vtimestamp = SPEC_Nano2HMS(SVStripData(event.X).Nanoseconds)
            ;length = string(format = '(%"Length/L1(um) = %d")',SHStripData(event.X).ImageWords * 10)
            Vlength = string(format = '(%"%d")',SVStripData(event.X).L1n * 10)
            Vheight = string(format = '(%"%d")',SVStripData(event.X).L2 * 10)
            Varea   = string(format = '(%"%6.1d")',SVStripData(event.X).Area * 100)
            VF1     = string(format = '(%"%1.1d")',SVStripData(event.X).F1)
            VPC1    = string(format = '(%"%3.1d")',SVStripData(event.X).PC1)
            VL3    = string(format = '(%"%9.3f")',SVStripData(event.X).L3)
            VL4    = string(format = '(%"%3.1d")',SVStripData(event.X).L4)
            VL5    = string(format = '(%"%3.1d")',SVStripData(event.X).L5)
            VPC3   = string(format = '(%"%9.3f,%9.3f")',SVStripData(event.X).PC3x,SVStripData(event.X).PC3y)
            VPC4   = string(format = '(%"%9.3f,%9.3f")',SVStripData(event.X).PC4x,SVStripData(event.X).PC4y)
            VA3    = string(format = '(%"%9.3f")',SVStripData(event.X).A3)
            VAlexei =   string(format = '(%"%6.1d")',SVStripData(event.X).Alexei1)


            WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= timestamp + '   V:'+ Vtimestamp + !CRLF $
                + length + '   V:'+ Vlength +    !CRLF $
                + height + '   V:'+ Vheight +!CRLF $
                + area   + '   V:'+ Varea +!CRLF $
                + F1     + '   V:'+ VF1 +!CRLF $
                + PC1    + '   V:'+ VPC1 +!CRLF $
                + L3     + '   V:'+ VL3 +!CRLF $
                + L4     + '   V:'+ VL4 +!CRLF $
                + L5     + '   V:'+ VL5 +!CRLF $
                + PC3    + '   V:'+ VPC3 +!CRLF $
                + PC4    + '   V:'+ VPC4 +!CRLF $
                + A3     + '   V:'+ VA3 +!CRLF $
                + Alexei + '   V:'+ VAlexei

            ; do showing the zoomed imaged, if event.Y is in bottom zoomed in H-image.
            ; if event.Y is on top part, zooms in the V-image.
            if event.Y le 128 then begin ; zooms in the H image.
                if (SHStripData(event.X).ImageWords GT 0) then begin

                    match = SHStripData(event.X).Nanoseconds
                    beginning = LONG(event.X)
                    index =  LONG(event.X)
                    WHILE ((beginning GE 0) and (SHStripData(index).Nanoseconds EQ match)) DO BEGIN
                        beginning--
                        if --index LT 0 then index = 0
                    ENDWHILE
                    if beginning NE 0 then  beginning++

                    theend = LONG(event.X)
                    index = LONG(event.X)
                    WHILE ((theend LE (!STRIP_WIDTH - 1)) and (SHStripData(index).Nanoseconds EQ match)) DO BEGIN
                        theend++
                        if ++index GT (!STRIP_WIDTH - 1) then index = (!STRIP_WIDTH - 1)  ; can't let us access SHStripData(600)
                    ENDWHILE
                    if theend NE (!STRIP_WIDTH - 1) then theend--



                    Widget_Control, strip_info.stripID, Get_Value=wid
                    WSet, wid

                    center_y = long(SHStripData(event.X).PC1)
                    center_x = long((theend-beginning)/2 + beginning)

                    ;length = SHStripData(event.X).L2
                    ;if (length LT SHStripData(event.X).ImageWords) then length = SHStripData(event.X).ImageWords


                    ;start = long(SHStripData(event.X).PC1 -length)
                    ;if (start LT 0) then start = 0

                    ;length *= 2
                    ;if (start + length) GT 127 then start = 128 - length
                    ;height = SHStripData(event.X).ImageWords

                    full_width = 44L
                    half_width = 22L

                    if (center_x LT half_width) then center_x = half_width
                    if (center_x GT (!STRIP_WIDTH - 1)-half_width) then center_x = (!STRIP_WIDTH - 1)-half_width
                    if (center_y LT half_width) then center_y = half_width
                    if (center_y GT 127-half_width) then center_y = 127-half_width
                    x1 = center_x - half_width
                    y1 = center_y - half_width
                    x_length = full_width
                    y_length = full_width

                    aa = where(SHStripData(*).nanoseconds eq match)
                    x1 = aa[0]
                    x_length = n_elements(aa)

                    clip = TVRD(x1,y1,x_length,y_length) ; get a clip from point x1,y1 with size=x_len by y_len
                    ;***********************************************************
                    Widget_Control, strip_info.zoomID, Get_Value=wid
                    WSet, wid
                    erase,color='ffffff'x  ; get background to white
                    ;bigger = rebin(clip,full_width*zoom_value,full_width*zoom_value,/SAMPLE)
                    bigger = rebin(clip, x_length * !zoom_factor, y_length * !zoom_factor, /SAMPLE)
                    tv,bigger
                    Widget_Control, strip_info.stripID, Get_Value=wid
                    WSet, wid
                end  ; end of if (SHStripData(event.X).ImageWords GT 0) then begin
                ;above finished teh H-image zoom; below zooms V-image.
            endif else begin;  zooms in the V-iamge
                if (SVStripData(event.X).ImageWords GT 0) then begin
                    match = SVStripData(event.X).Nanoseconds
                    beginning = LONG(event.X)
                    index =  LONG(event.X)
                    WHILE ((beginning GE 0) and (SVStripData(index).Nanoseconds EQ match)) DO BEGIN
                        beginning--
                        if --index LT 0 then index = 0
                    ENDWHILE
                    if beginning NE 0 then  beginning++

                    theend = LONG(event.X)
                    index = LONG(event.X)
                    WHILE ((theend LE (!STRIP_WIDTH - 1)) and (SVStripData(index).Nanoseconds EQ match)) DO BEGIN
                        theend++
                        if ++index GT (!STRIP_WIDTH - 1) then index = (!STRIP_WIDTH - 1)  ; can't let us access SHStripData(600)
                    ENDWHILE
                    if theend NE (!STRIP_WIDTH - 1) then theend--

                    Widget_Control, strip_info.stripID, Get_Value=wid
                    WSet, wid

                    center_y = long(SVStripData(event.X).PC1)
                    center_x = long((theend-beginning)/2 + beginning)

                    full_width = 44L
                    half_width = 22L    ; half_width should be particles L4 size related. we need to zoomed in ???

                    if (center_x LT half_width) then center_x = half_width
                    if (center_x GT (!STRIP_WIDTH - 1)-half_width) then center_x = (!STRIP_WIDTH - 1)-half_width
                    if (center_y LT half_width ) then center_y = half_width
                    if (center_y GT 127-half_width ) then center_y = 127-half_width
                    x1 = center_x - half_width
                    y1 = center_y - half_width
                    x_length = full_width
                    y_length = full_width

                    aa = where(SVStripData(*).nanoseconds eq match)
                    x1 = aa[0]
                    x_length = n_elements(aa)

                    clip = TVRD(x1,y1+132,x_length,y_length) ; 132 is the top pannel bottom line.
                    ;***********************************************************
                    Widget_Control, strip_info.zoomID, Get_Value=wid
                    WSet, wid
                    erase,color='ffffff'x  ; get background to white
                    ;bigger = rebin(clip,full_width*zoom_value,full_width*zoom_value,/SAMPLE)
                    bigger = rebin(clip, x_length * !zoom_factor, y_length * !zoom_factor, /SAMPLE)
                    tv,bigger
                    Widget_Control, strip_info.stripID, Get_Value=wid
                    WSet, wid
                end  ; end of if (SVStripData(event.X).ImageWords GT 0) then begin
            endelse;  done zooming the v_image.

        end; end of  if (event.x GE 0 and event.X LE (!STRIP_WIDTH - 1)) then begin  to show partice info
    end;   end of   if event.ID EQ strip_info.stripID then begin  to show strip info.

    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
END
;-------------------------------------
pro StereoZoomParticleStrip_Toolbar_Rewind, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV
    ;*******************************************************************************
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
    ;**************************************************
    Hfirstimg_foffset=strip_info.Hfirstimg_foffset
    Hlastimg_foffset =strip_info.Hlastimg_foffset
    Vfirstimg_foffset=strip_info.Vfirstimg_foffset
    Vlastimg_foffset =strip_info.Vlastimg_foffset
    ave_info=strip_info.ave_info
    ;**********************************************************************************
    ;*******************************************************************************
    Hindex=strip_info.Hindex
    nnnn=n_elements(Hindex);  there are total of nnnn particles to be displayed.
    Hsub_foffset=(*alldataH)(Hindex).imageoffset
    HL1size_array=(*alldataH)(Hindex).Nslice
    ;*********************
    Vindex=strip_info.Vindex
    Vsub_foffset=(*alldataV)(Vindex).imageoffset
    VL1size_array=(*alldataV)(Vindex).Nslice

    foffset=!stereoFoffset
    Hfoffset=foffset(0)
    Vfoffset=foffset(1)

    ;get the new offset
    index=where(Hsub_foffset le Hfoffset,number_left)
    Hfoffsets_array=reverse(Hsub_foffset(index))
    HL1size_array =reverse(HL1size_array(index))
    index=where(Vsub_foffset le Vfoffset,number_left)
    Vfoffsets_array=reverse(Vsub_foffset(index))
    VL1size_array =reverse(VL1size_array(index))
    ;find the first particle file_offset and then re-order them
    yoffset=0
    nnn=n_elements(HL1size_array) < 500
    for i=0, nnn-1 do begin
        yoffset=yoffset+max([HL1size_array(i),VL1size_array(i)])+1
        if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
            foffset=[Hfoffsets_array(i),Vfoffsets_array(i)]
            break
        endif; ;end of if yoffset ge
    endfor
    ;finished getting the new start offset
    ;***************************************************************************************

    newoffset = Fill_stereo_Strip(foffset,ave_info, strip_info,-1)
    if !stereoFOFFSET(0) le Hfirstimg_foffset then begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "BEGINNING OF Zoomed period REACHED"
    end else begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
    endelse
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
end
;-------------------------------------
pro StereozoomParticleStrip_Toolbar_Forward, event
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
    ;**************************************************
    Hfirstimg_foffset=strip_info.Hfirstimg_foffset
    Hlastimg_foffset =strip_info.Hlastimg_foffset
    ave_info=strip_info.ave_info
    ;**********************************************************************************
    foffset = !stereoFOFFSET
    newoffset = Fill_stereo_Strip(foffset,ave_info, strip_info,1)
    ; print, "pre,post",pre_offset,newoffset; ; if pre_offset EQ foffset then begin
    if foffset(0) ge Hlastimg_foffset then begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "END OF Zoomed Period REACHED"
    end else begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
    endelse
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure

end;-------------------------------------
;=============================================================
;*****************************************************************************
pro StereoZoomBitmap_Playback_Speed_event, event
    if event.index eq 0 then !PLAYBACK_SPEED = 0.1
    if event.index eq 1 then !PLAYBACK_SPEED = 0.25
    if event.index eq 2 then !PLAYBACK_SPEED = 0.50
    if event.index eq 3 then !PLAYBACK_SPEED = 1.0
end  ;zoomBitmap_Playback_Speed_event, event
;*****************************************************************************
pro StereoZoomplay_forward_timer_event, event
    forward_function  Fill_stereo_Strip
    IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') THEN BEGIN
        if (!PLAYBACK_ACTIVE eq 0) then begin
            Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
            ;**************************************************
            Hfirstimg_foffset=strip_info.Hfirstimg_foffset
            Hlastimg_foffset =strip_info.Hlastimg_foffset
            ave_info=strip_info.ave_info
            ;**********************************************************************************
            foffset = !stereoFOFFSET
            pre_offset = foffset(0)
            newoffset = Fill_stereo_Strip(foffset, ave_info,strip_info,1)
            ; print, "pre,post",pre_offset,newoffset
            if pre_offset ge Hlastimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "END OF Zoomed Period REACHED"
                !PLAYBACK_ACTIVE = 1
                widget_control, event.ID, SET_VALUE = 'FF.bmp', /BITMAP

                WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=1

            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
                WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED
            endelse


            Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure

        endif
    endif else begin
        Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
        ;**************************************************
        Hfirstimg_foffset=strip_info.Hfirstimg_foffset
        Hlastimg_foffset =strip_info.Hlastimg_foffset
        ave_info=strip_info.ave_info
        ;**********************************************************************************
        if (!PLAYBACK_ACTIVE eq 1) then begin
            !PLAYBACK_ACTIVE = 0
            widget_control, event.ID, SET_VALUE = 'FFon.bmp', /BITMAP
            WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=0
            foffset = !stereoFOFFSET
            pre_offset = foffset(0)
            newoffset = Fill_stereo_Strip(foffset, ave_info,strip_info,1)
            ; print, "pre,post",pre_offset,newoffset
            if pre_offset EQ Hlastimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "END OF Zoomed Period REACHED"
            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
            endelse
        endif else begin
            !PLAYBACK_ACTIVE = 1
            widget_control, event.ID, SET_VALUE = 'FF.bmp', /BITMAP

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=1
        endelse
        Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
    endelse
end;  end of zoomplay_forward_timer_event, event
;*****************************************************************************
pro StereoZoomplay_reverse_timer_event, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV
    ;*******************************************************************************
    forward_function  Fill_stereo_Strip
    IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') THEN BEGIN
        if (!REWIND_ACTIVE eq 0) then begin
            Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
            ;**************************************************
            Hfirstimg_foffset=strip_info.Hfirstimg_foffset
            Hlastimg_foffset =strip_info.Hlastimg_foffset
            Vfirstimg_foffset=strip_info.Vfirstimg_foffset
            Vlastimg_foffset =strip_info.Vlastimg_foffset
            ave_info=strip_info.ave_info
            ;**********************************************************************************
            ;*******************************************************************************
            Hindex=strip_info.Hindex
            nnnn=n_elements(Hindex);  there are total of nnnn particles to be displayed.
            Hsub_foffset=(*alldataH)(Hindex).imageoffset
            HL1size_array=(*alldataH)(Hindex).Nslice
            ;******************************
            Vindex=strip_info.Vindex
            Vsub_foffset=(*alldataV)(Vindex).imageoffset
            VL1size_array=(*alldataV)(Vindex).Nslice

            foffset=!stereoFoffset
            Hfoffset=foffset(0)
            Vfoffset=foffset(1)
            ;get the new offset
            index=where(Hsub_foffset le Hfoffset,number_left)
            if number_left ne 0 then begin
                Hfoffsets_array=reverse(Hsub_foffset(index))
                HL1size_array =reverse(L1size_array(index))
            endif
            ;******************************************
            index=where(Vsub_foffset le Vfoffset,number_left)
            if number_left ne 0 then begin
                Vfoffsets_array=reverse(Vsub_foffset(index))
                VL1size_array =reverse(VL1size_array(index))
                ;find the first particle file_offset and then re-order them
                yoffset=0
                nnn=n_elements(HL1size_array) < 500
                for i=0, nnn-1 do begin
                    yoffset=yoffset+max([HL1size_array(i),VL1size_array(i)])+1
                    if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                        foffset=[Hfoffsets_array(i),Hfoffsets_array(i)]
                        break
                    endif; ;end of if yoffset ge
                endfor
            endif else foffset=[Hfirstimg_foffset,Vfirstimg_foffset]
            ;finished getting the new start offset
            ;***************************************************************************************
            newoffset = Fill_stereo_Strip(foffset, ave_info,strip_info,-1)

            if !steroFOFFSET(0) le Hfirstimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "BEGINNING OF Zoomed Period REACHED"
                !REWIND_ACTIVE = 1
                widget_control, event.ID, SET_VALUE = 'RR.bmp', /BITMAP
                WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=1
            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
                WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED
            endelse
            Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
        endif
    endif else begin
        Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
        ;**************************************************
        Hfirstimg_foffset=strip_info.Hfirstimg_foffset
        Hlastimg_foffset =strip_info.Hlastimg_foffset
        Vfirstimg_foffset=strip_info.Vfirstimg_foffset
        Vlastimg_foffset =strip_info.Vlastimg_foffset
        ave_info=strip_info.ave_info
        ;**********************************************************************************
        ;*******************************************************************************
        Hindex=strip_info.Hindex
        nnnn=n_elements(Hindex);  there are total of nnnn particles to be displayed.
        Hsub_foffset=(*alldataH)(Hindex).imageoffset
        HL1size_array=(*alldataH)(Hindex).Nslice
        Vindex=strip_info.Vindex
        Vsub_foffset=(*alldataV)(Vindex).imageoffset
        VL1size_array=(*alldataV)(Vindex).Nslice

        foffset=!stereoFoffset
        Hfoffset=foffset(0)
        Vfoffset=foffset(1)
        ;get the new offset
        index=where(Hsub_foffset le Hfoffset,number_left)
        if number_left ne 0 then begin
            Hfoffsets_array=reverse(Hsub_foffset(index))
            HL1size_array =reverse(HL1size_array(index))
        endif
        index=where(Vsub_foffset le Vfoffset,number_left)
        if number_left ne 0 then begin
            Vfoffsets_array=reverse(Vsub_foffset(index))
            VL1size_array =reverse(VL1size_array(index))

            ;find the first particle file_offset and then re-order them
            yoffset=0
            nnn=n_elements(HL1size_array) < 500
            for i=0, nnn-1 do begin
                yoffset=yoffset+max([HL1size_array(i),HL1size_array(i)])+1
                if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                    foffset=[Hfoffsets_array(i),Hfoffsets_array(i)]
                    break
                endif; ;end of if yoffset ge
            endfor
        endif else foffset=[Hfirstimg_foffset,Vfirstimg_foffset]
        ;finished getting the new start offset
        ;***************************************************************************************
        if (!REWIND_ACTIVE eq 1) then begin
            !REWIND_ACTIVE = 0
            widget_control, event.ID, SET_VALUE = 'RRon.bmp', /BITMAP
            WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=0

            ; foffset = !FOFFSET
            newoffset = Fill_stereo_Strip(foffset, ave_info,strip_info,-1)

            if !stereoFOFFSET(0) le Hfirstimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "BEGINNING OF Zoomed Period REACHED"
            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
            endelse
        endif else begin
            !REWIND_ACTIVE = 1
            widget_control, event.ID, SET_VALUE = 'RR.bmp', /BITMAP
            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=1
        endelse
        Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
    endelse
end  ; end of zoomplay_reverse_timer_event, event
;*****************************************************************************

;****************************************************************************
; input the first particle index; that converted to foffset.
; output the last particle index; that converted to the new_file_offset.
; if the input output file offset falls outsize teh ave_start and end offset
; then stop filling and output message that the end of the period is reached.
Function Fill_stereo_strip, foffset, ave_info, strip_info, direction

    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,$
        LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV,SHstripdata,SVstripdata
    ;*******************************************************************************
    Hfoffset=foffset(0)
    Vfoffset=foffset(1);  foffset has two elements now for stereo-particle pairs.
    ;*******************************************************************************
    ;H channel stereo-particles variables
    SHStripData = REPLICATE({_DerivedDataRev2},!STRIP_WIDTH)
    Hsubindex=strip_info.Hindex
    nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
    Hsub_foffset=(*alldataH)(Hsubindex).imageoffset
    HL1size_array=(*alldataH)(Hsubindex).Nslice
    Himgword_array=(*alldataH)(Hsubindex).imageWords
    Hnanoseconds_array=(*alldataH)(Hsubindex).nanoseconds

    ;V channel stereo-particles variables
    SVStripData = REPLICATE({_DerivedDataRev2},!STRIP_WIDTH)
    Vsubindex=strip_info.Vindex
    Vsub_foffset=(*alldataV)(Vsubindex).imageoffset
    VL1size_array=(*alldataV)(Vsubindex).Nslice
    Vimgword_array=(*alldataV)(Vsubindex).imageWords
    Vnanoseconds_array=(*alldataV)(Vsubindex).nanoseconds


    Hfirstimage_foffset=Hsub_foffset(0)
    Hlastimage_foffset =Hsub_foffset(nnnn-1)
    Vfirstimage_foffset=Vsub_foffset(0)
    Vlastimage_foffset =Vsub_foffset(nnnn-1)
    ; stop
    if Hfoffset eq 0UL then begin
        Hfoffset=Hfirstimage_foffset
        number_left=nnnn < 500;  number of particles left need to be displayed.
        Hfoffsets_array=Hsub_foffset(0:number_left-1)
        HL1size_array =HL1size_array(0:number_left-1)
        Hnanoseconds_array =Hnanoseconds_array(0:number_left-1)
        Himgword_array=HimgWord_array(0:number_left-1)
        Huse_index=Hsubindex(0:number_left-1)
        ;******************************************
        Vfoffsets_array=Vsub_foffset(0:number_left-1)
        VL1size_array =VL1size_array(0:number_left-1)
        Vnanoseconds_array =Vnanoseconds_array(0:number_left-1)
        Vimgword_array=VimgWord_array(0:number_left-1)
        Vuse_index=Vsubindex(0:number_left-1)
        ;stop
    endif else begin
        ;***********************************************
        index=where(Hsub_foffset ge Hfoffset,number_left)
        Hfoffsets_array=Hsub_foffset(index)
        HL1size_array =HL1size_array(index)
        Himgword_array =Himgword_array(index)
        Hnanoseconds_array=Hnanoseconds_array(index)
        Huse_index=Hsubindex(index)
        ;***********************************************
        index=where(Vsub_foffset ge Vfoffset,number_left)
        Vfoffsets_array=Vsub_foffset(index)
        VL1size_array =VL1size_array(index)
        Vimgword_array =Vimgword_array(index)
        Vnanoseconds_array=Vnanoseconds_array(index)
        Vuse_index=Vsubindex(index)
        ;***********************************************
        ;stop
    endelse


    if number_left le 0 then begin
        foffset=[Hlastimage_foffset,Vlastimage_foffset]
        return, foffset; 1; no particles left to be displayed.
    endif

    ;********************************************************************************
    ; if  direction=1, then scan forward, if -1, then backward
    ;-------------------------------------------------------------
    ; Handle Rewind
    ;  Reposition the foffset from the current position so that
    ;  we fill the strip with the last particle as the one currently
    ;  pointed to.
    ;-------------------------------------------------------------
    if direction eq -1 then reverse_foffset=foffset

    ; create a filename that is one directory above the Data file's horizyymmddhhmmss.bin that was selected above
    ; Here it doesn't matter what the current file is because we will always have a horiz filename at this point to work with
    ;fname = strmid(!currentHPname,0,strlen(!currentHPname)-5) + 'SORTED' +   strmid(!currentHFname,strpos(!currentHFname,"horiz")+5,12) + '.2DS'
    my_str1=strmid(!currentHPname, 0,strlen(!currentHPname)-1)
    my_pos =strpos(my_str1,'\',/reverse_search)
    fname=strmid(my_str1,0,my_pos+1)+'SORTED'
    horzname=strmid(!currentHFname,strpos(!currentHFname,"horiz")+5,strlen(!currentHFname))
    datetime=strmid(horzname,0,strlen(horzname)-4)
    ;fname=fname+datetime+'.2DS'
    fname=fname+datetime+'.2DSCPI'

    OpenR, lun, fname, /Get_Lun

    ; draw the graph in the Strip Widget
    Widget_Control, strip_info.stripID, Get_Value=wid
    WSet, wid

    ;!P.MULTI = [0, 1, 1, 0, 0]; added this by mo januray 4, 2006
    erase,color='ffffff'x  ; get background to white
    redcolor = GetColor("Red", !D.Table_Size-2)

    ; Initialize our variables for the display
    yoffset = 0
    firstnano = 0ULL
    lastnano = 0ULL
    strip_index = 0U

    ;stop
    FOR i=0U,number_left-1 DO BEGIN  ; the number_left is not neccessary equal to n_elements(stripdata(*)).

        if (HL1size_array(i) GT 0) then begin  ;------------------ ; at begining yoffset=0, as it goes, yoffset increases.
            if firstnano eq 0ULL then firstnano =min([HNanoseconds_array(i),VNanoseconds_array(i)])
            Cond1=(yoffset + HL1size_array(i) + 1) GT !STRIP_WIDTH
            Cond2=(yoffset + VL1size_array(i) + 1) GT !STRIP_WIDTH
            cond3= (i lt number_left-1)
            if (cond1 or cond2) and cond3 then begin  ;util yoffset reached teh stripwidth.
                lastnano =max([HNanoseconds_array(i),HNanoseconds_array(i)])
                foffset =[Hfoffsets_array(i+1),Vfoffsets_array(i+1)]
                ;  i = uint(number_left + 100) ; this stops teh for loop.
                !StereoFOFFSET = foffset
                break
            end else begin ; only fill up to the top of the strip

                Slices = HL1size_array(i)
                WordCount = HImgWord_array(i)

                Image_data = BytArr(WordCount * 2)
                out_byte_array = BytArr(128L, Slices)

                POINT_LUN, lun, HfOffsets_array(i)
                ReadU, lun, Image_data

                HSums=intarr(Slices)
                HMax  = 0
                Area = 0UL
                Midpoint = 0
                Edges = 0
                L3 = 0.0
                L4 = 0
                L5 = 0
                PC3x = 0.0
                PC3y = 0.0
                PC4x = 0.0
                PC4y = 0.0
                A3 = 0.0
                Roundness1 = 0.0
                Roundness2 = 0.0
                Roundness3 = 0.0
                L1r = 0.0
                maxLength = 0.0
                maxWidth  = 0.0
                perimeter = 0UL
                perimeterum = 0.
                csp = 0.
                num_satellites = 0.

                Err=0
                ;ProcessParticle, Image_data, out_array, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , $
                ;                 L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp

                HorV = 'H'

                ProcessParticle, Image_data, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , $
                    L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp, $
                    ml_p1x=ml_p1x, ml_p1y=ml_p1y, ml_p2x=ml_p2x, ml_p2y=ml_p2y, mw_p1x=mw_p1x, mw_p1y=mw_p1y, mw_p2x=mw_p2x, mw_p2y=mw_p2y, $
                    perimeter_points_x=perimeter_points_x, perimeter_points_y=perimeter_points_y, HorV=HorV


                tv, ROTATE(out_byte_array, !IMAGE_ROTATION), yoffset, 0

                ;get V stero-iamge

                WordCount = VImgWord_array(i)
                Slices = VL1size_array(i)

                Image_data = BytArr(WordCount * 2)
                out_array = BytArr(16L * Slices)
                out_byte_array = BytArr(128L, Slices)

                POINT_LUN, lun, VfOffsets_array(i)
                ReadU, lun, Image_data

                HSums=intarr(Slices)
                HMax  = 0
                Area = 0UL
                Midpoint = 0
                Edges = 0
                L3 = 0.0
                L4 = 0
                L5 = 0
                PC3x = 0.0
                PC3y = 0.0
                PC4x = 0.0
                PC4y = 0.0
                A3 = 0.0
                Roundness1 = 0.0
                Roundness2 = 0.0
                Roundness3 = 0.0
                L1r = 0.0
                maxLength = 0.0
                maxWidth  = 0.0
                perimeter = 0UL
                perimeterum = 0.
                csp = 0.

                Err=0

                HorV = 'V'

                ;ProcessParticle, Image_data, out_array, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , $
                ;                 L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp
                ;out_byte_array = out_byte_array(*,0:OD.ImageWords-1)
                ProcessParticle, Image_data, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , $
                    L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp, $
                    ml_p1x=ml_p1x, ml_p1y=ml_p1y, ml_p2x=ml_p2x, ml_p2y=ml_p2y, mw_p1x=mw_p1x, mw_p1y=mw_p1y, mw_p2x=mw_p2x, mw_p2y=mw_p2y, $
                    perimeter_points_x=perimeter_points_x, perimeter_points_y=perimeter_points_y, HorV=HorV


                tv, ROTATE(out_byte_array, !IMAGE_ROTATION), yoffset, 132

                ; Save the pertinent data for each tick on the graph for later display
                FOR z=yoffset, (yoffset + max([HL1size_array(i),VL1size_array(i)])+1) DO BEGIN
                    if (z LT !STRIP_WIDTH) then  begin
                        SHStripData(z)  =(*alldataH)(Huse_index(i))
                        SVStripData(z) =(*alldataV)(Vuse_index(i))
                    endif
                ENDFOR
                yoffset += max([HL1size_array(i),VL1size_array(i)]) + 1
                foffset=[Hfoffsets_array(i),Vfoffsets_array(i)]; allways update it utile the last particle of the strip
            endelse
        end  ; end of if L1 size gt 0  -------------------------------------------
    ENDFOR

    if (i EQ number_left) then lastnano = max([HNanoseconds_array(i-1),VNanoseconds_array(i-1)])
    Close ,lun
    Free_Lun,lun


    ;dislay a color line to devide H and V particles.
    myline_byte_array=bytarr(3,1000,2)
    myline_byte_array(0,*,0)=255
    tv,myline_byte_array,0,128,true=1

    Widget_Control, strip_info.stripBase, BASE_SET_TITLE="Zoomed: Showing stereo pairs from " +$
        SPEC_Nano2HMS(firstnano) + " to " +  SPEC_Nano2HMS(lastnano) + $
        "   Top:V-Image; Bottom:H-Image; Tshift=0, H-V-centers dT=2, Lpercent=0.5"

    if (direction EQ -1) then !stereoFOFFSET = reverse_foffset
    if (direction EQ 1) then !stereoFoffset = foffset
    return, foffset
end ; end of fill_avearged_strip,offset,ave_info,info,direction
;***********************************************************************************************





