pro plot_event,event

    err=0
    catch,err
    if(err ne 0)then begin
        PRINT, 'Error message:', !ERR_STRING
        help,/trace
        ;widget_control,event.top,set_uvalue=StateInfo,/no_copy
        return
    endif

    WIDGET_CONTROL, event.top, GET_UVALUE=pStateInfo

    if(checkhasp((*pStateInfo).HaspFile) eq 0)then begin
        ; no hasp dongle
        r = dialog_message('Install a valid HASP key')
        return
    endif

    if(ptr_valid((*pStateInfo).pFrameData) and event.press eq 1)then begin  ; this needs to be a defined structure to continue
        WIDGET_CONTROL, event.top, /HOURGLASS

        ; Update ROI params to file?
        IF((*pStateInfo).UpdateFile) THEN UpdateBlock, pStateInfo

        ; convert cursor to a frame number
        index = convert_coord(event.x,event.y,/to_data,/device)

        print,event.x,index
        ; plot line on series
        wset,(*pStateInfo).plotID

        tempp = !P

        !P = !poriginal

        plot,*((*pStateInfo).pConc),xstyle = 1,ystyle=8,psym=10,ymargin=[2,.1],xmargin=[0,0]
        plots,[index[0],index[0]],[0,100],color=220

        !P = tempp

        wset,(*pStateInfo).MViewID
    endif

    ;  (*pStateInfo).ImgPos = index[0]
    ;  WIDGET_CONTROL, (*pStateInfo).ImgSliderID, SET_VALUE=(*pStateInfo).ImgPos

    ; get the list of frames to use ( this is set via *pImgPosIndx which may have backgrounds depending on gui setting)
    ;  ImgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]

    ; delete current frame
    ;  delete_frame,(*pStateInfo).pFrameData

    ; get the frame indicated via position in scan list
    ;  frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,(ImgList[(*pStateInfo).ImgPos-1]).fpos)

    ; display frame time
    ;  frame_time = convertFromSeconds(frameData.frameheader.Time,(*pStateInfo).fileHead.year)
    ;  frame_time.msec  = ROUND(CalcStrobeTime(frameData.frameheader.ArrivalT1, frameData.frameheader.ArrivalT2))

    ;  msg = 'Frame time:' + strtrim(fix(frame_time.day),2) + ':' + strtrim(fix(frame_time.hour),2) $
    ;    + ':' + strtrim(fix(frame_time.minute),2) + ':'+  strtrim(fix(frame_time.sec),2) + ':'+  strtrim(fix(frame_time.msec),2) + ' Missed Particles: ' + strtrim(FrameData.frameHeader.Missed -1,2)
    ;  ShowMsg, (*pStateInfo).InstLabel,msg

    ; initally, no background removed
    ;  (*pStateInfo).backRemoved = !false

    ; save into state structure pFrameData always holds the current frame
    ;  (*pStateInfo).pFrameData = ptr_new(frameData,/no_copy)

    ;  if((*pStateInfo).Bkgs_exist and (*pStateInfo).BkgPos ge 0)then begin
    ; determine if the current background is still the best
    ;   position = (*pStateInfo).ImgPos-1
    ;   if(ptr_valid((*pStateInfo).pBackPosIndx))then get_best_backGnd_pos,*(*pStateInfo).pFileScan, *(*pStateInfo).pBackPosIndx, position
    ;   if(position ne (*pStateInfo).BkgPos)then begin
    ;       BackFrame = read_backGnd((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,*(*pStateInfo).pFileScan, position)    ; contains the structure of the background
    ;       ;ShowMsg, (*pStateInfo).InstLabel,'Current Background at Position# '+ strtrim(position,2)
    ;       (*pStateInfo).BackFrame = ptr_new(BackFrame,/no_copy)
    ;       (*pStateInfo).BkgPos =  position
    ;   endif
    ;  endif

    ; set min/max to gui ( this removes a background if needed )
    ;  set_min_max, pStateInfo

    ; Show main info line
    ;  disp_frame_info, pStateInfo, 0

    ; now display frame

    ; now display frame
    ;  if((*pStateInfo).displayPerim)then begin
    ; if an object file exist toggle perimeter
    ;   if(ptr_valid((*pStateInfo).pObjList))then begin

    ;       objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[(*pStateInfo).ImgPos-1].fPos)
    ;       ROI_Count = objData.Frameheader.ROIsCount
    ;       pBoundary = ptrarr(ROI_count)

    ;       for index = 0,ROI_count-1 do begin
    ;          header = (*objData.pFrame)[index].imageheader
    ;          if(header.bound_len ne 0)then pBoundary[index] = header.boundary
    ;       endfor

    ;       delete_obj_header,objData

    ; redraw frame
    ;       tvlct,255,255,0,255
    ;       bounds = DispFrame(pStateInfo,pBoundary=pBoundary)

    ;   endif
    ;  endif else begin
    ; redraw frame
    ;   tvlct,255,255,255,255
    ;   bounds = DispFrame(pStateInfo)
    ;  endelse

    ;  ptr_free,(*pStateInfo).pBounds
    ;  (*pStateInfo).pBounds =  ptr_new(bounds)

    ; plot line on series
    ;  wset,(*pStateInfo).plotID
    ;  plot,*((*pStateInfo).pConc),xstyle = 1,ystyle=8,psym=10,ymargin=[.1,.1],xmargin=[.1,.1]
    ;  plots,[(*pStateInfo).ImgPos,(*pStateInfo).ImgPos],[0,100],color=255
    ;  wset,(*pStateInfo).MViewID

    ;endif

    ; Must be done every time to return structure to widget
    ;WIDGET_CONTROL, event.top, SET_UVALUE=pStateInfo, /NO_COPY

end
