pro read_sorted_data_file

    DEFSYSV, '!NO_CHART', 0
    DEFSYSV, '!H_CHART', 1
    DEFSYSV, '!V_CHART', 2
    DEFSYSV, '!HOURGLASS_CURSOR' , 32514
    DEFSYSV, '!ARROW_CURSOR' , 32512
    DEFSYSV, '!STRIP_WINDOW' , 3
    DEFSYSV, '!STRIP_WIDTH' , 1000 ; 600
    DEFSYSV, '!CHAR_SIZE' , 0.4
    DEFSYSV, '!CurrentHPname' , ''
    DEFSYSV, '!CurrentHFname' , ''
    DEFSYSV, '!CurrentVPname' , ''
    DEFSYSV, '!CurrentVFname' , ''
    DEFSYSV, '!FOFFSET', 0UL  ; default to start of file
    DEFSYSV, '!StereoFOFFset',[0UL,0UL]
    DEFSYSV, '!CRLF', string(13B) + string(10B)
    DEFSYSV, '!CURRENT_CHANNEL' , 1   ; 0=none, 1=horiz, 2=vert
    DEFSYSV, '!ZOOM_STATE' , 0b
    DEFSYSV, '!ZOOM_START_INDEX_H',0L
    DEFSYSV, '!ZOOM_END_INDEX_H', 0L
    DEFSYSV, '!ZOOM_START_INDEX_V',0L
    DEFSYSV, '!ZOOM_END_INDEX_V', 0L
    DEFSYSV, '!ZOOM_START_STRING' , ""
    DEFSYSV, '!ZOOM_END_STRING' , ""
    DEFSYSV, '!ZOOM_START_BIN_1HZ',0L
    DEFSYSV, '!ZOOM_END_BIN_1HZ', 0L
    DEFSYSV, '!DEADTIME_START_FLAG' , -100
    DEFSYSV, '!DEADTIME_END_FLAG' ,   -101
    DEFSYSV, '!MASK_START_FLAG' ,     -102
    DEFSYSV, '!MASK_END_FLAG' ,       -103
    DEFSYSV, '!TAS_FLAG' ,            -104
    DEFSYSV, '!CURRENT_VERSION',       1.0

    DEFSYSV, '!PLAYBACK_ACTIVE' , 1
    DEFSYSV, '!REWIND_ACTIVE' , 1
    DEFSYSV, '!PLAYBACK_SPEED', 0.10
    DEFSYSV, '!HI_LO_STATE' , 0   ; 0=low, 1=high

    DEFSYSV, '!ZOOM_START_NS',0ULL
    DEFSYSV, '!ZOOM_END_NS', 0ULL

    inputfile=dialog_pickfile(filter='*sorted*.2ds')

    OpenR, lun, inputfile, /Get_Lun

    info={totalParticles:0UL}
    info.TotalParticles=0UL
    errcount = 0L

    struct = {_DerivedDataRev2, $
        PartID: 0 , $
        Nanosecsold:0ULL , $
        NanoSeconds:0ULL , $
        ImageOffset: 0UL , $
        ImageWords: 0 , $
        Area: 0.0 , $
        Nslice: 0 , $
        L2: 0 , $
        F1: 0 , $
        Adj1: 0.0, $
        Pc1: 0.0, $
        TAS: 0.0, $
        ProbeCounter:0ULL, $
        L3: 0.0, $
        L4: 0, $
        L5: 0, $
        PC3x: 0.0, $
        PC3y: 0.0, $
        PC4x: 0.0, $
        PC4y: 0.0, $
        A3: 0.0, $
        Alexei1: 0.0, $
        Alexei2: 0L, $
        reject: byte(0), $
        w8_t: 0LL, $
        L7: 0.0, $
        L8: 0.0, $
        roundness: 0.0, $
        focus: 0.0, $
        warn: 0.0, $  ; some day we will change this to byte value to svae memory.
        adj0: 1.0, $  ;added on May 8-2007 for w8_t cleaning.
        noisebyte:byte(0),$;; added in June 2007.
        AccDTtick:0ULL,$   ; added on oct5 2007
        w8_t_clean:0LL, $; added on oct5,2007.
        L1n: 0.0, $;    ; added on nov 9, 2007.
        largest_satellite_area: 0.0, $    ;added dec19,2007
        alexei1old: 0.0, $ ;added dec19,2007
        TASold: 0.0, $    ; added dec19,2007
        Spare_16: 0.0, $
        Spare_17: 0.0, $
        Spare_18: 0.0, $
        Spare_19: 0.0, $
        Spare_20: 0.0, $
        CPI_trigger: 0}

    ;struct = {_DerivedDataRev2, $
    ;          Nanosecsold:0ULL , $
    ;          NanoSeconds:0ULL , $
    ;          ImageOffset: 0UL , $
    ;          ImageWords: 0 , $
    ;          Area: 0.0 , $
    ;          Nslice: 0 , $
    ;          L2: 0 , $
    ;          F1: 0 , $
    ;          Adj1: 0.0, $
    ;          Pc1: 0.0, $
    ;          TAS: 0.0, $
    ;          ProbeCounter:0ULL, $
    ;          L3: 0.0, $
    ;          L4: 0, $
    ;          L5: 0, $
    ;          PC3x: 0.0, $
    ;          PC3y: 0.0, $
    ;          PC4x: 0.0, $
    ;          PC4y: 0.0, $
    ;          A3: 0.0, $
    ;          Alexei1: 0.0, $
    ;          Alexei2: 0L, $
    ;          reject: byte(0), $
    ;          w8_t: 0LL, $
    ;          L7: 0.0, $
    ;          L8: 0.0, $
    ;          roundness: 0.0, $
    ;          focus: 0.0, $
    ;          warn: 0.0, $  ; some day we will change this to byte value to svae memory.
    ;          adj0: 1.0, $  ;added on May 8-2007 for w8_t cleaning.
    ;          noisebyte:byte(0),$;; added in June 2007.
    ;          AccDTtick:0ULL,$   ; added on oct5 2007
    ;          w8_t_clean:0LL, $; added on oct5,2007.
    ;          L1n: 0.0, $;    ; added on nov 9, 2007.
    ;          largest_satellite_area: 0.0, $    ;added dec19,2007
    ;          alexei1old: 0.0, $ ;added dec19,2007
    ;          TASold: 0.0, $    ; added dec19,2007
    ;          Spare_16: 0.0, $
    ;          Spare_17: 0.0, $
    ;          Spare_18: 0.0, $
    ;          Spare_19: 0.0, $
    ;          Spare_20: 0.0}
    ;add this tempary to fix the bug for generating the zoomed ascii
    ;**************************************************************************
    struct_ascii = {_AsciiData, $
        Nanosecsold:0ULL , $
        NanoSeconds:0ULL , $
        Area: 0.0 , $
        Nslice: 0 , $
        L2: 0 , $
        F1: 0 , $
        Adj1: 0.0, $
        Pc1: 0.0, $
        TAS: 0.0,$    ;added more in the following on oct 14 , 2005 by mo for outputing ascii data file.
        ProbeCounter:0ULL, $
        L3: 0.0, $
        L4: 0, $
        L5: 0, $
        PC3x: 0.0, $
        PC3y: 0.0, $
        PC4x: 0.0, $
        PC4y: 0.0, $
        A3: 0.0, $
        Alexei1: 0.0, $
        Alexei2: 0L,$
        L1n:0.0, $;  added nov 9, 2007.
        largest_satellite_area: 0.0, $    ;added dec19,2007
        alexei1old: 0.0, $ ;added dec19,2007
        TASold: 0.0 $    ; added dec19,2007
        }


    ;***************************************************************************



    struct2 = {_Timestamp, $
        Year: 0, $
        Month: 0, $
        Day: 0, $
        Hours: 0, $
        Minutes: 0, $
        Seconds: 0, $
        Milliseconds: 0, $
        Microseconds: 0, $
        Nanoseconds: 0 }

    horiz_count=0
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL
    NanosecondsPerDay    = NanosecondsPerHour * 24ULL
    out_array = BytArr(20000)


    ;Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure

    ;get the sorted file's starttime and endtime
    substrs=strsplit(inputfile,'\',/extract)
    sortedFileName=substrs(n_elements(substrs)-1)
    datetimestring=strmid(sortedFilename,6,strlen(sortedfilename)-9); =yymmddhhmmss_hhmmss_hhmmss_000x
    if strlen(datetimestring) eq 32 then begin
        subtrs=strsplit(datetimestring,'_',/extract)
        Stime=subtrs(1)
        Etime=subtrs(2)
        FSTime=(strmid(Stime,0,2)*3600LL+strmid(Stime,2,2)*60LL+strmid(Stime,4,2)*1LL)*1000000000;nanoseconds
        FETime=(strmid(Etime,0,2)*3600LL+strmid(Etime,2,2)*60LL+strmid(Etime,4,2)*1LL)*1000000000
    endif;     FStime is full-seconds say: 50045000000000LL nanoseconds. FEtime ends with 12345.999999999
    WriteH_OK=0; once the the first double-fake particle's time is readed, it is Ok to write to the bin file.
    WriteV_Ok=0


    ; Put the info structure back in its storage location.

    OpenR, lun, inputfile, /Get_Lun

    fileheader = bytarr(256)
    ReadU, lun, fileheader
    v_string = strmid(string(fileheader),4,4)
    reads, v_string, FORMAT='(%"%f")',cur_version
    if (cur_version ne 3.0) then begin
        r = dialog_message(['Warning, file you have selected is not a REV 3 SORTED file!','Use an older version of 2DSView to process this file..'],TITLE = 'File incompatible')
        close, lun
        return
    endif

    ;===========================================================
    ; Create Headers for the Ver 3.0 files
    ;===========================================================
    vheader = bytarr(256)
    vheader(*)=32 ; all spaces
    sheader = string(vheader)
    strput,sheader,'Ver 3.00 BIN PARTICLE DATA',0  ; put info on the front

    DataType = 0  ; header of all record types is an integer with repeated letters
    TimingWord = UIntArr(2)
    StartTimingWord = UIntArr(2)
    EndTimingWord = UIntArr(2)
    Masks = UIntArr(16)
    HK_ints = UIntArr(48)   ; changed from 40->52 with version 5.0
    HK_timingwords = UIntArr(2)
    HK_TAS  = 0.0
    TAS = 0.0
    Tas_H=0.0
    Tas_V=0.0
    PartID = 0
    Slices = 0U
    WordCount =  0U
    Timestamp = { _Timestamp }
    HTimestamp = { _Timestamp }
    VTimestamp = { _Timestamp }
    StartTimestamp = { _Timestamp }
    EndTimestamp = { _Timestamp }
    pos = 0UL
    Area = 0UL
    Midpoint = 0
    Edges = 0
    pxs = 0.01
    pxs_in_microns = 10.0
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    sa_default = 128.0 * pxs *  dww
    strbsz = 0.01
    Rollover = 0 ; 16 bit integer
    Rollover2= 0;  16 bit integer
    ProbeCount = 0uL ; 32 bit unsigned
    ProbeCount2 = 0uL ; 32 bit unsigned
    temp_64 = 0ULL ; 32 bit result
    OneRollover = 4294967296ULL  ; 2^32
    onebyte = 33B

    L3 = 0.0
    L4 = 0
    L5 = 0
    PC3x = 0.0
    PC3y = 0.0
    PC4x = 0.0
    PC4y = 0.0
    A3 = 0.0
    lastH=10; keep a record of the last H particle written to the bin file.  possible values
    ; are 0, -104, -103, -101, -106, -108. 0 means it is a good particle. for wipe off decision.
    lastV=10

    ;********************************************************
    OD = {_DerivedDataRev2}
    OD_block_size= N_TAGS( OD , /DATA_LENGTH )
    ;added above so that bad-data can be deleted. Oct 4, 2006.--by mo
    ;******************************************************
    backward=0

    counter = 0L

    WHILE ~ EOF(lun) DO BEGIN

        counter++
        ;if counter GT 67254L then begin
        ;print, format='(Z4)',DataType
        ; print, counter
        ;end

        ReadU, lun, DataType


        SWITCH DataType OF
            ;----------------------------
            ;added this block to handle new type of dummy particles that Chris added in september
            ;19th 2006, for those bad images ----tick or time is not monotonic.

            ; The 4 new deadtime indicaters are defined as:

            ;  V_DUMMY_DEADTIME_HEADER = &H1414 ' 5140 decimal   ; treat them as normal deadtime
            ;  H_DUMMY_DEADTIME_HEADER = &H1424 ' 5156 decimal   ; treat them as normal deadtime
            ;  V_BACKUP_DEADTIME_HEADER = &H2414 ' 9236 decimal  ; when I see this, throw out earlier
            ;  H_BACKUP_DEADTIME_HEADER = &H2424 ' 9252 decimal  ; raeded H or V particles.

            5156: $    ;this way all dummy_dead_times are assigned as mask_flags.
                print , "H Dummmy_deadtime_header"
            6425: $;   H_streaker_deadTime_header; no mre backup type anymore.
                begin
            if datatype eq 6425 then  print, 'H_streaker_DEADTIME_HEADER'
            ; do delete last readed in H-particles from the array.
            ; point_lun,-horiz_lun, current_posH
            ; point_lun, horiz_lun,current_posH-OD_block_size
            ;    stop
            ; truncate_lun,Horiz_lun;   after we truncate it, we replaced it with the deadtime mark from the sorted
            ;    stop
            ;write out new type of fake particles -105 -106 for area
            ReadU, lun, StartTimestamp,EndTimestamp
            ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2

            OD = {_DerivedDataRev2}


            OD.NanoSeconds = StartTimestamp.Nanoseconds + $
                (StartTimestamp.Microseconds * 1000ULL) + $
                (StartTimestamp.Milliseconds * 1000000ULL) + $
                (StartTimestamp.Seconds * NanosecondsPerSecond) + $
                (StartTimestamp.Minutes * NanosecondsPerMinute) + $
                (StartTimestamp.Hours * NanosecondsPerHour)

            OD.Nanosecsold=OD.nanoseconds
            OD.ImageOffset = 0UL
            OD.ImageWords = 0L
            if datatype eq 5156 then OD.Area = -105 else OD.area=-107; -107 is bad type_6425
            OD.Nslice = 0
            OD.L2 = 0
            OD.F1 = 0
            OD.Adj1 = 0.0
            OD.Pc1 = 0.0
            OD.TAS = tas_H;  added "+tas" by mo at oct 5, 2006.

            OD.ProbeCounter = Rollover * OneRollover + ProbeCount

            tick5=OD.probecounter;  mo added this for debug.
            ;if OD.tas gt 0.0 then $
            ;WRITEU, horiz_lun, OD
            OD0=OD

            OD.NanoSeconds = EndTimestamp.Nanoseconds + $
                (EndTimestamp.Microseconds * 1000ULL) + $
                (EndTimestamp.Milliseconds * 1000000ULL) + $
                (EndTimestamp.Seconds * NanosecondsPerSecond) + $
                (EndTimestamp.Minutes * NanosecondsPerMinute) + $
                (EndTimestamp.Hours * NanosecondsPerHour)

            OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
            OD.ImageOffset = 0UL
            OD.ImageWords = 0L
            if datatype eq 5156 then OD.Area = -106 else OD.area=-108; -108 is bad type_6425
            OD.Nslice = 0
            OD.L2 = 0
            OD.F1 = 0
            OD.Adj1 = 0.0
            OD.Pc1 = 0.0
            OD.TAS = tas_H
            OD.ProbeCounter = Rollover2 * OneRollover + ProbeCount2
            tick6=OD.probecounter
            if OD.probecounter lt OD0.probecounter then begin
                OD.probecounter=OD0.probecounter
                OD.nanoseconds =OD0.nanoseconds
                OD.area=OD.area-100
                OD0.area=OD0.area-100
                print,OD0.area,': ',rollover, probecount
                print, OD.area,': ',rollover2, probecount2
                printf,22,'at time=',OD.nanoseconds,' H Fake pair"s  end-tick less than start-tick  '
            endif
            lastH=-106;  -106 and -108 is of the same type.

            ; print,rollover, probecount
            ;print,rollover2, probecount2
            ;stop
            break
        end  ; end of H-backup-deadtime particles.
        ;***********************************************************************************
        9252: $;   H_backup_deadTime_header
            begin
        print, 'H_Backup_DEADTIME_HEADER'

        ; do delete last readed in V-particles from the array.
        if lastH eq 0 then begin;  just romved one particle which is a good particle but time is wrong.
            ; point_lun,-horiz_lun, current_posH;   get the current file pointer position.
            ; point_lun, horiz_lun,current_posH-OD_block_size;  Note that OD_block_size is assigned
            ;block_size =174 bytes , it changes depending *****
            ; truncate_lun,Horiz_lun
            print,'truncate one Hs'
            wait,2
        endif

        if lastH ne -104 and lastH lt 0 then begin;  need to remove the last pair of fake particles.
            ;point_lun,-horiz_lun, current_posH
            ;point_lun, horiz_lun,current_posH-2*OD_block_size;  Note that OD_block_size is assigned
            ;block_size =163 bytes ?
            ;truncate_lun,Horiz_lun
            print,'truncate 2 Hs   lastH=',lastH
            wait,2
        endif

        ; begin reading the two time stamps and counts to write two bad particles.

        ReadU, lun,  StartTimestamp,EndTimestamp
        ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
        OD = {_DerivedDataRev2}


        OD.NanoSeconds = StartTimestamp.Nanoseconds + $
            (StartTimestamp.Microseconds * 1000ULL) + $
            (StartTimestamp.Milliseconds * 1000000ULL) + $
            (StartTimestamp.Seconds * NanosecondsPerSecond) + $
            (StartTimestamp.Minutes * NanosecondsPerMinute) + $
            (StartTimestamp.Hours * NanosecondsPerHour)
        OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
        OD.ImageOffset = 0UL
        OD.ImageWords = 0L
        OD.Area = -109
        OD.Nslice = 0
        OD.L2 = 0
        OD.F1 = 0
        OD.Adj1 = 0.0
        OD.Pc1 = 0.0
        OD.TAS = tas_H
        OD.ProbeCounter = Rollover * OneRollover + ProbeCount
        ;if OD.tas gt 0.0 then $
        ;WRITEU, horiz_lun, OD
        OD0=OD

        OD.NanoSeconds = EndTimestamp.Nanoseconds + $
            (EndTimestamp.Microseconds * 1000ULL) + $
            (EndTimestamp.Milliseconds * 1000000ULL) + $
            (EndTimestamp.Seconds * NanosecondsPerSecond) + $
            (EndTimestamp.Minutes * NanosecondsPerMinute) + $
            (EndTimestamp.Hours * NanosecondsPerHour)
        OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
        OD.Area = -110
        OD.ProbeCounter = Rollover2 * OneRollover + ProbeCount2
        ;if OD.tas gt 0.0 then $
        if OD.probecounter lt OD0.probecounter then begin
            OD.probecounter=OD0.probecounter
            OD.nanoseconds =OD0.nanoseconds
            OD.area=OD.area-100
            OD0.area=OD0.area-100
            print,OD0.area,': ',rollover, probecount
            print, OD.area,': ',rollover2, probecount2
            ;printf,22,'at time=',OD.nanoseconds,' H Fake pair"s  end-tick less than start-tick  '
        endif
        lastH=-110

        break
    end; end of wipping off H-bad non_monotonic data and puting a deadtime pair inside.

    27756 :$   ; H_DEADTIME (0x6C6C)
        print , "H DEADTIME"
    7196 : $   ; H_MASK (0x1C1C)
        begin
    ReadU, lun, StartTimestamp,EndTimestamp
    ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2

    if probecount2 eq probecount and rollover eq rollover2  then begin
        break;  added this for verion 992 on Dec 15, 2006.
    endif

    if datatype eq 7196 then  print , "H MASK"
    OD = {_DerivedDataRev2}

    OD.NanoSeconds = StartTimestamp.Nanoseconds + $
        (StartTimestamp.Microseconds * 1000ULL) + $
        (StartTimestamp.Milliseconds * 1000000ULL) + $
        (StartTimestamp.Seconds * NanosecondsPerSecond) + $
        (StartTimestamp.Minutes * NanosecondsPerMinute) + $
        (StartTimestamp.Hours * NanosecondsPerHour)

    OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
    OD.ImageOffset = 0UL
    OD.ImageWords = 0L
    if DataType eq 27756 then OD.Area = !DEADTIME_START_FLAG else OD.Area = !MASK_START_FLAG
    OD.Nslice = 0
    OD.L2 = 0
    OD.F1 = 0
    OD.Adj1 = 0.0
    OD.Pc1 = 0.0
    OD.TAS = tas_H;  added "+tas" by mo at oct 5, 2006.
    OD.ProbeCounter = Rollover * OneRollover + ProbeCount
    Tick0=OD.probecounter

    ;WRITEU, horiz_lun, OD
    OD0=OD


    OD.NanoSeconds = EndTimestamp.Nanoseconds + $
        (EndTimestamp.Microseconds * 1000ULL) + $
        (EndTimestamp.Milliseconds * 1000000ULL) + $
        (EndTimestamp.Seconds * NanosecondsPerSecond) + $
        (EndTimestamp.Minutes * NanosecondsPerMinute) + $
        (EndTimestamp.Hours * NanosecondsPerHour)

    OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
    OD.ImageOffset = 0UL
    OD.ImageWords = 0L
    if DataType eq 27756 then OD.Area = !DEADTIME_END_FLAG else OD.Area = !MASK_END_FLAG
    OD.Nslice = 0
    OD.L2 = 0
    OD.F1 = 0
    OD.Adj1 = 0.0
    OD.Pc1 = 0.0
    OD.TAS = tas_H
    OD.ProbeCounter = Rollover2 * OneRollover + ProbeCount2

    if OD.probecounter lt OD0.probecounter then begin
        OD.probecounter=OD0.probecounter
        OD.nanoseconds =OD0.nanoseconds
        OD.area=OD.area-100
        OD0.area=OD0.area-100
        print,OD0.area,': ',rollover, probecount
        print, OD.area,': ',rollover2, probecount2
        printf,22,'at time=',OD.nanoseconds,' H Fake pair"s  end-tick less than start-tick  '
    endif

    lastH=-103;   -101 and -103 is the of the same type.

    break
end ; end of H-dead_time and H-mask

5140: $   ; V_DUMMY_DEADTIME_HEADER = &H1414 ' 5140 decimal
    print, 'V_DUMMY_DEADTIME_HEADER'
6168: $;   H_streaker_deadTime_header; no mre backup type anymore.
    begin
if datatype eq 6168 then  print, 'V_streaker_DEADTIME_HEADER'
; begin reading the two time stamps and counts to write two bad particles.
ReadU, lun,  StartTimestamp,EndTimestamp
ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
OD = {_DerivedDataRev2}


OD.NanoSeconds = StartTimestamp.Nanoseconds + $
    (StartTimestamp.Microseconds * 1000ULL) + $
    (StartTimestamp.Milliseconds * 1000000ULL) + $
    (StartTimestamp.Seconds * NanosecondsPerSecond) + $
    (StartTimestamp.Minutes * NanosecondsPerMinute) + $
    (StartTimestamp.Hours * NanosecondsPerHour)
OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
OD.ImageOffset = 0UL
OD.ImageWords = 0L
if DataType eq 5140 then OD.Area = -105 else OD.Area =-107; ;-108 is V-streaker.
OD.Nslice = 0
OD.L2 = 0
OD.F1 = 0
OD.Adj1 = 0.0
OD.Pc1 = 0.0
OD.TAS =tas_V
OD.ProbeCounter = Rollover * OneRollover + ProbeCount
tick5=OD.probecounter

;WRITEU, vert_lun, OD
OD0=OD

OD.NanoSeconds = EndTimestamp.Nanoseconds + $
    (EndTimestamp.Microseconds * 1000ULL) + $
    (EndTimestamp.Milliseconds * 1000000ULL) + $
    (EndTimestamp.Seconds * NanosecondsPerSecond) + $
    (EndTimestamp.Minutes * NanosecondsPerMinute) + $
    (EndTimestamp.Hours * NanosecondsPerHour)

OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
OD.ImageOffset = 0UL
OD.ImageWords = 0L
if DataType eq 5140 then OD.Area = -106 else OD.Area =-108; ;-108 is for backuptype Bad.
OD.Nslice = 0
OD.L2 = 0
OD.F1 = 0
OD.Adj1 = 0.0
OD.Pc1 = 0.0
OD.TAS =TAS_V; added this "+tas" by mo on Oct 5, 2006.
OD.ProbeCounter = Rollover2 * OneRollover + ProbeCount2
if OD.probecounter lt OD0.probecounter then begin
    OD.probecounter=OD0.probecounter
    OD.nanoseconds =OD0.nanoseconds
    OD.area=OD.area-100
    OD0.area=OD0.area-100
    print,OD0.area,': ',rollover, probecount
    print, OD.area,': ',rollover2, probecount2
    printf,22,'at time=',OD.nanoseconds,' V Fake pair"s  end-tick less than start-tick  '
endif

lastV=-106
break
end; end of type1 and type1 V Bad Particles.
;----------------------------
9236: $;   V_backup_deadTime_header
    begin
print, 'V_Backup_DEADTIME_HEADER'

; do delete last readed in V-particles from the array.
if lastV eq 0 then begin;  just romved one particle which is a good particle but time is wrong.
    ;point_lun,-vert_lun, current_posV
    ;point_lun, vert_lun,current_posV-OD_block_size;  Note that OD_block_size is assigned
    ;block_size =163 bytes ?
    ;truncate_lun,vert_lun
endif
if lastV ne -104 and lastV lt 0 then begin;  need to remove the last pair of fake particles.
    ;point_lun,-vert_lun, current_posV
    ;point_lun, vert_lun,current_posV-2*OD_block_size;  Note that OD_block_size is assigned
    ;block_size =163 bytes ?
    ;truncate_lun,vert_lun
endif
;****************************

; begin reading the two time stamps and counts to write two bad particles.

ReadU, lun,  StartTimestamp,EndTimestamp
ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
OD = {_DerivedDataRev2}

OD.NanoSeconds = StartTimestamp.Nanoseconds + $
    (StartTimestamp.Microseconds * 1000ULL) + $
    (StartTimestamp.Milliseconds * 1000000ULL) + $
    (StartTimestamp.Seconds * NanosecondsPerSecond) + $
    (StartTimestamp.Minutes * NanosecondsPerMinute) + $
    (StartTimestamp.Hours * NanosecondsPerHour)
OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
OD.ImageOffset = 0UL
OD.ImageWords = 0L
OD.Area = -109
OD.Nslice = 0
OD.L2 = 0
OD.F1 = 0
OD.Adj1 = 0.0
OD.Pc1 = 0.0
OD.TAS = tas_V
OD.ProbeCounter = Rollover * OneRollover + ProbeCount

;WRITEU, vert_lun, OD
OD0=OD

OD.NanoSeconds = EndTimestamp.Nanoseconds + $
    (EndTimestamp.Microseconds * 1000ULL) + $
    (EndTimestamp.Milliseconds * 1000000ULL) + $
    (EndTimestamp.Seconds * NanosecondsPerSecond) + $
    (EndTimestamp.Minutes * NanosecondsPerMinute) + $
    (EndTimestamp.Hours * NanosecondsPerHour)
OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
OD.Area = -110
OD.ProbeCounter = Rollover2 * OneRollover + ProbeCount2
if OD.probecounter lt OD0.probecounter then begin
    OD.probecounter=OD0.probecounter
    OD.nanoseconds =OD0.nanoseconds
    OD.area=OD.area-100
    OD0.area=OD0.area-100
    print,OD0.area,': ',rollover, probecount
    print, OD.area,': ',rollover2, probecount2
    ;printf,22,'at time=',OD.nanoseconds,' V Fake pair"s  end-tick less than start-tick  '
endif

lastV=-110
break
end; end of wipping off bad non_monotonic data and puting a deadtime pair inside.


31868 : $   ; V_DEADTIME (0x7C7C)
    if datatype eq 31868 then print, "V DEADTIME"  ; won't compile without some statement here
11308 : $   ; V_MASK (0x2C2C)
    begin
ReadU, lun,  StartTimestamp,EndTimestamp
ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2

if probecount2 eq probecount and rollover eq rollover2  then begin
    break;  added this for verion 992 on Dec 15, 2006.
endif

OD = {_DerivedDataRev2}


OD.NanoSeconds = StartTimestamp.Nanoseconds + $
    (StartTimestamp.Microseconds * 1000ULL) + $
    (StartTimestamp.Milliseconds * 1000000ULL) + $
    (StartTimestamp.Seconds * NanosecondsPerSecond) + $
    (StartTimestamp.Minutes * NanosecondsPerMinute) + $
    (StartTimestamp.Hours * NanosecondsPerHour)

OD.Nanosecsold=OD.nanoseconds ;= StartTimestamp.Year * 12 + StartTimestamp.Month
OD.ImageOffset = 0UL
OD.ImageWords = 0L
if DataType eq 31868 then OD.Area = !DEADTIME_START_FLAG else OD.Area = !MASK_START_FLAG
OD.Nslice = 0
OD.L2 = 0
OD.F1 = 0
OD.Adj1 = 0.0
OD.Pc1 = 0.0
OD.TAS = 0.0 + tas_V
OD.ProbeCounter = Rollover * OneRollover + ProbeCount

;WRITEU, vert_lun, OD
OD0=OD

OD.NanoSeconds = EndTimestamp.Nanoseconds + $
    (EndTimestamp.Microseconds * 1000ULL) + $
    (EndTimestamp.Milliseconds * 1000000ULL) + $
    (EndTimestamp.Seconds * NanosecondsPerSecond) + $
    (EndTimestamp.Minutes * NanosecondsPerMinute) + $
    (EndTimestamp.Hours * NanosecondsPerHour)

OD.Nanosecsold=OD.nanoseconds ;= EndTimestamp.Year * 12 + EndTimestamp.Month
OD.ImageOffset = 0UL
OD.ImageWords = 0L
if DataType eq 31868 then OD.Area = !DEADTIME_END_FLAG else OD.Area = !MASK_END_FLAG
OD.Nslice = 0
OD.L2 = 0
OD.F1 = 0
OD.Adj1 = 0.0
OD.Pc1 = 0.0
OD.TAS = 0.0+TAS_V; added this "+tas" by mo on Oct 5, 2006.
OD.ProbeCounter = Rollover2 * OneRollover + ProbeCount2
if OD.probecounter lt OD0.probecounter then begin
    OD.probecounter=OD0.probecounter
    OD.nanoseconds =OD0.nanoseconds
    OD.area=OD.area-100
    OD0.area=OD0.area-100
    print,OD0.area,': ',rollover, probecount
    print, OD.area,': ',rollover2, probecount2
    ; printf,22,'at time=',OD.nanoseconds,' V Fake pair"s  end-tick less than start-tick  '
endif
lastV=-103
break
end

;----------------------------
19789 : $
    begin
ReadU, lun, TimingWord, Masks
;print , "MASK"
break
end

;----------------------------
16705 : $  ; TAS_HEADER_V
    print , "V TAS",TAS
;----------------------------
21588 : $  ; TAS_HEADER_H;  chris, is this the TAS change fake particle ? -104 ?
    BEGIN
ReadU, lun , TAS
if DataType eq 16705 then TAS_V=tas else TAS_H=tas; added thsi on Nov.28, 2006.

ReadU, lun, StartTimestamp, Rollover,ProbeCount

OD = {_DerivedDataRev2}

OD.NanoSeconds = StartTimestamp.Nanoseconds + $
    (StartTimestamp.Microseconds * 1000ULL) + $
    (StartTimestamp.Milliseconds * 1000000ULL) + $
    (StartTimestamp.Seconds * NanosecondsPerSecond) + $
    (StartTimestamp.Minutes * NanosecondsPerMinute) + $
    (StartTimestamp.Hours * NanosecondsPerHour)
OD.Nanosecsold=OD.nanoseconds ;= StartTimestamp.Year * 12 + StartTimestamp.Month
OD.ImageOffset = 0UL
OD.ImageWords = 0L
OD.Area = !TAS_FLAG
OD.Nslice = 0
OD.L2 = 0
OD.F1 = 0
OD.Adj1 = 0.0
OD.Pc1 = 0.0
OD.TAS =0.0+tas;    added this by mo.
OD.ProbeCounter = Rollover * OneRollover + ProbeCount

if (DataType eq 16705) then begin
    ;if OD.tas gt 0.0 then $

    lastV=-104
endif  else begin
    ;if OD.tas gt 0.0 then $
    lastH=-104

endelse
break
END


;----------------------------
19275 : $  ; HK_HEADER
    BEGIN
ReadU, lun , HK_ints, HK_TAS, HK_timingwords
ReadU, lun, Rollover,ProbeCount
print , "HK", HK_TAS
break
END

;----------------------------
18504 : $  ; H_PARTICLE_HEADER
    BEGIN

ReadU, lun , PartID,WordCount,Slices,Timestamp
ReadU, lun, Rollover,ProbeCount

; Slices is the number of words making up the image (can be more than the WordCount)
; WordCount is the true number of image slices
HTimestamp = Timestamp
if (WordCount GE 500) then begin
    ;print, "H WC=",Wordcount, info.TotalParticles
    WordCount = WordCount and 32767U
end

Nanoseconds=0LL
NanoSeconds = Timestamp.Nanoseconds + $
    Timestamp.Microseconds * 1000ULL + $
    Timestamp.Milliseconds * 1000000ULL + $
    Timestamp.Seconds * NanosecondsPerSecond + $
    Timestamp.Minutes * NanosecondsPerMinute + $
    Timestamp.Hours * NanosecondsPerHour
;--------------------------------------------------------------------------------------
; We'd like (in 2DS executable) to trap all goofy particles before they are placed into the SORTED
;  file but as new DSP error or data transmission errors occur, we may miss some. So
;  we are forced to double check here. If the particle slice count or integer data word
;  couint is zero, we clearly cannot proceed to create zero length arrays. However,
;  we still need to read the image, if there is one. So we force Slices =1000 to avoid
;  doing processing that would crash this program, and we ignore this particle.
;--------------------------------------------------------------------------------------
if (Wordcount gt 0 and Slices gt 0) then begin
    HImage = BytArr(WordCount * 2)
    HSums = IntArr(Slices)
    out_array = BytArr(16L * Slices)
    out_byte_array = BytArr(128L, Slices)
    HMax  = 0
endif else begin
    Slices = 1000
endelse

POINT_LUN, -lun, pos
ReadU, lun, HImage

;***********************************************************
;if OD.tas gt 0.0 then $
lastH=0
horiz_count++

; if timestamp.hours eq 15 and timestamp.minutes eq 33 and timestamp.seconds eq 45 then begin
; print,slices
; print,Himage
; print,timestamp.milliseconds
; print,OD.probecounter
;  stop
; endif


break


END

;----------------------------
22102 : $  ; V_PARTICLE_HEADER
    BEGIN
ReadU, lun, PartID,WordCount,Slices,Timestamp
ReadU, lun, Rollover,ProbeCount

; Slices is the number of words making up the image (can be more than the WordCount)
; WordCount is the true number of image slices
VTimestamp = Timestamp
if (WordCount GE 500) then begin
    ;    print, "V WC=",Wordcount, info.TotalParticles
    WordCount = WordCount and 32767U
end
Nanoseconds=0LL
NanoSeconds = Timestamp.Nanoseconds + $
    Timestamp.Microseconds * 1000ULL + $
    Timestamp.Milliseconds * 1000000ULL + $
    Timestamp.Seconds * NanosecondsPerSecond + $
    Timestamp.Minutes * NanosecondsPerMinute + $
    Timestamp.Hours * NanosecondsPerHour

;--------------------------------------------------------------------------------------
; We'd like (in 2DS executable) to trap all goofy particles before they are placed into the SORTED
;  file but as new DSP error or data transmission errors occur, we may miss some. So
;  we are forced to double check here. If the particle slice count or integer data word
;  couint is zero, we clearly cannot proceed to create zero length arrays. However,
;  we still need to read the image, if there is one. So we force Slices =1000 to avoid
;  doing processing that would crash this program, and we ignore this particle.
;--------------------------------------------------------------------------------------
if (Wordcount gt 0 and Slices gt 0) then begin
    VImage = BytArr(WordCount*2)
    VSums = IntArr(Slices)
    out_array = BytArr(16L * Slices)
    out_byte_array = BytArr(128L, Slices)
    VMax  = 0
endif else begin
    Slices = 1000
endelse

POINT_LUN, -lun, pos
ReadU, lun, VImage

;***********************************************************
lastV=0

break

END

;----------------------------
ELSE: begin
    POINT_LUN, -lun, badpos
    print , "Error, bad header in data file. Offset = ",badpos
    print, "value = ", DataType ; FLAG=0
    printf, 22, "Chris said impossible Error: bad header in data file. Offset = ",badpos," value = ", DataType
end
ENDSWITCH
if starttimestamp.hours eq 20 and starttimestamp.minutes eq 42 and starttimestamp.seconds eq 35 then begin
    NanoSeconds = startTimestamp.Nanoseconds + $
        (startTimestamp.Microseconds * 1000ULL) + $
        (startTimestamp.Milliseconds * 1000000ULL) + $
        (startTimestamp.Seconds * NanosecondsPerSecond) + $
        (startTimestamp.Minutes * NanosecondsPerMinute) + $
        (startTimestamp.Hours * NanosecondsPerHour)
    print,'nanoseconds=', nanoseconds
    print,'datatype=',DataType
    stop
endif



ENDWHILE

Close ,lun

Free_Lun, lun

;Widget_Control, event.top, Set_UValue=info, /No_Copy

; read_verticle_file
device, CURSOR_STANDARD= !ARROW_CURSOR  ; show hourglass while we process the data
end ;===== end of spec_toolbar_save make the horizon. vert_***bin files ===========================


;*****************
