PRO ZoomedVParticleStrip, info  ; this is for Vparticles
    forward_function Fill_averaged_strip
    stripID = 0L
    zoomID  = 0L
    stripBase = 0L
    stripLabel = 0L

    ave_info=info.ave_info
    lastimg_foffset=info.lastimg_foffset
    firstimg_foffset=info.firstimg_foffset


    strip_info = {stripID:stripID,        $ ; widget ID for the strip of bitmaps
        VstripID:0L,            $
        zoomID:zoomID,          $
        stripBase:stripBase,    $
        stripLabel:stripLabel,  $
        VstripBase:stripBase,   $
        VstripLabel:stripLabel, $
        FR_button:0L,      $
        SSR_button:0L,     $
        SSF_button:0L,     $
        FF_button:0L,      $
        ave_info:ave_info, $
        lastimg_foffset:lastimg_foffset,   $
        firstimg_foffset:firstimg_foffset, $
        time1:0LL, $ ; added following 4 line in august 15th,2007.
        time2:0LL, $
        eventx1:0, $
        eventx2:0}

    base = WIDGET_BASE(/COLUMN)
    strip_info.VstripBase = base
    info.stripBase = base

    Vparticles = Widget_Draw(base, XSize=!STRIP_WIDTH, YSize=128, $
        Event_Pro='SPEC_StripZoomV_event', /BUTTON_EVENTS, /MOTION_EVENTS)

    strip_info.VstripID = VParticles

    info.stripID = VParticles

    ;strip_y_size = 340 ; changed from 280 to 340 to add Roundness 1 2 3, each line increase 20.
    ;strip_y_size = 440 ; changed from 340 to 440 to add L1r, maxLength, maxWidth, and perimeter, crystal_type, each line increase 20.
    strip_y_size = 480 ; updated for Largest Sat Area

    STRIP_Toolbar = WIDGET_BASE(base, $
        COLUMN=8, $
        FRAME=1, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=strip_y_size); this line's 280 must be the same as next dula_label's 280.


    STRIP_dual_label = WIDGET_BASE(STRIP_Toolbar, $
        ROW=1, $
        ; FRAME=1, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=strip_y_size)
    ;YSIZE=280)  ;changer from 180 to 280; for showing L7, L8 , L5, PC1 etc. each line increase 20.


    ; Generate a label on the bitmap widget that will display the parameters for a single particle

    LABEL_Info = WIDGET_TEXT(STRIP_dual_label, $
        VALUE="", $
        XSIZE = 40, $
        YSIZE=40);change from 30 to 40 to make room for L7 L8
    strip_info.VstripLabel = LABEL_Info

    strip_toolbar2=widget_base(strip_toolbar,/col)
    strip_toolbar3=widget_base(strip_toolbar2,/row)
    BUTTON_FastBackward = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='FastRewind', $
        XSIZE=40, $
        TOOLTIP="Play Backwards", $
        VALUE=  'RR.bmp', /BITMAP, $
        Event_Pro='VZoomplay_reverse_timer_event')



    BUTTON_Rewind = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='Rewind', $
        XSIZE=35, $
        TOOLTIP="Single Step Reverse", $
        VALUE=  'SingleR.bmp', /BITMAP, $
        Event_Pro='VzoomParticleStrip_Toolbar_Rewind')

    BUTTON_Forward = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='Forward', $
        XSIZE=35, $
        TOOLTIP="Single Step Forward", $
        ;PUSHBUTTON_EVENTS=1, $
        VALUE= 'SingleF.bmp', /BITMAP, $
        Event_Pro='VzoomParticleStrip_Toolbar_Forward')


    BUTTON_FastForward = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='FastForward', $
        XSIZE=40, $
        TOOLTIP="Play Forwards", $
        VALUE=  'FF.bmp', /BITMAP, $
        Event_Pro='Vzoomplay_forward_timer_event')


    spaceholder1 = WIDGET_LABEL(STRIP_Toolbar3, $
        VALUE= " Speed (in Secs)", $
        XSIZE=110, $
        YSIZE=35)

    dd_list=['0.10','0.25','0.50','1.0']
    STRIP_Dropdown = WIDGET_DROPLIST(STRIP_Toolbar3, $
        FRAME=1, $
        VALUE = dd_list, $
        Event_Pro = 'VzoomBitmap_Playback_Speed_event')

    making_png_pages= WIDGET_button(STRIP_Toolbar2, $
        FRAME=1, $
        VALUE = 'Generate_images_png_pages', $
        Event_Pro ='Generating_VImage_png_pages_event')

    ;************************************************* add following on august 15, 2007
    cleaningbutton= WIDGET_button(STRIP_Toolbar2, $
        FRAME=1, $
        VALUE = 'Cleaning by start--End Clicks', $
        Event_Pro ='Cleaning_button_event')

    strip_toolbar4=widget_base(strip_toolbar2,/row)
    label = widget_label(strip_toolbar4,value = 'Label_one_image_as_bad_with_one_click:')
    b341 = widget_base(strip_toolbar4,/exclusive,/row)
    offbutton = widget_button(b341,value='Off',Event_pro='One_click_Cleaning_button_off_event')
    onbutton = widget_button(b341,value='On',Event_pro='One_click_Cleaning_button_on_event')

    ; checkbox for displaying perimeters

    base_showperimeter = widget_base(strip_toolbar2, /row, /nonexclusive)

    ck_showperimeter = widget_button(base_showperimeter, value = 'Show Perimeters', Event_pro = 'showperimeterV_event')
    widget_control, ck_showperimeter, set_button = !showperimeterV

    if !clean_status eq 3 then begin
        widget_control,onbutton, set_button=1
    endif else widget_control,offbutton, set_button=1


    ; save so we can disble buttons during FF and Fast reverse
    strip_info.FR_button = BUTTON_FastBackward
    strip_info.SSR_button = BUTTON_Rewind
    strip_info.SSF_button = BUTTON_Forward
    strip_info.FF_button = BUTTON_FastForward

    Zoomer_base = WIDGET_BASE(STRIP_Toolbar, $
        MAP=1, $
        UVALUE='BASE_Zoomer', $
        BASE_ALIGN_LEFT=1, $
        XSIZE=!zoom_xsize, $
        YSIZE=!zoom_ysize)

    strip_info.zoomID = Widget_Draw(Zoomer_base,XSize = !zoom_xsize, YSize = !zoom_xsize,$
        Event_Pro='SPEC_StripZoomV_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    ;  strip_info.zoomID = Widget_Draw(Zoomer_base,XSize=128, YSize=128, Event_Pro='SPEC_StripH_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    direction=1
    foffset=-1;  -1 means the first time filling in the strip
    foffset=Fill_averaged_strip(foffset, ave_info, strip_info, direction,'V')
    wdelete,!D.window
    Widget_Control, base, Set_UValue=strip_info, /No_Copy
    WIDGET_CONTROL, base, /REALIZE

    ; TAF added the second call to Fill_averaged_strip with direction = 0 to actually fill the strip after the window loads.
    ; Note the two calls to Widget control to get/set the new strip_info.
    Widget_Control, base, Get_UValue=strip_info, /No_Copy
    newoffset = Fill_averaged_Strip(foffset, ave_info, strip_info, 0, 'V')
    Widget_Control, base, Set_UValue=strip_info, /No_Copy

    XMANAGER, 'ZoomedVParticleStrip', base, /JUST_REG

END ; end of zoomHparticlestrip,info



PRO SPEC_StripZoomV_event, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,avestripdata,avestripdataV
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure

    HorV = 'V'

    microns_per_pixel = !MICRONS_PER_PIXELV

    if(event.PRESS GE 1) then  begin
        if event.ID EQ strip_info.zoomID then print, "zoom window clicked"
    end

    ; add following to remove noisy particles
    if event.Press GE 1 and event.ID eq strip_info.VstripID and !clean_status eq 3 then begin
        if (event.x GE 0 and event.X LE (!STRIP_WIDTH - 1)) then begin
            timenanoseconds = aveStripDataV(event.X).Nanoseconds
            index=where((*alldataV).nanoseconds eq timenanoseconds)
            if index(0) ne -1 then begin
                if (*alldataV)(index(0)).reject eq 0 then begin
                    (*alldataV)(index(0)).reject=1
                    reject=1
                endif  else begin
                    (*alldataV)(index(0)).reject=0
                    reject=0
                endelse
                ADD_THIS_CLICK_TO_CLICK_action_list_file,index(0),'V',reject
            endif
            if index(0) ne -1 then begin
                ;search until the start and end of this image.
                xx1=event.X >0
                while (aveStripdataV(xx1).Nanoseconds eq aveStripdataV(event.X).nanoseconds and xx1 gt 0) do begin
                    xx1=xx1-1
                endwhile
                xx2=event.X <998
                while (aveStripdataV(xx2).Nanoseconds eq aveStripdataV(event.X).nanoseconds and xx2 lt 998) do begin
                    xx2=(xx2+1) <998
                endwhile
                Widget_Control, strip_info.VstripID, Get_Value=wid
                WSet, wid
                mylength=xx2-xx1
                myclip = TVRD(xx1,0,mylength,128)

                flig_myclips_color,myclip,mylength,dimension

                loadct, !ct_2DS, /silent
                if dimension eq 3 then tv,myclip,xx1,0,true=1
                if dimension eq 2 then tv,myclip,xx1,0
            endif ; if index(0) ne -1
        endif
    endif
    ;********************************************************************************
    ; add following on august 15th 2007
    ;*******************************************************************
    ;********************************************************************************
    ;  add this to remove several particles at a time by drawing a rubber band or two clicks .
    if event.type eq 0 and event.ID eq strip_info.VstripID and !clean_status ne 0 then begin;button is pressed down
        if !clean_status eq 1 then begin
            if event.type eq 0 and event.ID eq strip_info.VstripID then begin
                strip_info.time2= aveStripDataV(event.X).Nanoseconds
                strip_info.eventx2=event.X
                !clean_status =0
                ;find all of the unique time between time1 and time2 in the data
                index=where((*alldataV).nanoseconds ge strip_info.time1 and (*alldataV).nanoseconds le strip_info.time2 $
                    and (*alldataV).reject eq 0, contGG)
                if contGG gt 0 then (*alldataV)(index).reject=1
                ADD_ALL_INDEXS_TO_ACTIONLIST,INDEX,'V'


                if (contGG gt 0) then begin
                    Widget_Control, strip_info.VstripID, Get_Value=wid
                    WSet, wid
                    mylength=fix(abs(strip_info.eventX2-strip_info.eventX1))
                    myclip = TVRD(strip_info.eventx1,0,mylength,128)
                    yellowblock=bytarr(3,mylength,128)
                    yellowblock(0,*,*)=255
                    yellowblock(1,*,*)=myclip
                    loadct, !ct_2DS, /silent
                    tv,yellowblock,strip_info.eventX1,0,true=1
                endif

            endif; end if venet.type eq 0
        endif; end of if !clean_status eq 1

        if !clean_status eq 2 then begin
            strip_info.time1= aveStripDataV(event.X).Nanoseconds
            strip_info.eventx1=event.X;                                           wait for until it is up.
            print,'time1=',strip_info.time1;   this is teh first particle's time.
            !clean_status=1
        endif
    endif
    ;**********************************************************************************

    ;*********************************************************************************

    if event.ID EQ strip_info.VstripID then begin
        if (event.x GE 0 and event.X LE (!STRIP_WIDTH - 1)) then begin


            ; Calculate the masses using various methods (TAF should clean this up and only calculate these parameters in one place...)

            shaded_area         = aveStripDataV(event.X).Area    * microns_per_pixel * microns_per_pixel ; microns^2

            ;if(aveStripData(event.X).focus gt !focuspercent) then begin
            ;    focus_adjusted_area = shaded_area
            ;endif else begin
            ;    focus_adjusted_area = !pi * aveStripData(event.X).L7 * aveStripData(event.X).L7 / 4. * microns_per_pixel * microns_per_pixel ; microns^2
            ;endelse

            ; Mass from CSP using parameterization for normal shaded pixel area

            csp_mass     = (10.0^(-9.0 * !csp_beta)) * !csp_alpha * double(aveStripDataV(event.X).csp)^!csp_beta ; here csps in um, area in mm^2 ; sizes is im um.

            ; Mass from CSP using parameterization for out of focus adjusted area

            ;csp_mass_adj = (10.0^(-9.0 * csp_beta)) * csp_alpha * double(aveStripData(event.X).csp * focus_adjusted_area / shaded_area)^csp_beta
            ;csp_mass_adj = csp_mass_adj


            ; Mass from Area using parameterization for normal shaded pixel area
            area_alpha = 0.115D
            area_beta  = 1.218D

            this_sizes = aveStripDataV(event.X).L1n  * microns_per_pixel                      ; microns
            this_area  = aveStripDataV(event.X).Area * microns_per_pixel * microns_per_pixel ; microns^2

            this_area = this_area / 1.e6 ; convert microns^2 to mm^2

            ;area_liq = .0001 * (!pi * this_sizes^2.) / 4.

            ;this_area_use = area_liq < this_area

            mass1 = area_alpha * double(this_area)^area_beta ; here sizes in um, area in mm^2 ; sizes is im um.
            mass2 = 0.917 * (0.1^9.0 * !pi/6.0) * This_sizes^3.0 ; size in um (TAF NOTE NOT WATER!!!) water-mass. milligrams. ice density
            ;mass3 = mass1 < mass2                                ; take the less elements of the two arrays
            ;print, string(format = '(%"Area Mass: %11.3e %11.3e")', mass1, mass2)
            area_mass = mass1


            ; Mass from Area using parameterizationfor out of focus adjusted area
            this_sizes = aveStripDataV(event.X).L1n * microns_per_pixel                      ; microns

            ;if(aveStripData(event.X).focus gt !focuspercent) then begin
            ;    this_area =  aveStripData(event.X).Area * microns_per_pixel * microns_per_pixel ; microns^2
            ;endif else begin
            this_area  = !pi * aveStripDataV(event.X).L7 * aveStripDataV(event.X).L7 / 4. * microns_per_pixel * microns_per_pixel ; microns^2
            ;endelse

            this_area = this_area / 1.e6 ; convert microns^2 to mm^2

            ;area_liq = .0001 * (!pi * this_sizes^2.) / 4.

            ;this_area_use = area_liq < this_area

            mass1 = area_alpha * double(this_area)^area_beta ; here sizes in um, area in mm^2 ; sizes is im um.
            mass2 = 0.917 * (0.1^9.0 * !pi/6.0) * This_sizes^3.0 ; size in um water-mass. milligrams.
            ;mass3 = mass1 < mass2                                ; take the less elements of the two arrays
            ;print, string(format = '(%"Adj Mass: %11.3e %11.3e")', mass1, mass2)
            ;print, " "
            area_mass_adj = mass1

            timestamp = SPEC_Nano2HMS(aveStripDataV(event.X).Nanoseconds)

            if(aveStripDataV(event.X).maxWidth eq 0.) then begin
                aspect = -1.
            endif else begin
                aspect = aveStripDataV(event.X).maxLength / aveStripDataV(event.X).maxWidth
            endelse

            hex_timestamp = string(format = '(%"0x%012X")',                                 aveStripDataV(event.X).ProbeCounter)
            F1         = string(format = '(%"F1 = 0x%04X")',aveStripDataV(event.X).F1)
            PC1        = string(format = '(%"PC1 = % 3.1d             Focus = % 9.5f")',aveStripDataV(event.X).PC1, aveStripDataV(event.X).focus)
            Nslice     = string(format = '(%"Nslice =%6.1d")', aveStripDataV(event.X).Nslice)
            length     = string(format = '(%"L1n(um) =% 7.1f          Mass(mg)   Focus Adj Mass")',aveStripDataV(event.X).L1n * microns_per_pixel)
            L1r_field  = string(format = '(%"L1r(um) =% 7.2f    Area: %11.3e  %11.3e")', aveStripDataV(event.X).L1r, area_mass, area_mass_adj)
            height     = string(format = '(%"L2(um) =% 8d       CSP: %11.3e   ")',aveStripDataV(event.X).L2 * microns_per_pixel, csp_mass)
            L3         = string(format = '(%"L3 = %9.3f")',1.8*aveStripDataV(event.X).L3)
            L4         = string(format = '(%"L4 = %3.1d")',aveStripDataV(event.X).L4)
            L5         = string(format = '(%"L5 = % 3.1d                Aspect:  % 9.3f")',aveStripDataV(event.X).L5, aspect)
            L7         = string(format = '(%"L7 = %8.2f")',aveStripDataV(event.X).L7)
            L8         = string(format = '(%"L8 = %8.2f")',aveStripDataV(event.X).L8)
            PC3        = string(format = '(%"PC3 (x,y) = %9.3f,%9.3f")',aveStripDataV(event.X).PC3x,aveStripDataV(event.X).PC3y)
            PC4        = string(format = '(%"PC4 (x,y) = %9.3f,%9.3f")',aveStripDataV(event.X).PC4x,aveStripDataV(event.X).PC4y)
            ;A3        = string(format = '(%"A3 = %9.3f")',aveStripDataV(event.X).A3)
            get_binary_8bitstring,my8bitstring,aveStripdataV(event.X).noisebyte
            A3     = 'NoiseType = '+my8bitstring
            area   = string(format = '(%"Area(sq.um) = % 8d")',aveStripDataV(event.X).Area * microns_per_pixel * microns_per_pixel)
            Alexei = string(format = '(%"A1 (Alexei) = % 8d")',aveStripDataV(event.X).Alexei1 * microns_per_pixel * microns_per_pixel)
            W8_t   =string(format = '(%"W8_t (tick) = %19I")',aveStripDataV(event.X).W8_t)
            W8_t_clean=string(format = '(%"W8_t_clean = %19I")',aveStripDataV(event.X).W8_t_clean)
            Rndness=string(format = '(%"Roundness (0 or 1) = %3d")', fix(aveStripDataV(event.X).Roundness))
            Warning=string(format = '(%"Warning  = %6.0f")',aveStripDataV(event.X).warn)
            Roundness1_field = string(format = '(%"Roundness 1 = %9.5f")', aveStripDataV(event.X).Roundness1)
            Roundness2_field = string(format = '(%"Roundness 2 = %9.5f")', aveStripDataV(event.X).Roundness2)
            Roundness3_field = string(format = '(%"Roundness 3 = %9.5f")', aveStripDataV(event.X).Roundness3)
            maxLength_field = string(format = '(%"Length = %9.3f um")', aveStripDataV(event.X).maxLength * microns_per_pixel)
            maxWidth_field  = string(format = '(%" Width  = %9.3f um")', aveStripDataV(event.X).maxWidth * microns_per_pixel)
            perimeter_field = string(format = '(%"Perimeter = %d pixels, %9.1f um")', aveStripDataV(event.X).perimeter, aveStripDataV(event.X).perimeterum)
            ;CPI_trigger_msg = string(format = '(%"CPI Trigger  = %d")',aveStripDataV(event.X).CPI_trigger)
            largest_sat_field= string(format = '(%"Largest Sat Area = %9.1f um^2")',        aveStripDataV(event.X).largest_satellite_area)
            num_sats_field      = string(format = '(%"Satellites = %d  ")',               fix(aveStripDataV(event.X).num_satellites))
            CPI_trigger_msg = string(format = '(%"CPI Trigger = %d   PartID = 0x%04X")',aveStripDataV(event.X).CPI_trigger, aveStripDataV(event.X).PartID)

            if((aveStripDataV(event.X).F1 AND '3'X) eq '3'X) then begin
                Edge_field = "Edge Flag = Both Edges"
            endif else if((aveStripDataV(event.X).F1 AND '1'X) eq '1'X) then begin
                Edge_field = "Edge Flag =    0 Edge"
            endif else if((aveStripDataV(event.X).F1 AND '2'X) eq '2'X) then begin
                Edge_field = "Edge Flag = 127 Edge"
            endif else begin
                Edge_field = "Edge Flag = Not on Array Edge"
            endelse

            if((aveStripDataV(event.X).F1 AND '4'X) eq '4'X) then begin
                Note1_field = "NOTE: Roundness 1-3 from Edge Particle"

                if((aveStripDataV(event.X).F1 AND '8'X) eq '8'X) then begin
                    Note2_field = "      Centroid ON  Array"
                endif else begin
                    Note2_field = "      Centroid OFF Array"
                endelse
            endif else begin
                Note1_field = ""
                Note2_field = ""
            endelse

            if((aveStripDataV(event.X).F1 AND '10'X) eq '10'X) then begin
                Note1_field = "NOTE: Roundness 1-3 from Dual Edge Particle"

                if((aveStripDataV(event.X).F1 AND '8'X) eq '8'X) then begin
                    Note2_field = "      Centroid ON  Array"
                endif else begin
                    Note2_field = "      Centroid OFF Array"
                endelse
            endif

            if(aveStripDataV(event.X).crystal_type eq 1) then begin
                crystal_type_field = string(format = '(%"crystal = sphere      CSP(um^3) = %11.2e")', aveStripDataV(event.X).csp)
            endif else if(aveStripDataV(event.X).crystal_type eq 15) then begin
                crystal_type_field = string(format = '(%"crystal = ice         CSP(um^3) = %11.2e")', aveStripDataV(event.X).csp)
            endif else begin
                crystal_type_field = string(format = '(%"crystal = ?           CSP(um^3) = %11.2e")', aveStripDataV(event.X).csp)
            endelse

            WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= timestamp + !CRLF $
                + hex_timestamp + !CRLF $
                + crystal_type_field + !CRLF $
                + F1     + !CRLF $
                + PC1    + !CRLF $
                + Nslice + !CRLF $
                + length + !CRLF $
                + L1r_field + !CRLF $
                + height + !CRLF $
                + L3     + !CRLF $
                + L4     + !CRLF $
                + L5     + !CRLF $
                + L7     + !CRLF $
                + L8     + !CRLF $
                + PC3    + !CRLF $
                + PC4    + !CRLF $
                + A3     + !CRLF $ ; this is 8bit noisetype now.
                + area   + !CRLF $
                + Alexei + !CRLF $
                + W8_t   + !CRLF $
                + W8_t_clean + !CRLF $
                + rndness + !CRLF  $
                + warning + !CRLF $
                + Roundness1_field + !CRLF $
                + Roundness2_field + !CRLF $
                + Roundness3_field + !CRLF $
                + maxLength_field  + !CRLF $
                + maxWidth_field   + !CRLF $
                + perimeter_field  + !CRLF $
                + Edge_field       + !CRLF $
                + largest_sat_field+ !CRLF $
                + Note1_field      + !CRLF $
                + Note2_field      + !CRLF $
                + num_sats_field   + CPI_trigger_msg

            CPI_trigger2 = aveStripDataV(event.X).CPI_trigger

            if (aveStripDataV(event.X).ImageWords GT 0) then begin

                match = aveStripDataV(event.X).Nanoseconds
                beginning = LONG(event.X)
                index =  LONG(event.X)
                WHILE ((beginning GE 0) and (aveStripDataV(index).Nanoseconds EQ match)) DO BEGIN
                    beginning--
                    if --index LT 0 then index = 0
                ENDWHILE
                if beginning NE 0 then  beginning++

                theend = LONG(event.X)
                index = LONG(event.X)
                WHILE ((theend LE (!STRIP_WIDTH - 1)) and (aveStripDataV(index).Nanoseconds EQ match)) DO BEGIN
                    theend++
                    if ++index GT (!STRIP_WIDTH - 1) then index = (!STRIP_WIDTH - 1)  ; can't let us access aveStripData(600)
                ENDWHILE
                if theend NE (!STRIP_WIDTH - 1) then theend--



                Widget_Control, strip_info.VstripID, Get_Value=wid
                WSet, wid

                ;center_y = long(aveStripDataV(event.X).PC1)
                ;center_y = long(aveStripDataV(event.X).PC1 + aveStripDataV(event.X).L5/2.) ; TAF was cutting off too much, still not very good display though
                center_y = long(aveStripDataV(event.X).PC1)
                center_x = long((theend-beginning)/2 + beginning)

                ;length = aveStripData(event.X).L2
                ;if (length LT aveStripData(event.X).ImageWords) then length = aveStripData(event.X).ImageWords


                ;start = long(aveStripData(event.X).PC1 -length)
                ;if (start LT 0) then start = 0

                ;length *= 2
                ;if (start + length) GT 127 then start = 128 - length
                ;height = aveStripData(event.X).ImageWords
                ;full_width = 22L
                ;half_width = 11L
                ;zoom_value = 6L

                ;full_width = 44L
                ;half_width = 22L
                ;zoom_value = 6L

                ;if (center_x LT half_width) then center_x = half_width
                ;if (center_x GT (!STRIP_WIDTH - 1)-half_width) then center_x = (!STRIP_WIDTH - 1)-half_width
                ;if (center_y LT half_width) then center_y = half_width
                ;if (center_y GT 127-half_width) then center_y = 127-half_width
                ;x1 = center_x - half_width
                ;y1 = center_y - half_width
                ;x_length = full_width
                ;y_length = full_width

                x1 = 0
                y1 = 0
                ;x_length = !zoom_xsize
                x_length = theend-beginning+1
                y_length = !PIXELS

                aa = where(aveStripDataV(*).nanoseconds eq match)
                x1 = aa[0]
                x_length = n_elements(aa)

                ; TAF adding support for handling the green CPI Trigger images for zoom

                ;clip = TVRD(x1, y1, x_length, y_length)
                clip = TVRD(x1, y1, x_length, y_length, /true)

                ;clip = reform(clip[2,*,*])

                ;green_color = 140
                ;purple_color = 38 ; TAF not sure where the 38 is coming from, indexed table vs decomposed?
                ;purple_index = where(clip eq purple_color, count)
                ;if(count gt 0) then begin
                ;    clip[purple_index] = green_color
                ;endif
                loadct, !ct_2DS, /silent
                Widget_Control, strip_info.zoomID, Get_Value=wid
                WSet, wid
                erase,color='FFFFFF'x  ; get background to white
                ;bigger = rebin(clip,full_width*zoom_value,full_width*zoom_value,/SAMPLE)
                bigger = rebin(clip, 3, x_length * !zoom_factor, y_length * !zoom_factor, /SAMPLE)
                tv, bigger, /true

                Widget_Control, strip_info.VstripID, Get_Value=wid
                WSet, wid
            endif
        endif
    endif

    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
END
;-------------------------------------
pro VZoomParticleStrip_Toolbar_Rewind, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV
    ;*******************************************************************************
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
    ;**************************************************
    firstimg_foffset=strip_info.firstimg_foffset
    lastimg_foffset =strip_info.lastimg_foffset
    ave_info=strip_info.ave_info
    ;**********************************************************************************
    ;*******************************************************************************
    Hsubindex=*(ave_info.Vsubindex)
    nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
    Hsub_foffset=(*alldataV)(Hsubindex).imageoffset
    L1size_array=(*alldataV)(Hsubindex).Nslice
    foffset=!Foffset
    ;get the new offset
    index=where(Hsub_foffset le foffset,number_left)
    if number_left ne 0 then begin
        foffsets_array=reverse(Hsub_foffset(index))
        L1size_array =reverse(L1size_array(index))
        ;find the first particle file_offset and then re-order them
        yoffset=0
        nnn=n_elements(L1size_array) < 500
        for i=0, nnn-1 do begin
            yoffset=yoffset+L1size_array(i)+1
            if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                foffset=foffsets_array(i)
                break
            endif; ;end of if yoffset ge
        endfor
    endif else foffset=firstimg_foffset
    ;finished getting the new start offset
    ;***************************************************************************************

    newoffset = Fill_averaged_Strip(foffset,ave_info, strip_info,-1,'V')
    if !FOFFSET le firstimg_foffset then begin
        WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= "BEGINNING OF Zoomed period REACHED"
    end else begin
        WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= ""
    endelse
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
end
;-------------------------------------
pro VzoomParticleStrip_Toolbar_Forward, event
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
    ;**************************************************
    firstimg_foffset=strip_info.firstimg_foffset
    lastimg_foffset =strip_info.lastimg_foffset
    ave_info=strip_info.ave_info
    ;**********************************************************************************
    foffset = !FOFFSET
    newoffset = Fill_averaged_Strip(foffset,ave_info, strip_info,1,'V')
    ; print, "pre,post",pre_offset,newoffset; ; if pre_offset EQ foffset then begin
    if foffset ge lastimg_foffset then begin
        WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= "END OF Zoomed Period REACHED"
    end else begin
        WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= ""
    endelse
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure

end;-------------------------------------
;=============================================================
;*****************************************************************************
pro VzoomBitmap_Playback_Speed_event, event
    if event.index eq 0 then !PLAYBACK_SPEED = 0.1
    if event.index eq 1 then !PLAYBACK_SPEED = 0.25
    if event.index eq 2 then !PLAYBACK_SPEED = 0.50
    if event.index eq 3 then !PLAYBACK_SPEED = 1.0
end  ;zoomBitmap_Playback_Speed_event, event
;*****************************************************************************
pro Vzoomplay_forward_timer_event, event
    forward_function  Fill_averaged_Strip
    IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') THEN BEGIN
        if (!PLAYBACK_ACTIVE eq 0) then begin
            Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
            ;**************************************************
            firstimg_foffset=strip_info.firstimg_foffset
            lastimg_foffset =strip_info.lastimg_foffset
            ave_info=strip_info.ave_info
            ;**********************************************************************************
            foffset = !FOFFSET
            pre_offset = foffset
            newoffset = Fill_averaged_Strip(foffset, ave_info,strip_info,1,'V')
            ; print, "pre,post",pre_offset,newoffset
            if pre_offset ge lastimg_foffset then begin
                WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= "END OF Zoomed Period REACHED"
                !PLAYBACK_ACTIVE = 1
                widget_control, event.ID, SET_VALUE = 'FF.bmp', /BITMAP

                WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=1

            end else begin
                WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= ""
                WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED
            endelse


            Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure

        endif
    endif else begin
        Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
        ;**************************************************
        firstimg_foffset=strip_info.firstimg_foffset
        lastimg_foffset =strip_info.lastimg_foffset
        ave_info=strip_info.ave_info
        ;**********************************************************************************
        if (!PLAYBACK_ACTIVE eq 1) then begin
            !PLAYBACK_ACTIVE = 0
            widget_control, event.ID, SET_VALUE = 'FFon.bmp', /BITMAP
            WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=0
            foffset = !FOFFSET
            pre_offset = foffset
            newoffset = Fill_averaged_Strip(foffset, ave_info,strip_info,1,'V')
            ; print, "pre,post",pre_offset,newoffset
            if pre_offset EQ lastimg_foffset then begin
                WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= "END OF Zoomed Period REACHED"
            end else begin
                WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= ""
            endelse
        endif else begin
            !PLAYBACK_ACTIVE = 1
            widget_control, event.ID, SET_VALUE = 'FF.bmp', /BITMAP

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=1
        endelse
        Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
    endelse
end;  end of zoomplay_forward_timer_event, event
;*****************************************************************************
pro Vzoomplay_reverse_timer_event, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV
    ;*******************************************************************************
    forward_function  Fill_averaged_Strip
    IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') THEN BEGIN
        if (!REWIND_ACTIVE eq 0) then begin
            Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
            ;**************************************************
            firstimg_foffset=strip_info.firstimg_foffset
            lastimg_foffset =strip_info.lastimg_foffset
            ave_info=strip_info.ave_info
            ;**********************************************************************************
            ;*******************************************************************************
            Hsubindex=*(ave_info.Vsubindex)
            nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
            Hsub_foffset=(*alldataV)(Hsubindex).imageoffset
            L1size_array=(*alldataV)(Hsubindex).Nslice

            foffset=!Foffset
            ;get the new offset
            index=where(Hsub_foffset le foffset,number_left)
            if number_left ne 0 then begin
                foffsets_array=reverse(Hsub_foffset(index))
                L1size_array =reverse(L1size_array(index))
                ;find the first particle file_offset and then re-order them
                yoffset=0
                nnn=n_elements(L1size_array) < 500
                for i=0, nnn-1 do begin
                    yoffset=yoffset+L1size_array(i)+1
                    if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                        foffset=foffsets_array(i)
                        break
                    endif; ;end of if yoffset ge
                endfor
            endif else foffset=firstimg_foffset
            ;finished getting the new start offset
            ;***************************************************************************************
            newoffset = Fill_averaged_Strip(foffset, ave_info,strip_info,-1,'V')

            if !FOFFSET le firstimg_foffset then begin
                WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= "BEGINNING OF Zoomed Period REACHED"
                !REWIND_ACTIVE = 1
                widget_control, event.ID, SET_VALUE = 'RR.bmp', /BITMAP
                WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=1
            end else begin
                WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= ""
                WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED
            endelse
            Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
        endif
    endif else begin
        Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
        ;**************************************************
        firstimg_foffset=strip_info.firstimg_foffset
        lastimg_foffset =strip_info.lastimg_foffset
        ave_info=strip_info.ave_info
        ;**********************************************************************************
        ;*******************************************************************************
        Hsubindex=*(ave_info.Vsubindex)
        nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
        Hsub_foffset=(*alldataV)(Hsubindex).imageoffset
        L1size_array=(*alldataV)(Hsubindex).Nslice

        foffset=!Foffset
        ;get the new offset
        index=where(Hsub_foffset le foffset,number_left)
        if number_left ne 0 then begin
            foffsets_array=reverse(Hsub_foffset(index))
            L1size_array =reverse(L1size_array(index))
            ;find the first particle file_offset and then re-order them
            yoffset=0
            nnn=n_elements(L1size_array) < 500
            for i=0, nnn-1 do begin
                yoffset=yoffset+L1size_array(i)+1
                if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                    foffset=foffsets_array(i)
                    break
                endif; ;end of if yoffset ge
            endfor
        endif else foffset=firstimg_foffset
        ;finished getting the new start offset
        ;***************************************************************************************
        if (!REWIND_ACTIVE eq 1) then begin
            !REWIND_ACTIVE = 0
            widget_control, event.ID, SET_VALUE = 'RRon.bmp', /BITMAP
            WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=0

            ; foffset = !FOFFSET
            newoffset = Fill_averaged_Strip(foffset, ave_info,strip_info,-1,'V')

            if !FOFFSET le firstimg_foffset then begin
                WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= "BEGINNING OF Zoomed Period REACHED"
            end else begin
                WIDGET_CONTROL ,strip_info.VstripLabel ,SET_VALUE= ""
            endelse
        endif else begin
            !REWIND_ACTIVE = 1
            widget_control, event.ID, SET_VALUE = 'RR.bmp', /BITMAP
            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=1
        endelse
        Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
    endelse
end  ; end of Vzoomplay_reverse_timer_event, event
;*****************************************************************************
;**************************************************************************************
pro Generating_Vimage_png_pages_event,event
    ;**********************************************************
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
    ;**************************************************
    ave_info=strip_info.ave_info
    output_png_images_page,ave_info,'V'
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
end; end of Generating_image_png_pages_event



