pro a3vcpiview_tms_methods,ave_info
    ; this is to make two tms traces (M1V1, M2V2) in each of 3 pannel of a window.
    ; when a reset button is click, all methods M1, M2 and Variables V1, V2 will
    ; be set to default values.
    title_str='Comparing 2DS tms plots'
    ;time_periods='aaaa to bbbbb'
    ;create top level base
    tlb=widget_base(title=title_str,/column,xsize=12.5*72,ysize=9*72,xoffset=30)
    L1base=widget_base(tlb,/row);      ;xoffset to place in offset the computer screen.
    ;timetext=widget_text(L1base,xsize=25,ysize=1,value=time_periods)
    helpnote=widget_button(L1base,value='Help Notes',uvalue='Help')
    save_config  =widget_button(L1base,value='save_config',uvalue='save_config')
    load_config  =widget_button(L1base,value='load_config',uvalue='load_config')
    save_png  =widget_button(L1base,value='save_png',uvalue='save_png')
    print_png =widget_button(L1base,value='Print',uvalue='ToPrinter')
    save_ascii =widget_button(L1base,value='save_ascii',uvalue='save_ascii')
    starttime=floor(ave_info.STARTNANOSECONDS/1000000000.0)
    endtime=ceil(ave_info.endnanoseconds/1000000000.0)
    Nseconds=endtime-starttime
    label9=widget_label(L1base,value='Seconds:')
    NsecsID=widget_text(L1base,frame=40,  Scr_XSize = 50, Value=strtrim(string(Nseconds),2))
    NbinsID= cw_field(L1base,title='Nbins',value=300,/int,xsize=5,uvalue ='Nbins',/all)

    resetbut=widget_button(L1base,value='Reset',uvalue='Reset')
    plotit  =widget_button(L1base,value='Update',uvalue='Redraw')

    L2base=widget_base(tlb,/row);  for tms draw and left-side widget_buttons.
    tmsDraw=widget_draw(L2base,xsize=9.5*72,ysize=560);  7.5*72); 540/3=180
    tmsbutbase=widget_base(L2base,/column)


    Methods=['M1','M2','M3','M4','M5','M6','M7']
    H_Channels=['H','V']
    V_channels=['V','H']
    A_Variables=['conc','extI','Lwc','evts','IWC','extL']
    B_Variables=['extI','Lwc','conc','evts','IWC','extL']
    C_Variables=['Lwc','conc','extI','evts','IWC','extL']

    tmsbutbase_a=widget_base(tmsbutbase,/column,/frame,ysize=180)
    ;do the first pannel for concentration trace 1 and trace 2
    label1=widget_label(tmsbutbase_a,value='1: Compare Time Series (df=conc)')
    label2=widget_label(tmsbutbase_a,value='Trace 1')
    tmsbutbase1=widget_base(tmsbutbase_a,/row)
    M11droplist=widget_droplist(tmsbutbase1,title='M',value=Methods,uvalue='M11list')
    C11droplist=widget_droplist(tmsbutbase1,title='C',value=H_Channels,uvalue='C11list')
    V11droplist=widget_droplist(tmsbutbase1,title='P',value=A_Variables,uvalue='V11list')

    label2=widget_label(tmsbutbase_a,value='Trace 2')
    tmsbutbase2=widget_base(tmsbutbase_a,/row)
    M12droplist=widget_droplist(tmsbutbase2,title='M',value=Methods,uvalue='M12list')
    C12droplist=widget_droplist(tmsbutbase2,title='C',value=V_Channels,uvalue='C12list')
    V12droplist=widget_droplist(tmsbutbase2,title='P',value=A_Variables,uvalue='V12list')

    tmsbutbase3=widget_base(tmsbutbase_a,/row)
    label2a    =widget_label(tmsbutbase3,value='     ')
    Ymintext11=cw_field(tmsbutbase3,title='Ymin',value=0.0, xsize=6,uValue='Pan1min',/all)
    Ymaxtext12=cw_field(tmsbutbase3,title='Ymax',value=1000.0, xsize=6,uValue='Pan1max',/all)
    b341a=widget_base(tmsbutbase_a,col=1,/nonexclusive)
    manPan1ID=widget_button(b341a,value='Manual-scaling:',event_pro='manPan1_event')
    widget_control,manPan1ID,set_button=0

    ;do the second panne2 for extinction trace 1 and trace 2
    tmsbutbase_b=widget_base(tmsbutbase,/column,/frame,ysize=180)
    label3=widget_label(tmsbutbase_b,value='2: compare Time Series (df=extinction)')
    label4=widget_label(tmsbutbase_b,value='Trace 1')
    tmsbutbase3=widget_base(tmsbutbase_b,/row)
    M21droplist=widget_droplist(tmsbutbase3,title='M',value=Methods,uvalue='M21list')
    C21droplist=widget_droplist(tmsbutbase3,title='C',value=H_Channels,uvalue='C21list')
    V21droplist=widget_droplist(tmsbutbase3,title='P',value=B_Variables,uvalue='V21list')

    label5=widget_label(tmsbutbase_b,value='Trace 2')
    tmsbutbase4=widget_base(tmsbutbase_b,/row)
    M22droplist=widget_droplist(tmsbutbase4,title='M',value=Methods,uvalue='M22list')
    C22droplist=widget_droplist(tmsbutbase4,title='C',value=V_Channels,uvalue='C22list')
    V22droplist=widget_droplist(tmsbutbase4,title='P',value=B_Variables,uvalue='V22list')
    ;*****************************************************************************
    tmsbutbase3=widget_base(tmsbutbase_b,/row)
    label2a    =widget_label(tmsbutbase3,value='     ')
    Ymintext21=cw_field(tmsbutbase3,title='Ymin',value=0.0, xsize=6,uValue='Pan2min',/all)
    Ymaxtext22=cw_field(tmsbutbase3,title='Ymax',value=10.0, xsize=6,uValue='Pan2max',/all)
    b341b=widget_base(tmsbutbase_b,col=1,/nonexclusive)
    manPan2ID=widget_button(b341b,value='Manual-scaling:',event_pro='manPan2_event')
    widget_control,manPan2ID,set_button=0

    ;*********************************************************************************
    ;do the second panne3 for mass trace 1 and trace 2
    tmsbutbase_c=widget_base(tmsbutbase,/column,/frame,ysize=180)
    label6=widget_label(tmsbutbase_c,value='3: Compare Time Series (df= mass ) ')
    label7=widget_label(tmsbutbase_c,value='Trace 1')
    tmsbutbase5=widget_base(tmsbutbase_c,/row)
    M31droplist=widget_droplist(tmsbutbase5,title='M',value=Methods,uvalue='M31list')
    C31droplist=widget_droplist(tmsbutbase5,title='C',value=H_Channels,uvalue='C31list')
    V31droplist=widget_droplist(tmsbutbase5,title='P',value=C_Variables,uvalue='V31list')

    label8=widget_label(tmsbutbase_c,value='Trace 2')
    tmsbutbase6=widget_base(tmsbutbase_c,/row)
    M32droplist=widget_droplist(tmsbutbase6,title='M',value=Methods,uvalue='M32list')
    C32droplist=widget_droplist(tmsbutbase6,title='C',value=V_Channels,uvalue='C32list')
    V32droplist=widget_droplist(tmsbutbase6,title='P',value=C_Variables,uvalue='V32list')
    ;*****************************************************************************
    tmsbutbase3=widget_base(tmsbutbase_c,/row)
    label2a    =widget_label(tmsbutbase3,value='     ')
    Ymintext31=cw_field(tmsbutbase3,title='Ymin',value=0.0, xsize=6,uValue='Pan3min',/all)
    Ymaxtext32=cw_field(tmsbutbase3,title='Ymax',value=3.0, xsize=6,uValue='Pan3max',/all)
    b341b=widget_base(tmsbutbase_c,col=1,/nonexclusive)
    manPan3ID=widget_button(b341b,value='Manual-scaling:',event_pro='manPan3_event')
    widget_control,manPan3ID,set_button=0

    ;*********************************************************************************

    widget_control, tlb,/realize
    MethodIDs={M11ID:M11droplist,C11ID:C11droplist,V11ID:V11droplist,$
        M12ID:M12droplist,C12ID:C12droplist,V12ID:V12droplist,$
        M21ID:M21droplist,C21ID:C21droplist,V21ID:V21droplist,$
        M22ID:M22droplist,C22ID:C22droplist,V22ID:V22droplist,$
        M31ID:M31droplist,C31ID:C31droplist,V31ID:V31droplist,$
        M32ID:M32droplist,C32ID:C32droplist,V32ID:V32droplist}
    configs={M11:'M1',C11:'H',V11:'conc',M12:'M1',C12:'V',V12:'conc',$
        M21:'M1',C21:'H',V21:'extI',M22:'M1',C22:'V',V22:'extI',$
        M31:'M1',C31:'H',V31:'Lwc',M32:'M1',C32:'V',V32:'Lwc'}
    z300=dblarr(300)
    tmsvalues={y1:z300,y2:z300,y3:z300,y4:z300,y5:z300,y6:z300} ;for ascii file.
    tmslabels={y1:'LHConc',y2:'LVConc',y3:'LHextn',Y4:'LVextn',y5:'LHLwc',y6:'LVLwc'} ; for ascii file
    info={MethodIDs:MethodIDs,methodvals:methods,H_channels:H_channels,V_channels:V_channels,$
        A_variables:A_variables,B_variables:B_variables,C_variables:C_variables,$
        configs:configs,ave_info:ave_info,tmsdrawID:tmsdraw,$
        tmsvalues:ptr_new(tmsvalues),tmslabels:tmslabels,$
        manu_panel1:0,manu_panel2:0,manu_panel3:0,$
        manPan1ID:manPan1ID,Pan1min:0.0,pan1max:1000.0,$
        manPan2ID:manPan2ID,pan2min:0.0,pan2max:10.0,$
        ManPan3ID:manPan3ID,pan3min:0.0,pan3max:3.0,$
        Ymintext11:Ymintext11,Ymaxtext12:Ymaxtext12, $; button IDS
        Ymintext21:Ymintext21,Ymaxtext22:Ymaxtext22, $
        Ymintext31:Ymintext31,Ymaxtext32:Ymaxtext32,$
        NbinsID:NbinsID,$
        nbins:300,$
        Hsv:ptr_new(),$
        Vsv:ptr_new()}

    ;use a pointer to pass teh data
    ptr=ptr_new(info,/no_copy); no extra copy is made.

    ;widget_control,tlb,set_uvalue=info; ;because xmanager will always pass a
    ;top level structure data to teh evenet handeler, so it is assigned
    ;in here in a package info to be ready to pass it by xmanager.
    widget_control,/hourglass

    get_tms_trace1to6_v2,ptr,xpts,all6yvals,all6MCPNstrings,all3ytitles
    draw_averaged_6tms,ptr,xpts,all6yvals,all6MCPNstrings,all3ytitles

    widget_control,tlb,set_uvalue=ptr;  info;  this replace above ***=info
    xmanager,'a3vcpiview_tms_methods',tlb,/just_reg
    ;*****************************************************
    return
end;   ;end of main program
;***********************************************************
pro a3vcpiview_tms_methods_event,event

    widget_control,event.top,get_uvalue=ptr
    widget_control, event.id,get_uvalue=uval
    case uval of
        'Reset':begin ; reset the traces to be default traces.
        methods=['M1','M2','M3','M4','M5','M6','M7']
        Param_a   =['conc','extI','Lwc','evts','IWC','extL']
        Param_b   =['extI','Lwc','conc','evts','IWC','extL']
        Param_c   =['Lwc','conc','extI','evts','IWC','extL']
        widget_control,(*ptr).MethodIDs.M11ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C11ID,set_value=['H','V']
        widget_control,(*ptr).MethodIDs.V11ID,set_value=param_a
        widget_control,(*ptr).MethodIDs.M12ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C12ID,set_value=['V','H']
        widget_control,(*ptr).MethodIDs.V12ID,set_value=param_a

        widget_control,(*ptr).MethodIDs.M21ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C21ID,set_value=['H','V']
        widget_control,(*ptr).MethodIDs.V21ID,set_value=param_b
        widget_control,(*ptr).MethodIDs.M22ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C22ID,set_value=['V','H']
        widget_control,(*ptr).MethodIDs.V22ID,set_value=param_b

        widget_control,(*ptr).MethodIDs.M31ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C31ID,set_value=['H','V']
        widget_control,(*ptr).MethodIDs.V31ID,set_value=param_c
        widget_control,(*ptr).MethodIDs.M32ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C32ID,set_value=['V','H']
        widget_control,(*ptr).MethodIDs.V32ID,set_value=param_c

        configs={M11:'M1',C11:'H',V11:'conc',M12:'M1',C12:'V',V12:'conc',$
            M21:'M1',C21:'H',V21:'extI',M22:'M1',C22:'V',V22:'extI',$
            M31:'M1',C31:'H',V31:'Lwc',M32:'M1',C32:'V',V32:'Lwc'}
        (*ptr).configs=configs
    end
    'M11list': (*ptr).configs.M11=((*ptr).Methodvals)(event.index)
    'M12list': (*ptr).configs.M12=((*ptr).Methodvals)(event.index)
    'M21list': (*ptr).configs.M21=((*ptr).Methodvals)(event.index)
    'M22list': (*ptr).configs.M22=((*ptr).Methodvals)(event.index)
    'M31list': (*ptr).configs.M31=((*ptr).Methodvals)(event.index)
    'M32list': (*ptr).configs.M32=((*ptr).Methodvals)(event.index)

    'C11list': (*ptr).configs.C11=((*ptr).H_Channels)(event.index)
    'C12list': (*ptr).configs.C12=((*ptr).V_Channels)(event.index)
    'C21list': (*ptr).configs.C21=((*ptr).H_Channels)(event.index)
    'C22list': (*ptr).configs.C22=((*ptr).V_Channels)(event.index)
    'C31list': (*ptr).configs.C31=((*ptr).H_Channels)(event.index)
    'C32list': (*ptr).configs.C32=((*ptr).V_Channels)(event.index)

    'V11list': (*ptr).configs.V11=((*ptr).A_Variables)(event.index)
    'V12list': (*ptr).configs.V12=((*ptr).A_Variables)(event.index)
    'V21list': (*ptr).configs.V21=((*ptr).B_Variables)(event.index)
    'V22list': (*ptr).configs.V22=((*ptr).B_Variables)(event.index)
    'V31list': (*ptr).configs.V31=((*ptr).C_Variables)(event.index)
    'V32list': (*ptr).configs.V32=((*ptr).C_Variables)(event.index)

    'Nbins':  begin
        widget_control,(*ptr).NbinsID,get_value=val
        (*ptr).nbins=val
    end
    'Redraw': begin
        widget_control,/hourglass
        if (*ptr).Nbins ne 300 then begin;      ;get_Nbins_sample_Volumes,ptr
            Nbins=(*ptr).Nbins
            ave_info=(*ptr).ave_info
            Hsv=fltarr(Nbins)
            Vsv=fltarr(Nbins)
            z300=dblarr(Nbins)
            tmsvalues={y1:z300,y2:z300,y3:z300,y4:z300,y5:z300,y6:z300} ;for ascii file.
            (*ptr).tmsvalues=ptr_new(tmsvalues)
            get_Hsv_Vsv,Nbins,Hsv,Vsv,ave_info
            (*ptr).Hsv=ptr_new(Hsv)
            (*ptr).Vsv=ptr_new(Vsv)

        endif
        ; get_tms_trace1to6,ptr,xpts,all6yvals,all6MCPNstrings,all3ytitles
        get_tms_trace1to6_v2,ptr,xpts,all6yvals,all6MCPNstrings,all3ytitles
        draw_averaged_6tms,ptr,xpts,all6yvals,all6MCPNstrings,all3ytitles
    end
    'save_config':begin; save the config_set into an ascii file.
    outputfilename=!currentHPname+'Config_tms_method_channel_variable.ascii'
    openw,6,outputfilename
    printf,6,(*ptr).configs(0)
    close,6
end

'load_config':begin; load the config_file and assign it back into.
pathnm=strmid(!currentHpname,0,strlen(!currentHpname)-1)
in_configs_file=dialog_pickfile(filter='*tms_method_channel_variable*.ascii',path=pathnm)
if in_configs_file eq '' then return
openr,6,in_configs_file
input_string='abcdf'
readF,6,input_string;  ;input_string={ L1 H binc L1 V binc L1 ******
close,6
substring=strsplit(input_string,' ',/extract);substring(0)="{"; substring(1)="L1"
(*ptr).configs.m11=substring(1)
(*ptr).configs.C11=substring(2)
(*ptr).configs.V11=substring(3)

(*ptr).configs.m12=substring(4)
(*ptr).configs.C12=substring(5)
(*ptr).configs.V12=substring(6)

(*ptr).configs.m21=substring(7)
(*ptr).configs.C21=substring(8)
(*ptr).configs.V21=substring(9)

(*ptr).configs.m22=substring(10)
(*ptr).configs.C22=substring(11)
(*ptr).configs.V22=substring(12)

(*ptr).configs.m31=substring(13)
(*ptr).configs.C31=substring(14)
(*ptr).configs.V31=substring(15)

(*ptr).configs.m32=substring(16)
(*ptr).configs.C32=substring(17)
(*ptr).configs.V32=strmid(substring(18),0,strlen(substring(18))-1)
widget_control,(*ptr).MethodIDs.M11ID,set_value=substring(1)
widget_control,(*ptr).MethodIDs.C11ID,set_value=substring(2)
widget_control,(*ptr).MethodIDs.V11ID,set_value=substring(3)
widget_control,(*ptr).MethodIDs.M12ID,set_value=substring(4)
widget_control,(*ptr).MethodIDs.C12ID,set_value=substring(5)
widget_control,(*ptr).MethodIDs.V12ID,set_value=substring(6)

widget_control,(*ptr).MethodIDs.M21ID,set_value=substring(7)
widget_control,(*ptr).MethodIDs.C21ID,set_value=substring(8)
widget_control,(*ptr).MethodIDs.V21ID,set_value=substring(9)
widget_control,(*ptr).MethodIDs.M22ID,set_value=substring(10)
widget_control,(*ptr).MethodIDs.C22ID,set_value=substring(11)
widget_control,(*ptr).MethodIDs.V22ID,set_value=substring(12)

widget_control,(*ptr).MethodIDs.M31ID,set_value=substring(13)
widget_control,(*ptr).MethodIDs.C31ID,set_value=substring(14)
widget_control,(*ptr).MethodIDs.V31ID,set_value=substring(15)
widget_control,(*ptr).MethodIDs.M32ID,set_value=substring(16)
widget_control,(*ptr).MethodIDs.C32ID,set_value=substring(17)
widget_control,(*ptr).MethodIDs.V32ID,set_value=(*ptr).configs.V32
end
'save_png':  save_tms_png,ptr
'ToPrinter': send_tms_png_to_printer,ptr
'save_ascii':write_compare_tms_ascii,ptr
'Help':  begin
    display_tms_help_message,ptr
end

'Pan1min': (*ptr).Pan1min=event.value
'Pan1max': (*ptr).Pan1max=event.value
'Pan2min': (*ptr).Pan2min=event.value
'Pan2max': (*ptr).Pan2max=event.value
'Pan3min': (*ptr).Pan3min=event.value
'Pan3max': (*ptr).Pan3max=event.value

else:
endcase

widget_control,event.top,set_uvalue=ptr;  put the info back to xmanager
end;  ;end of event handler
;****************************************************

;****************************************************
;*******************************************************************************
pro get_tms_trace1to6_v2,ptr,xxx,all6yvals,all6MCPNstrs,all3ytitles
    widget_control,/hourglass
    ave_info=(*ptr).ave_info

    ;find_if_there_is_bad_time_data in this Time Period.

    pop_up_messages_if_ThereIs_non_monotonic_data,ave_info



    ;for trace1
    this_method =(*ptr).configs.M11
    This_channel=(*ptr).configs.C11
    this_param  =(*ptr).configs.V11
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,This_method,this_channel,this_param,y11,ystr
    str1=this_method+":"+this_channel+":"+this_param
    ytitle_str1=ystr


    this_method =(*ptr).configs.M12
    This_channel=(*ptr).configs.C12
    this_param  =(*ptr).configs.V12
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,This_method,this_channel,this_param,y12,ystr
    str2=this_method+":"+this_channel+":"+this_param
    ytitle_str1=ytitle_str1+','+ystr


    this_method =(*ptr).configs.M21
    This_channel=(*ptr).configs.C21
    this_param  =(*ptr).configs.V21
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,This_method,this_channel,this_param,y21,ystr
    str3=this_method+":"+this_channel+":"+this_param
    ytitle_str2=ystr

    this_method =(*ptr).configs.M22
    This_channel=(*ptr).configs.C22
    this_param  =(*ptr).configs.V22
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,This_method,this_channel,this_param,y22,ystr
    str4=this_method+":"+this_channel+":"+this_param
    ytitle_str2=ytitle_str2+','+ystr

    this_method =(*ptr).configs.M31
    This_channel=(*ptr).configs.C31
    this_param  =(*ptr).configs.V31
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,This_method,this_channel,this_param,y31,ystr
    str5=this_method+":"+this_channel+":"+this_param
    ytitle_str3=ystr

    this_method =(*ptr).configs.M32
    This_channel=(*ptr).configs.C32
    this_param  =(*ptr).configs.V32
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,This_method,this_channel,this_param,y32,ystr
    str6=this_method+":"+this_channel+":"+this_param
    ytitle_str3=ytitle_str3+','+ystr

    all6yvals   ={y1:y11, y2:y12, y3:y21, y4:y22, y5:y31, y6:y32}
    all6MCPNstrs={s1:str1,s2:str2,s3:str3,s4:str4,s5:str5,s6:str6}
    all3ytitles =[ytitle_str1,ytitle_str2,ytitle_str3]
    ;assign the values to the pointer to save it for saving to ascii file use at later.
    (*ptr).tmsvalues=ptr_new(all6yvals)
    (*ptr).tmslabels=all6MCPNstrs

end; end of get_psd_trace1to8,ptr,xpts,y11,y12,y21,y22,y31,y32,y41,y42
;*******************************************************************************

;********************************************
pro  Draw_averaged_6tms,ptr,xpts,all6yvals,all6MCPNstrs,all3ytitles
    all6yvales=*((*ptr).tmsvalues)
    y11=all6yvals.y1
    y12=all6yvals.y2
    y21=all6yvals.y3
    y22=all6yvals.y4
    y31=all6yvals.y5
    y32=all6yvals.y6
    s11=all6MCPNstrs.s1
    s12=all6MCPNstrs.s2
    s21=all6MCPNstrs.s3
    s22=all6MCPNstrs.s4
    s31=all6MCPNstrs.s5
    s32=all6MCPNstrs.s6

    Widget_Control, (*ptr).tmsdrawid, Get_Value=wid  ; get the window ID for drawing.

    ave_info=(*ptr).ave_info

    forward_function  SPEC_Nano2HMS_struct, strrepl

    delta_s =(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000000.0
    if delta_s lt 10000.0 then  $
        delta_s ='dT='+string(delta_s,format='(F6.1)')+'s'  $
        else delta_s ='dT='+string(delta_s,format='(I6)')+'s'

    !ZOOM_START_STRING =  SPEC_Nano2HMS(ave_info.StartNanoSeconds)
    !ZOOM_END_STRING =  SPEC_Nano2HMS(ave_info.EndNanoSeconds)
    plot_string = !ZOOM_START_STRING +"-" + !ZOOM_END_STRING

    plot_string2 = strtrim(string(10000),2) + ' H , ' + $
        strtrim(string(20000),2) +  ' V Data Points'

    message_string = 'cmp_tms data from ' + !ZOOM_START_STRING +  $
        " to " + !ZOOM_END_STRING + ' , ' + plot_string2

    Widget_Control, (*ptr).tmsdrawID, TLB_SET_TITLE = message_string

    ;get the time axis lables from the ave_info
    ;******************************************************
    thisCharsize = Str_Size('A Sample String', 0.25)
    strf = 'aaa';SPEC_Nano2HMS(local_FirstData.Nanoseconds)
    strl = 'bbb'; SPEC_Nano2HMS(local_LastData.Nanoseconds)

    fullrange = 0ULL
    binwidth = 0ULL
    ;fullrange = local_LastData.Nanoseconds - local_FirstData.Nanoseconds
    fullrange = ave_info.endNanoseconds - ave_info.startNanoseconds
    binwidth = fullrange/8
    curbin = ave_info.startNanoseconds
    tnames = StrArr(9)
    FOR i=0,8 DO BEGIN
        tnames(i) =  strtrim(strmid(SPEC_Nano2HMS(curbin),0,12),2)
        curbin += binwidth
    ENDFOR
    ;-------------------------------
    ;Set up X axis tick labels.
    ;-------------------------------
    !X.TICKNAME = tnames
    !X.TICKS = 8
    ;********************************************************

    WSet, wid
    bluecolor =GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)

    erase,color='ffffff'x  ; get background to white

    XYOUTS,240,290,"REDRAWING ",color=bluecolor, size=4 , /device
    FOR i=0,5 DO BEGIN  ; seems to be needed to get the "REDRAW" to fully appear
        PRINT, " "
    ENDFOR

    !P.MULTI = [0, 1,3, 0, 0]
    !X.OMARGIN = [1.5,0.0]  ;We need this because the Area plot X axis label extends off the left edge of the window

    ;-------------------------------------------------------------------
    ; Determine which particles we're plotting, H or V
    ;-------------------------------------------------------------------

    xlog_setting = 1;ave_info.AveXLog
    ylog_setting = 0; ave_info.AveYLog

    subfile_str=strsplit(!currentHFname,'\',/extract)
    binfilename=strtrim(subfile_str(n_elements(subfile_str)-1),2)+'   '+delta_s

    ;now get the axis maximum minimums for the plots
    index=where(y11 ne 0.0,contG)
    if contG gt 0 then  ymin = min(y11(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
    index=where(y12 ne 0.0,contG)
    if contG gt 0 then  ymin_v = min(y12(index)) else ymin_v=0.1
    if (ymin_v lt ymin) then ymin = ymin_v

    ymax = max([y11,y12])
    ymax= ymax ; > 10.0;  take the maximum of the two values
    if (ylog_setting eq 1) then begin
        ymin = 10.0 ^ floor(alog10(ymin))
        ymax = 10.0^ceil(alog10(ymax))
    endif

    if (*ptr).manu_panel1 eq 1 then begin
        ymin=(*ptr).pan1min
        ymax=(*ptr).Pan1Max
    endif

    Yrange_AB=[ymin,ymax]

    PLOT, y11, COLOR=bluecolor,$
        YTITLE=all3ytitles(0), Xstyle = 1, YLOG=Ylog_setting,background= whitecolor,$
        TITLE=binfilename+'    '+plot_string,THICK=1, YRANGE=Yrange_AB, charsize=1.8, $
        pos=[0.10,0.72,0.98,0.97],xmargin=[3,1],YSTYLE=YStyle;$
        ; xtitle='time  ( blue='+s11+' red='+s12 +' )'
        oplot,y12,color=redcolor
    xyouts,60,377,'(blue='+s11+' mean='+string(mean(y11),format='(E9.2)'),color=bluecolor,/device
    xyouts,'  red='+s12+' mean='+string(mean(y12),format='(E9.2)'),color=redcolor,/device
    xyouts,' DeadT.not.Adjusted.for.Mean.yet)',color=bluecolor,/device
    ;end of plot 1 of 4 *******************************************************************************

    index=where(y21 ne 0.0,contG)
    if contG gt 0 then  ymin = min(y21(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
    index=where(y22 ne 0.0,contG)
    if contG gt 0 then  ymin_v = min(y22(index)) else ymin_v=0.1
    if (ymin_v lt ymin) then ymin = ymin_v

    ymax = max([y21,y22])
    if (ylog_setting eq 1) then begin
        ymin = 10.0 ^ floor(alog10(ymin))
        ymax = 10.0^ceil(alog10(ymax))
    endif

    if (*ptr).manu_panel2 eq 1 then begin
        ymin=(*ptr).pan2min
        ymax=(*ptr).Pan2Max
    endif

    Yrange_AB=[ymin,ymax]

    PLOT, y21, COLOR=bluecolor,Xstyle = 1, YLOG=ylog_setting,background= whitecolor,$
        THICK=1, YRANGE=Yrange_AB,ystyle=ystyle,charsize=1.8,$
        pos=[0.10,0.41,0.98,0.66],xmargin=[3,1],$
        YTITLE=all3ytitles(1); xtitle='time  ( blue='+s21+' red='+s22 +' )'
    oplot,y22,COLOR=redColor
    xyouts,60,200,'(blue='+s21+' Mean='+string(mean(y21),format='(E9.2)'),color=bluecolor,/device
    xyouts,'  red='+s22+' mean='+string(mean(y22),format='(E9.2)'),color=redcolor,/device
    xyouts,' DeadT.not.Adjusted.for.Mean.yet)',color=bluecolor,/device

    ;end of plot 2 of 3 *******************************************************************************

    index=where(y31 ne 0.0,contG)
    if contG gt 0 then  ymin = min(y31(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
    index=where(y32 ne 0.0,contG)
    if contG gt 0 then  ymin_v = min(y32(index)) else ymin_v=0.1
    if (ymin_v lt ymin) then ymin = ymin_v

    ymax = max([y31,y32])
    if (ylog_setting eq 1) then begin
        ymin = 10.0 ^ floor(alog10(ymin))
        ymax = 10.0^ceil(alog10(ymax))
    endif

    if (*ptr).manu_panel3 eq 1 then begin
        ymin=(*ptr).pan3min
        ymax=(*ptr).Pan3Max
    endif

    Yrange_AB=[ymin, ymax]

    PLOT, y31, COLOR=bluecolor, $
        YTITLE=all3ytitles(2), Xstyle = 1, YLOG=Ylog_setting,background= whitecolor,$
        TITLE=' ', THICK=1, YRANGE=Yrange_AB, charsize=1.80,  $
        pos=[0.10,0.09,0.98,0.34],xmargin=[3,1],YSTYLE=YStyle; xtitle='time( blue='+s31+'red='+s32+')'
    oplot,y32,color=redColor
    xyouts,60,20,'(blue='+s31+' mean='+string(mean(y31),format='(E9.2)'),color=bluecolor,/device
    xyouts,'  red='+s32+' mean='+string(mean(y32),format='(E9.2)'),color=redcolor,/device
    xyouts,' DeadT.not.Adjusted.for.Mean.yet)',color=bluecolor,/device
    xyouts,30.0,10,ave_info.criteria.label, charsize=1.0,color=bluecolor,/device;  310 is in middle.
    ;end of plot 3 of 3 *******************************************************************

end;  end of Draw-averaged_6tms
;***************************************************************************************

;***************************************************************************************
pro write_compare_tms_ascii,ptr

    ;get the output file name.
    ave_info=(*ptr).ave_info
    plot_string=strjoin(strsplit(ave_info.plot_string,':',/extract)); take away':' from the string.
    junk=findfile(!currentHPname+'ascii\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "ascii\"
    outputfilename=!currentHPname+'ascii\MxC0_TMS_CMP_'+plot_string+'.txt'
    ;open file to write
    openw, 77,outputfilename
    printf,77,'TMS_compare times series plot file generated at ',systime()
    printf,77,ave_info.binfilename;  ;input_filename
    printf,77,'The criteria applied to get the subset of data is:'
    printf,77,ave_info.criteria.label
    printf,77,'Time period is :',ave_info.plot_string
    printf,77,'Time is divided into ',strtrim(string((*ptr).Nbins),2),' bins'
    printf,77,'The 6 traces are in the following  order:'
    printf,77,(*ptr).tmslabels
    y1=(*(*ptr).tmsvalues).y1
    y2=(*(*ptr).tmsvalues).y2
    y3=(*(*ptr).tmsvalues).y3
    y4=(*(*ptr).tmsvalues).y4
    y5=(*(*ptr).tmsvalues).y5
    y6=(*(*ptr).tmsvalues).y6
    Nbins=(*ptr).Nbins
    startnanos=ave_info.startnanoseconds
    endnanos  =ave_info.endnanoseconds
    delt_nanos= (endnanos-startnanos)/nbins

    for i=0LL,Nbins-1LL do begin
        time=startnanos +i*delt_nanos
        rem_nanos=time mod 1000000000LL
        this_time=SPEC_Nano2HMS(time)
        hh=strmid(this_time,0,2)
        mm=strmid(this_time,3,2)
        ss=strmid(this_time,6,2)
        printf,77,format='(3(I2,1x),I9,1x,I16,1x,5(E11.4,1x),E11.4)',hh,mm,ss,rem_nanos,time,y1(i),y2(i),y3(i),y4(i),y5(i),y6(i)
    endfor
    close,77
end; ;end of write_compare_tms_ascii,ptr
;***********************************************************************
pro display_tms_help_message,ptr
    tms_help_message=[['0: The time period has been divided into '+string((*ptr).Nbins)+' bins.'],$
        ['                                                  '],$
        ['1. Save config is to save current button setups.'],$
        ['                                                '],$
        ['2. Load config is to load last saved button setups.'],$
        ['   After loading, the droplist has only 1 option,'],$
        ['   click reset and you will have more options again.'],$
        ['                                                '],$
        ['3. Save png is to save the plot as a png file.'],$
        ['                                                '],$
        ['4. Save ascii is to save the plot as an ascii file.'],$
        ['                                                '],$
        ['5. Update is to update the plot of the current setup.'],$
        ['                                                '],$
        ['6. Reset is to set the buttons to the default options.'],$
        ['                                                '],$
        ['7. M option M1,..M5 is for method, which means using '],$
        ['   different size of the image for calculation. for example:'],$
        ['   M1 uses particle size along the airplane movement direction.'],$
        ['   M2 uses particle size perpendicular to L1, for ice crystals. '],$
        ['   M4 is Particle size after corrected by Alexei"s method.'],$
        ['   Note That M2-LWC may be 100 times larger than other LWC/IWC'],$
        ['                                                '],$
        ['8. C option is to choose images from H or V channel.'],$
        ['                                                '],$
        ['9. P option is to choose variables concentration, extinction and IWC '],$
        ['                                                '],$
        ['10. This window is for comparing the results from '],$
        ['    different methods and/or channels.']]
    rrr=dialog_message(tms_help_message,/information)
end
;****************************************************************************
pro save_tms_png,ptr
    Widget_Control, (*ptr).tmsdrawid, Get_Value=wid  ; get the window ID for drawing.
    ave_info=(*ptr).ave_info
    ;get the output file name.
    plot_string=strjoin(strsplit(ave_info.plot_string,':',/extract)); take away':' from the string.
    junk=findfile(!currentHPname+'png\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "png\"
    outputfilename=!currentHPname+'png\MxC0_TMS_CMP_'+plot_string+'.png'
    wset,wid
    write_png,outputfilename,tvrd(true=1),/order
end; end of save_tms_png, ptr
;**************************************************************
;************************************************************
pro send_tms_png_to_printer,ptr
    Widget_Control, (*ptr).tmsdrawid, Get_Value=wid  ; get the window ID for drawing.
    wset,wid
    printwindow,wid,/landscape
end; end of send_tms_png_to_printer
;**************************************************************
pro manpan1_event,event
    Widget_Control, event.top, Get_uValue=ptr
    if (*ptr).manu_panel1 eq 0 then (*ptr).manu_Panel1=1 else (*ptr).manu_Panel1=0
    widget_control,(*ptr).manpan1ID, set_button = (*ptr).manu_Panel1
    Widget_Control, event.top, set_uValue=ptr
end
;***************************************************
pro manpan2_event,event
    Widget_Control, event.top, Get_uValue=ptr
    if (*ptr).manu_panel2 eq 0 then (*ptr).manu_Panel2=1 else (*ptr).manu_Panel2=0
    widget_control,(*ptr).manpan2ID, set_button = (*ptr).manu_Panel2
    Widget_Control, event.top, set_uValue=ptr
end
;***************************************************
pro manpan3_event,event
    Widget_Control, event.top, Get_uValue=ptr
    if (*ptr).manu_panel3 eq 0 then (*ptr).manu_Panel3=1 else (*ptr).manu_Panel3=0
    widget_control,(*ptr).manpan3ID, set_button = (*ptr).manu_Panel3
    Widget_Control, event.top, set_uValue=ptr
end
;***************************************************
