PRO Do_A2ds_Fishing_event, event

    ;FORWARD_FUNCTION  Write_fast_fssp ; TAF commenting for .sav


    WIDGET_CONTROL, event.top, GET_UVALUE= LocalState,/no_copy
    sname = TAG_NAMES(event, /STRUCTURE_NAME)

    case sname of
        ; Handle a kill request.
        'WIDGET_KILL_REQUEST':begin
        ; I should clean up in here. and release it to go back to zoom window.
        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;end of 'widget_kill_reguest':begin

    ; Handle a sizing request
    'WIDGET_BASE':begin
    WIDGET_CONTROL, event.top, XSIZE =1000, YSIZE =800  ; added by mo sept 9,2004
    WIDGET_CONTROL, LocalState.MainView, XSIZE = 780, YSIZE =560
    Plot_fast_fssp, LocalState
    WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
    return
end

'WIDGET_TAB':begin
; stop
end

else: begin

    ; a normal event

    WIDGET_CONTROL, event.id, GET_UVALUE = eventval
    CASE eventval OF    ; Note that pos  is not equal Pos, it is case_senitive
        'help_notes':begin
        messages=[[              'Note:'],       $
            ['1.If trouble, type (return)'],$
            ['   or (return,1)in command'],$
            ['   and hit Enter.        '],$
            ['                           '],$
            ['2. you can save a plot '],$
            ['   as a png or ascii  '],$
            ['   file.              '],$
            ['                        '],$
            ['3. if Lmax=10^(-7), that'],$
            ['   there is a particle '],$
            ['   with flag -1 in that '],$
            ['   period.             '],$
            ['                       '],$
            ['4. flag 0 means no edge'],$
            ['  cut; 1 means one edge'],$
            ['  cut; 2 means two edge'],$
            ['  cuts, particle is big.']]
        rrr=dialog_message(messages,/information)
    end

    ;*******************************
    'Ave_all': begin
        localstate.aveplot=1
        Plot_fast_fssp, LocalState
        localstate.aveplot=0
    end

    ;**********************************************
    'xlog': begin
        localstate.xlog=event.select
    end
    'ylog': localstate.ylog=event.select
    'Xbinsize': localstate.Xbin_size=event.value
    'x_lower':localstate.x_lo=event.value
    'x_upper':localstate.x_Hi=event.value
    'y_upper':localstate.y_upper=event.value
    ;**********************************************
    'ReDO_TS':  begin
        localstate.redo_ts=1
        Plot_fast_fssp, LocalState
        localstate.redo_ts =0
    end

    'Do_dt_distribution':  begin
        localstate.dt_distribution=1
        Plot_fast_fssp, LocalState
        localstate.dt_distribution =0
    end
    ;********************************
    'S_increase':begin
    update_Stime_by_Nsecond,1,localstate
    replot_old_plots,localstate
end

'S_decrease':begin
update_Stime_by_Nsecond,-1,localstate
replot_old_plots,localstate
end

'E_increase':begin
update_Etime_by_Nsecond,1,localstate
replot_old_plots,localstate
end

'E_decrease':begin
update_Etime_by_Nsecond,-1,localstate
replot_old_plots,localstate
end

'Nper_Pd':begin
localstate.NperPD=event.value

end
'Size_Lo': localstate.sizeLO=event.value
'Size_Hi':begin
localstate.sizeHI=event.value
;widget_control,localstate.sizeHI_ID,set_value =0
end
'flag0': localstate.flag0=event.select
'flag1': localstate.flag1=event.select
'flag2': localstate.flag2=event.select

'type':  localstate.type=event.value;  if value =0 it is H  if 1 it is V

'starthh':begin
if event.value gt 24 then begin
    rr9=dialog_message('value too large, try again',/information)
    localstate.starthh=24
endif else localstate.starthh=event.value
end
'startmm':begin
if event.value gt 59 then begin
    rr9=dialog_message('value too large, try again',/information)
    localstate.startmm=59
endif else       localstate.startmm=event.value
end
'startss':begin
if event.value gt 59 then begin
    rr9=dialog_message('value too large, try again',/information)
    localstate.startss=59
endif else       localstate.startss=event.value
end

'startms': begin
    if event.value gt 999 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.startms=999
    endif else  localstate.startms=event.value
end


'stophh': begin
    if event.value gt 24 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.stophh=24
    endif else localstate.stophh=event.value
end
'stopmm': begin
    if event.value gt 59 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.stopmm=59
    endif else       localstate.stopmm=event.value
end
'stopss': begin
    if event.value gt 59 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.stopss=59
    endif else  localstate.stopss=event.value
end

'stopms': begin
    if event.value gt 999 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.stopms=999
    endif else  localstate.stopms=event.value
end
'NEWFILE': begin
    ;input and load the data;;group data;assign data to teh localstate
    ave_info=localstate.ave_info
    input_and_load_2ds_data,ave_info,localstate
    Plot_fast_fssp, LocalState
end

'PRINT': BEGIN

    ; IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()

    ; IF LocalState.PrinterSetup THEN Plot_fast_fssp, LocalState, OutPutFlags=1
END

'SAVETIFF': Plot_fast_fssp, LocalState, OutPutFlags=2

'SAVE':   plot_fast_fssp,localstate,outputFlags=1;    save ascii

'QUITfile': BEGIN
    WIDGET_CONTROL, event.top, /DESTROY
    RETURN
END ;endof quit
ELSE:
ENDCASE ; end of event.id case
end
endcase ; end of sname case
WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
END


;===============================================================================
PRO Do_A2ds_Fishing,ave_info, GROUP=GROUP, OutPutFlags=OutPutFlags
    time_length=(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000000.0
    if time_length gt 10.0 then begin
        yyy=dialog_message([['Time period too long, recommend 1 or 2 seconds.'],['Continue ? y/n']],/question)
        if yyy eq 'No' then return
    endif
    ; stop
    ; Default is to send ouput to plot, only once
    IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0

    ; build GUI
    tlb = WIDGET_BASE(GROUP_LEADER=Group, /TLB_KILL_REQUEST_EVENTS, /TLB_SIZE_EVENTS, /col, TITLE='Spec A2Ds_fishing program',mbar=menuBase)
    ;-----------------------------------------------------
    button_bar = widget_base(tlb,/row)
    ; Menu
    file_menu = WIDGET_BUTTON(button_bar, Value='Start/Quit Fishing', /Menu)
    file_bttn1 = WIDGET_BUTTON(file_menu, Value='Start_fishing', Uvalue='NEWFILE')
    file_bttn4 = WIDGET_BUTTON(file_menu, Value='Quit_Fishing', Uvalue='QUITfile',/sep)

    ; button bar   add options label

    bb1 = widget_base(button_bar,/row)
    ;  readBut = widget_button(bb1,value='open.bmp',/bitmap,uvalue='OPEN') ;ascii
    saveBut = widget_button(bb1,value='Save.bmp',/bitmap,uvalue='SAVE') ;sacii
    ;saveBut = widget_button(bb1,value='Save txt',/bitmap,uvalue='SAVE')

    bb2 = widget_base(button_bar,/row)
    printBut = widget_button(bb2,value='print.bmp',/bitmap,uvalue='PRINT') ;print one file
    printallBut = widget_button(bb2,value='print1.bmp',/bitmap,uvalue='PRINTALL') ; print all

    bb3 = widget_base(button_bar,/row)
    tiffBut = widget_button(bb3,value='freeform.bmp',/bitmap,uvalue='SAVETIFF')  ; save png
    ;tiffBut = widget_button(bb3,value='save png',/bitmap,uvalue='SAVETIFF')

    bb4 = widget_base(button_bar,/row)
    helpbutton =widget_button(bb4,value='Helpful_notes',uvalue='help_notes')

    bb5 = widget_base(button_bar,/row)
    ; quitBut = widget_button(bb4,value='quit.bmp',/bitmap,uvalue='QUIT')  ; quite
    quitBut = widget_button(bb5,value='quit',/bitmap,uvalue='QUIT')

    MAINBase = widget_base(tlb,/row)
    ;*****************************************************
    wTLB = WIDGET_BASE(mainbase, /COLUMN, /BASE_ALIGN_TOP)
    wTab = WIDGET_TAB(wTLB, LOCATION=1); wTab = WIDGET_TAB(wTLB, LOCATION=location)
    wt1  =WIDGET_BASE(wTab, Title='show_Series_Plots', /COLUMN)
    MainView1 = WIDGET_DRAW(wt1, UVALUE='MAIN_VIEW1',$
        XSIZE=720, YSIZE=620);, X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004

    wt2  =WIDGET_BASE(wTab, Title='show_Ave_all_Plots', /COLUMN)
    MainView2 = WIDGET_DRAW(wt2, UVALUE='MAIN_VIEW2',$
        XSIZE=720, YSIZE=620);, X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004
    ;may 25 changed mainview to mainview1 and mainview2

    wt3  =WIDGET_BASE(wTab, Title='show_dt_distribution', /COLUMN)
    MainView3 = WIDGET_DRAW(wt3, UVALUE='MAIN_VIEW3',$
        XSIZE=720, YSIZE=620);, X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004
    ;may 25 changed mainview to mainview1 and mainview2
    ;*********************************************************
    ;-----------------------------------------------------
    ; Base for all buttons and radio buttons on the left side
    LeftButtonsBase = WIDGET_BASE(MAINBase, /COLUMN, UVALUE='AllButtons')
    ;-----------------------------------------------------
    ; Base for options
    OpsBase = WIDGET_BASE(LeftButtonsBase, /COL, /FRAME, /BASE_ALIGN_CENTER, UVALUE='ProcButtons', TITLE='Histogram Options')

    b3 = widget_base(opsbase,/col,/frame)
    b30 = widget_base(b3,/row)
    b31 = widget_base(b30,/col)
    ;label = widget_label(b31,value = 'Do time hhmmss.sss to hhmmss.sss',/align_left)
    label2= widget_label(b31,value = '     hh       mm       ss        mili_sec',/align_left)

    b311 = widget_base(b31,/row)
    StrHr_ID  = cw_field(b311,title='S',value=0,/int,xsize=2,uvalue ='starthh',/all)
    StrMin_ID = cw_field(b311,title=':',value=0,/int,xsize=2,uvalue ='startmm',/all)
    StrSec_ID = cw_field(b311,title=':',value=0,/int,xsize=2,uvalue ='startss',/all)
    Strmsc_ID = cw_field(b311,title='.',value=0,/int,xsize=3,uvalue ='startms',/all)
    ;making a increase and decrease button
    upbutton=widget_button(b311,value='>',uvalue='S_increase')
    dnbutton=widget_button(b311,value='<',uvalue='S_decrease')


    b312 = widget_base(b31,/row)
    StpHr_ID  = cw_field(b312,title='E',value=0,/int,xsize=2,uvalue ='stophh',/all)
    StpMin_ID = cw_field(b312,title=':',value=0,/int,xsize=2,uvalue ='stopmm',/all)
    StpSec_ID = cw_field(b312,title=':',value=0,/int,xsize=2,uvalue ='stopss',/all)
    Stpmsc_ID = cw_field(b312,title='.',value=0,/int,xsize=3,uvalue ='stopms',/all)
    ;making a increase and decrease button
    upbuttonE=widget_button(b312,value='>',uvalue='E_increase')
    dnbuttonE=widget_button(b312,value='<',uvalue='E_decrease')


    NperPd_ID= CW_field(opsbase,title='N_cnt_Per_Del_T:', value=1000,/int,xsize=5, uvalue='Nper_Pd',/all)
    size_base=widget_base(opsbase,/row)
    SizeLo_ID= CW_field(size_base,title='Size.lo:',value=0.5,xsize=5,uvalue = 'Size_Lo',/all) 
    SizeHI_ID= CW_field(size_base,title='Size.hi:',value=500.0,xsize=5,uvalue = 'Size_Hi',/all)

    b36  =widget_base(opsbase,/row)
    ;label = widget_label(b36,value='# of shaded edges',/align_center)
    b37a = widget_base(b36,/row)
    label = widget_label(b37a,value='#of_edges:',/align_left)
    b373 = widget_base(b37a,col=3,/nonexclusive)
    flag0 = widget_button(b373,value = '0',uvalue ='flag0')
    flag1 = widget_button(b373,value = '1',uvalue ='flag1')
    flag2 = widget_button(b373,value = '2',uvalue ='flag2')
    widget_control,flag0,set_button=1
    widget_control,flag1,set_button=1
    widget_control,flag2,set_button=1
    ;H, V, or all type buttons
    b37b = widget_base(opsbase,/row)
    label = widget_label(b37b,value='Type',/align_left)
    b374 = widget_base(b37b,col=3)
    butns = ['H','V']
    type = CW_BGroup(b374,butns,/row,/exclusive,button_uvalue=[0,1],uvalue='type',/no_release)
    widget_control,type,set_value=0

    ;ReDOTS     =widget_button(opsbase,value='Do_Time_Series',uvalue='ReDO_TS')
    ;makaverage =widget_button(opsbase,value='Do_Average_all',uvalue='Ave_all')
    ;-----------------------------------------------------
    ;************************************************************************
    TMs_ave_base=widget_base(opsbase,/row)
    ReDOTS=widget_button(TMS_ave_base,value='Do_Time_Series',uvalue='ReDO_TS')
    makaverage =widget_button(TMS_ave_base,value='Do_Average_all',uvalue='Ave_all')

    psdView = WIDGET_DRAW(opsbase, /BUTTON_EVENTS, /FRAME, /RETAIN, UVALUE='psd_VIEW',$
        XSIZE=200, YSIZE=200);, X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004

    ;****************************************************************************
    time_base=widget_base(opsbase,/col,/frame)
    b1 = widget_base(time_base,/col,/frame)
    b11= widget_base(b1,/row,/nonexclusive)
    xlog_select =widget_button(b11,value='Xlog',uvalue='xlog') 
    ylog_select =widget_button(b11,value='Ylog',uvalue='ylog') 
    widget_control,xlog_select,set_button=1
    widget_control,ylog_select,set_button=1
    b10=widget_base(time_base,/row)
    Binsize = CW_field(b10,title='TbinSize:',value=1,/long, xsize=5,uvalue = 'Xbinsize',/all) 
    Ymax_limit   = CW_field(b10,title='Y_hi:',value=1000,/long, xsize=5,uvalue = 'y_upper',/all) 
    b12= widget_base(time_base,/row)
    min_num_of_particles = CW_field(b12,title='X-Lo:',value=1,/long, xsize=5,uvalue = 'x_lower',/all) 
    Per_Bin_Habits_Tms   = CW_field(b12,title='X_Hi:',value=1000,/long, xsize=8,uvalue = 'x_upper',/all) 
    do_dt_dist =widget_button(time_base,value='Redo_t_distribution',uvalue='Do_dt_distribution')
    ;****************************************************************************
    ;****************************************************

    FileName =' ';Filenm

    WIDGET_CONTROL, MAINBase, /REALIZE

    ; Get drawable window index
    WIDGET_CONTROL, MainView1, GET_VALUE=MainViewID1
    WIDGET_CONTROL, MainView2, GET_VALUE=MainViewID2
    WIDGET_CONTROL, psdView, GET_VALUE=psdViewID
    LocalState = {year:0,$;year,$
        day:'0',$
        hhmmss_str:' ',$;hhmmss_str,$
        time0:0.0,$;time0,$
        sizelo:0.5,$
        sizehi:500.0,$  
        NperPD:1000,$   ;   MainView:MainView, $
        MViewID1:MainView1,$; ID1, $       ; draw window ID added may 25, 2005
        MViewID2:MainView2,$;ID2, $  ;MViewID:MainViewID, $       ; draw window ID
        MViewID3:MainView3,$;ID2, $  ;MViewID:MainViewID, $       ; draw window ID
        InFileName:FileName, $        ; data file name
        NperPD_ID:NperPD_ID, $
        sizeLO_ID:SizeLO_ID, $        
        sizeHI_ID:sizeHi_ID, $
        StpHr_ID:stpHR_ID,$
        Stpmin_ID:stpmin_ID,$
        Stpsec_ID:stpsec_ID,$
        Stpmsc_ID:stpmsc_ID,$
        StrHr_ID:strHr_ID,$
        Strmin_ID:Strmin_ID,$
        Strsec_ID:strsec_ID,$
        Strmsc_ID:Strmsc_ID,$
        flag0:1,$
        flag1:1,$
        flag2:1,$       
        PrinterSetup:0,$
        starthh:0,$;shh,$
        startmm:0,$;smm,$
        startss:0,$;sss,$
        startms:0,$;sms,$
        stophh:0,$;ehh,$
        stopmm:0,$;emm,$
        stopss:0,$;ess,$
        stopms:0,$;ems,$
        pathnm:' ',$;pathnm,$
        aveplot:0,$
        redo_ts:1,$
        pTsy1:ptr_new(),$
        pTsy2:ptr_new(),$
        px:ptr_new(),$
        group:7,$
        type:0,$   ; add following part on Junary 15th 2005
        pHntimeg1:ptr_new(),$
        pHdiamg1:ptr_new(),$
        pHflagsg1:ptr_new(),$
        pHntimeg2:ptr_new(),$
        pHdiamg2:ptr_new(),$
        pHflagsg2:ptr_new(),$
        pHntimeg3:ptr_new(),$
        pHdiamg3:ptr_new(),$
        pHflagsg3:ptr_new(),$
        pHntimeg4:ptr_new(),$
        pHdiamg4:ptr_new(),$
        pHflagsg4:ptr_new(),$
        pHntimeg5:ptr_new(),$
        pHdiamg5:ptr_new(),$
        pHflagsg5:ptr_new(),$
        pHntimeg6:ptr_new(),$
        pHdiamg6:ptr_new(),$
        pHflagsg6:ptr_new(),$
        pHntimeg7:ptr_new(),$
        pHdiamg7:ptr_new(),$
        pHflagsg7:ptr_new(),$
        PHw8_tg1:ptr_new(),$
        PHw8_tg2:ptr_new(),$
        PHw8_tg3:ptr_new(),$
        PHw8_tg4:ptr_new(),$
        PHw8_tg5:ptr_new(),$
        PHw8_tg6:ptr_new(),$
        PHw8_tg7:ptr_new(),$
        pHyconc:ptr_new(),$
        pHxtime:ptr_new(),$  ;above is for H  following is for V
        pVntimeg1:ptr_new(),$
        pVdiamg1:ptr_new(),$
        pVflagsg1:ptr_new(),$
        pVntimeg2:ptr_new(),$
        pVdiamg2:ptr_new(),$
        pVflagsg2:ptr_new(),$
        pVntimeg3:ptr_new(),$
        pVdiamg3:ptr_new(),$
        pVflagsg3:ptr_new(),$
        pVntimeg4:ptr_new(),$
        pVdiamg4:ptr_new(),$
        pVflagsg4:ptr_new(),$
        pVntimeg5:ptr_new(),$
        pVdiamg5:ptr_new(),$
        pVflagsg5:ptr_new(),$
        pVntimeg6:ptr_new(),$
        pVdiamg6:ptr_new(),$
        pVflagsg6:ptr_new(),$
        pVntimeg7:ptr_new(),$
        pVdiamg7:ptr_new(),$
        pVflagsg7:ptr_new(),$
        pVyconc:ptr_new(),$
        pVxtime:ptr_new(),$
        psdviewID:psdviewID,$
        inter_ntimes_min:1LL,$
        ave_info:ave_info,$
        Xlog:1,$   ;added in may 24 for getting rid of get_init_txt; box.
        ylog:1,$
        X_lo:1,$
        X_hi:1000,$
        xbin_size:1,$;   for time distribution x-bib-size
        pHntimetkg1:ptr_new(),$;1,$
        pHntimetkg2:ptr_new(),$;2,$
        pHntimetkg3:ptr_new(),$;3,$
        pHntimetkg4:ptr_new(),$;4,$
        pHntimetkg5:ptr_new(),$;5,$
        pHntimetkg6:ptr_new(),$;6,$
        pHntimetkg7:ptr_new(),$;6,$
        pVntimetkg1:ptr_new(),$;1,$
        pVntimetkg2:ptr_new(),$;2,$
        pVntimetkg3:ptr_new(),$;3,$
        pVntimetkg4:ptr_new(),$;4,$
        pVntimetkg5:ptr_new(),$;5,$
        pVntimetkg6:ptr_new(),$;6,$
        pVntimetkg7:ptr_new(),$;6,$
        Pvw8_tg1:ptr_new(),$
        Pvw8_tg2:ptr_new(),$
        Pvw8_tg3:ptr_new(),$
        Pvw8_tg4:ptr_new(),$
        Pvw8_tg5:ptr_new(),$
        Pvw8_tg6:ptr_new(),$
        Pvw8_tg7:ptr_new(),$
        y_upper:1000LL, $
        dt_distribution:0, $
        PHtms1:ptr_new(),$; added may 1, 2006
        pHtms2:ptr_new(),$
        pHtms3:ptr_new(),$
        pHtms4:ptr_new(),$
        pHtms5:ptr_new(),$
        pHtms6:ptr_new(),$
        pHtms7:ptr_new(),$
        PVtms1:ptr_new(),$
        pVtms2:ptr_new(),$
        pVtms3:ptr_new(),$
        pVtms4:ptr_new(),$
        pVtms5:ptr_new(),$
        pVtms6:ptr_new(),$
        pVtms7:ptr_new() $;  added on May  1 2006.
        };******added august 19,2005

    if((OutPutFlags and 1)/1)then begin
        IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()
    endif

    ; Save state
    WIDGET_CONTROL, tlb, SET_UVALUE=LocalState,/no_copy

    ; Hand off control of the widget to the XMANAGER:
    ;XMANAGER, 'Do_A2ds_Fishing', tlb, /NO_BLOCK
    XMANAGER, 'Do_A2ds_Fishing', tlb, /JUST_REG;   change above to this on June 3,2005.
END; ;end of show*****gui.pro
;=========================================================================
;============================================================================
PRO Plot_fast_fssp, LocalState, OutPutFlags=OutPutFlags
    nanoseconds_per_second=1000000000.0
    IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0
    ;Save image file?
    IF OutPutFlags eq 2 THEN BEGIN
        ;Get file name from start and stop times
        Sstr=strtrim(localstate.starthh,2)+'_'+$
            strtrim(localstate.startmm,2)+'_'+$
            strtrim(localstate.startss,2)+'_'+$
            strtrim(localstate.startms,2)
        Estr=strtrim(localstate.stophh,2)+'_'+$
            strtrim(localstate.stopmm,2)+'_'+$
            strtrim(localstate.stopss,2)+'_'+$
            strtrim(localstate.stopms,2)
        SETime_str='_'+Sstr+'__'+Estr
        widget_control,LocalState.MViewID1,get_value=wid
        wset,wid
        ;stop
        filename=localstate.pathnm+'Fish_Zoom'+SEtime_str+'_TMS_2DS.png'
        Buf = TVRD(true=1)
        WRITE_png, FileName, Buf
        widget_control,LocalState.MViewID2,get_value=wid
        wset,wid
        ; stop
        filename=localstate.pathnm+'Fish_Zoom'+SEtime_str+'_FvsL_2DS.png'
        Buf = TVRD(true=1)
        WRITE_png, FileName, Buf

        widget_control,LocalState.MViewID3,get_value=wid
        wset,wid
        ; stop
        filename=localstate.pathnm+'Fish_Zoom'+SEtime_str+'_DtDis_2DS.png'
        Buf = TVRD(true=1)
        WRITE_png, FileName, Buf

        wset,LocalState.psdViewID
        filename=localstate.pathnm+'Fish_Zoom'+SEtime_str+'_Psd_2DS.png'
        Buf = TVRD(true=1)
        WRITE_png, FileName, Buf
        return
    ENDIF
    ;write the outputs to ascii files.
    IF OutPutFlags eq 1 THEN BEGIN
        Write_fast_fssp, LocalState,FILENAME=FileName
        return
    endif

    if localstate.infilename eq ' ' then begin
        rr=dialog_message('An Input data file must be opened before making any plots.',/information)
        return
    endif
    ;get the infilename
    infilename=localstate.infilename
    substr=strsplit(infilename,'\',/extract)
    infilename=substr(n_elements(substr)-1)

    ;get start_stop_time_string


    widget_control,/hourglass

    year =localstate.year
    day  =localstate.day
    time0=localstate.time0
    ; stop

    ;get the plot data to make the plots.
    ;*********************************************************
    ; if type =0, get H data, if type =1, get V data; if type=all get HV data
    ;*********************************************************

    ; january 14;  the following can be replace with a subrountine call
    ; get the subset_data, localstate, subsetntime,subsetdiam,subsetflags
    ; then using get_plot_xyvalues, subsetntime, x,tsy1,tsy2

    if localstate.redo_ts eq 1 then begin

        get_the_subsetdata,localstate,subsetntime,subsetdiam,subsettms,CstartTime,CstopTime,$
            Stime_str,Etime_str,sizes_str,groupflags
        ;calculated the subset time series:
        ; nnnw8_t=n_elements(subsetw8_t)
        ;subset_time_series=lon64arr(nnnw8_t)
        ;for i=1LL,nnnw8_t-1LL do begin
        ;subset_time_series(i)=subset_time_series(i-1LL)+subsetw8_t(i)
        ;endfor
        subset_time_series=subsettms

        ;note that xtime yconc is H or V dependent. here in next we want both for the whole
        ;zoomed ave_info.startnanosecond ave_info.endnanosecond period.
        Hyconc=*(localstate.pHyconc);  These are for top pananel two curve plots.
        Hxtime=*(localstate.pHxtime); whole fishing's time series
        Vyconc=*(localstate.pVyconc)
        Vxtime=*(localstate.pVxtime); whole fishing's time series

        ;call subroutine to plot the psd distributions
        plot_subsetdiam_psd,subsetdiam,localstate

        ;**************************************************************************************
        ;stop
        ;following part be replaced with get_plot_xyvalues,subsetntime,NperpD ,x,tsy1,tsy2
        ;***********************************************************************************
        NperPD=localstate.NperPD

        NNNpart=n_elements(subsetntime)
        if NNNpart eq 1 then begin
            if subsetntime lt 0 then NNNpart=0;   note that we assign subsetntime=[-9.9]
        endif
        N_particles='#ofParticles='+strtrim(string(NNNpart),2)

        ;get_the_plotxyvalues,cstoptime,cstarttime,subsetntime,subsetntimetk,subsetflags,NperPD,x,tsy1,tsy2,tsc3
        get_the_plotxyvalues,cstoptime,cstarttime,subsetntime,subset_time_series,NperPD,x,tsy1,tsy2,tsc3

        ;note that zoomtime is subsetntime(0) is the same as CstartTime

        ;************************************************************************************
        ;x is started from the seconds of CstartTime;  we need to change that into the
        ;seconds since CstartTime so that:
        ;x=(x-x(0))/nanoseconds_per_second; in seconds
        x=(x-CstartTime)/nanoseconds_per_second; to make it aligned to teh zoomed time time series.

        ;now we have all values to make the plots.
        ;and we make the plots.

        widget_control,LocalState.MViewID1,get_value=wid
        wset,wid
        bluecolor =GetColor("Navy", !D.Table_Size-2)
        redcolor = GetColor("Red", !D.Table_Size-2)
        blackcolor=getColor("Black",!D.Table_Size-2)
        whitecolor =GetColor("White", !D.Table_Size-2)
        greencolor =GetColor("Green", !D.Table_Size-2)
        erase,color='ffffff'x  ; get background to white
        !P.multi=[0,4,1]

        ;get the my_ytitle  depending on time resolution
        maxyconc=max([Hyconc,Vyconc])
        if (Hxtime(1)-Hxtime(0) gt 0.1) and (Hxtime(1)-Hxtime(0)) lt 1.0 then begin
            my_ytitle='#/(0.1s)'
            my_title=' Normalized #/(0.1S) Series  Max='+strtrim(long(maxyconc),2)+' per_100ms H:blue V:Red'
        endif

        if (Hxtime(1)-Hxtime(0) ge 0.01) and (Hxtime(1)-Hxtime(0) lt 0.1) then begin
            my_ytitle='#/(0.01s)'
            my_title=' Normalized #/(0.01S) Series  Max='+strtrim(long(maxyconc),2)+' per_10_ms H:blue V:Red'
        endif


        if maxyconc ne 0.0 then begin
            Hyconc=Hyconc/maxyconc
            Vyconc=Vyconc/maxyconc
        endif else begin
            Hyconc=Hyconc*0.0
            Vyconc=Vyconc*0.0
        endelse
        ;nnseconds=n_elements(xtime);  xtime is seconds since midnight=hh*3600+mm*60+ss.sss
        ; replace above since xtime is not in seconds anymore----the zoomed time periods could
        ;                                                         less than 1 seconds.
        xtimep=Hxtime-Hxtime(0)
        ;PLOT,xtimes,yconc, COLOR=0, XRANGE=[xtimes(0),max(xtimes)],$
        PLOT,xtimep,Hyconc, COLOR=bluecolor, XRANGE=[xtimep(0),max(xtimep)],$
            yrange=[0.0,1.02],title=my_title,background= whitecolor,$
            YTITLE=my_ytitle, Xstyle = 1,THICK=1, Ystyle=1,charsize=2.0,$
            position=[0.12,0.86,0.97,0.96],xtitle='Time, (s)----'+infilename
        oplot,xtimep,Vyconc,color=redcolor
        ;select the zoomed part of concentration time series
        CstartS=CstartTime/nanoseconds_per_second-Hxtime(0)
        CstopS =CstopTime/nanoseconds_per_second- Hxtime(0)
        oplot,[CstartS,CstartS],[0.0,1.02],linestyle=2,color=greencolor
        oplot,[CstopS,  CstopS],[0.0,1.02],linestyle=2,color=greencolor

        nnnseconds=(CstopTime-CstartTime)/1000000000.0;  CstopS-CstartS)
        Del_Time=(CstopTime-CstartTime)/1000000000.0
        ;note that x is seconds since whole starttime.
        ;get the zoomed part concentration time series.
        if nnnseconds le 10 and nnnseconds ge 1.0  then begin
            yconcz=fltarr(nnnseconds*100+1);  make it 10Hz resolution
            xtimez=indgen(nnnseconds*100+1)/100.0
            zoomtime=CstartTime+xtimez*nanoseconds_per_second
            fffnn=nnnseconds*100L-1L
            for k=0L,fffnn do begin
                indexn=where(subsetntime ge zoomtime(k) and subsetntime lt zoomtime(k+1L),contn)
                yconcz(k)=contn
            endfor
        endif

        if nnnseconds lt 1.0  then begin
            yconcz=fltarr(1*100+1);  make it 100Hz resolution
            xtimez=indgen(1*100+1)/100.0;  with increament of 1/100 seconds
            zoomtime=CstartTime+xtimez*1000000000.0
            fffnn=1*100L-1L;    change from 2L to 1L; above add 1 more bin.
            for k=0L,fffnn do begin
                indexn=where(subsetntime ge zoomtime(k) and subsetntime lt zoomtime(k+1L),contn)
                yconcz(k)=contn
            endfor
        endif

        if nnnseconds gt 10.0 then begin
            yconcz=fltarr(nnnseconds+1);  make it 10Hz resolution
            xtimez=indgen(nnnseconds+1)
            zoomtime=CstartTime+xtimez*nanoseconds_per_second
            fffnn=nnnseconds-1L
            for k=0L,fffnn do begin
                indexn=where(subsetntime ge zoomtime(k) and subsetntime lt zoomtime(k+1L),contn)
                yconcz(k)=contn
            endfor
        endif
        max_yconcz=max(yconcz) >1.0
        yconcz=yconcz/max_yconcz

        if localstate.type eq 0 then this_color=bluecolor else this_color=redcolor
        ; plot 2 of 4 the zoomed time series
        title_str=sizes_str + 'pixels    '+groupflags
        ptsy1=ptr_new(fltarr(n_elements(tsy1)))
        ptsy2=ptr_new(fltarr(n_elements(tsy1)))
        px   =ptr_new(fltarr(n_elements(tsy1)))
        *ptsy1=tsy1
        *ptsy2=tsy2
        *px=x
        localstate.ptsy1=ptsy1
        localstate.ptsy2=ptsy2
        localstate.px=px
        xmax_ts=(cstopTime-cstartTime)/nanoseconds_per_second

        ;select the zoomed part of concentration time series
        ; CstartS=CstartTime/nanoseconds_per_second-xtime(0)
        ; CstopS=CstopTime/nanoseconds_per_second-xtime(0)
        ; index=where(xtimes ge cstartS and xtimes le cstopS)
        ; xtimesz=xtimes(index)
        ; xtimesz=xtimesz-xtimesz(0)
        ; yconcz=yconc(index)
        PLOT,xtimez,yconcz, COLOR=this_color, XRANGE=[0.0,Del_Time],$
            yrange=[0.0,1.05],title='Zoomed:  '+title_str+'  '+N_particles,$
            YTITLE='#/Time', Xstyle =1,THICK=1, Ystyle=1,charsize=1.5,$
            position=[0.12,0.66,0.97,0.76],background= whitecolor
        oplot,x,tsc3/(max(tsc3)>1.0),color=blackcolor


        ;PLOT,x,Tsy1, COLOR=0, XRANGE=[x(0),xmax_ts],/ylog,$
        PLOT,x,Tsy1, COLOR=this_color, XRANGE=[0.0,Del_time],/ylog,$
            yrange=[0.1,10.0^ceil(alog10(max(Tsy1)))],$ ;title='Counts per second Time series',$
            YTITLE='F', Xstyle = 1,THICK=1, Ystyle=1,charsize=1.5,$
            position=[0.12,0.36,0.97,0.61],background= whitecolor

        subHstr=strsplit(!currentHFname,'\',/extract)
        HFname=subHstr(n_elements(subHstr)-1)
        subVstr=strsplit(!currentVFname,'\',/extract)
        VFname=subVstr(n_elements(subVstr)-1)
        HV_binfilenames=HFname + '  '+VFname

        Tsy2=tsy2*10.0^(-5);     1 tick is 10um=10^(-5) Meter;110.0/nanoseconds_per_Second
        index=where(Tsy2 ne 0.0,contGG)
        if contGG ne 0 then minyGG=min(Tsy2(index)) else minyGG=0.0001

        ; PLOT,x,Tsy2, COLOR=0, XRANGE=[x(0),xmax_ts],/ylog,subtitle=HV_binfilenames,$
        PLOT,x,Tsy2, COLOR=this_color, XRANGE=[0.0, Del_time],/ylog,subtitle=HV_binfilenames,$
            yrange=[10.0^floor(alog10(minyGG)),10.0^ceil(alog10(max(Tsy2)))],$ ;title=' ',$
            YTITLE='Lmax, (meter)', Xstyle = 1,THICK=1, Ystyle=1,charsize=1.5,$
            position=[0.12,0.09,0.97,0.32],xtitle='Time, seconds from Chosen StartTime '+stime_str

        endofplot:   ;do nothing.

    endif;  end of if localstate.redo_ts eq 1
    ;stop

    ;******************************************************************
    ;begin ave_all plots.
    if localstate.aveplot gt 0 then begin
        ;get teh ave_all data ntime_ave
        get_ntime_ave,localstate,ntime_ave,time_series,w8_t_ave,Stime_str,Etime_str,groupflags,sizes_str
        ;call function to get the Farray and Larray.
        ; take the offset away,  it is a pain to that basics fish don't take
        ; large nTime_ave numbers.
        ; stop
        nnn=n_elements(w8_t_ave)
        if nnn lt 10 then begin
            rrr=dialog_message('Too few particles to do the plots, try again !',/information)
            return
        endif

        ; time_series=lon64arr(nnn)
        ;for i=1LL,nnn-1LL do begin
        ;time_series(i)=time_series(i-1)+w8_t_ave(i)
        ;endfor

        ;basic_fish has bugs about FOFL  return -NaN values, array to big.---brad need to change.
        ; basic_fish_2ds,ntimetk_ave,Larray,Farray,50ll; Farray, Farray, y1,y2 are the desired results.
        ;stop
        time_series=time_series-time_series(0)
        basic_fish_2ds,time_series,Larray,Farray,1LL
        ;stop
        ;write_output_to_file
        outfile='Moqixu_H_test_ser_F_and_L.txt
        openw,11,outfile
        nnn=n_elements(Time_series)
        nn2=n_elements(Farray)
        if nnn ge nn2 then begin
            for i=0L,nn2-1L do begin
                printf,11, format='(I8,1x,F9.6,1x,F12.4)',time_series(i),Farray(i),Larray(i)
            endfor

            for i=nn2,nnn-1 do begin
                printf,11, format='(I8,1x,F9.6,1x,F12.4)',Time_series(i),0.0,0.0
            endfor
        endif

        if nnn lt nn2 then begin
            for i=0L,nnn-1L do begin
                printf,11, format='(I8,1x,F9.6,1x,F12.4)',Time_series(i),Farray(i),Larray(i)
            endfor
            for i=nnn,nn2-1 do begin
                printf,11, format='(I8,1x,F9.6,1x,F12.4)',0,Time_series(i),Larray(i)
            endfor
        endif
        close,11

        subHstr=strsplit(!currentHFname,'\',/extract)
        HFname=subHstr(n_elements(subHstr)-1)
        subVstr=strsplit(!currentVFname,'\',/extract)
        VFname=subVstr(n_elements(subVstr)-1)
        HV_binfilenames=HFname + '  '+VFname

        ;output the time_series,Larry,Farray  for compare with brad.
        outbrad='c:\Brad_fake_time_series.txt'
        openw,17,outbrad
        for i=0LL,n_elements(time_series)-1LL do begin
            printf,17,time_series(i)
        endfor
        close,17

        outbrad='c:\Brad_fake_time_series_FL.txt'
        openw,17,outbrad
        for i=0LL,n_elements(Farray)-1LL do begin
            printf,17,Farray(i),Larray(i)
        endfor

        close,17

        ;make the plots.   note that 1 tick is time is 10um=10^(-5)meter.
        xxx=Larray*10.0^(-5);  110.0/nanoseconds_per_second; Larry is nanoseconds---->xxxx in unit of m.
        yyy=Farray

        if localstate.type eq 0 then type_str='H ' else   type_str='V '

        ; loadct,0
        widget_control,LocalState.MViewID2,get_value=wid
        wset,wid
        bluecolor =GetColor("Navy", !D.Table_Size-2)
        redcolor = GetColor("Red", !D.Table_Size-2)
        blackcolor=getColor("Black",!D.Table_Size-2)
        whitecolor =GetColor("White", !D.Table_Size-2)
        greencolor =GetColor("Green", !D.Table_Size-2)
        erase,color='ffffff'x  ; get background to white
        ;******************************************
        !P.multi=[0,1,1]
        indexw=where(yyy ge 0.0,contw)
        if contw lt 2 then begin
            rrrrrr=dialog_message('Farray has less than 2 values greater than 0.0',/information)
            yyy(0:2)=1.0
        endif
        title_str=type_str+'Ave_all from '+Stime_str+' to '+Etime_str+'  size='+ sizes_str+'  '+groupflags
        plot,xxx,yyy,color=blackcolor,title=title_str,/xlog,$;position=[0.12,0.56,0.95,0.96],$
            ytitle='Farray',xtitle='Larray, (meters)',charsize=1.0,background= whitecolor,$
            subtitle=HV_binfilenames

    endif; end of doing ave_all_plot

    if localstate.dt_distribution gt 0 then begin
        ;find the inter_particle time to see the interparticle time distribution.
        get_ntime_ave,localstate,ntime_ave,time_series,w8_t_ave,Stime_str,Etime_str,groupflags,sizes_str

        nn_int=n_elements(ntime_ave)
        if nn_int le 3 then begin
            rrr=dialog_message('To few particles to make inter-particle time distribution',/information)
            return
        end

        if localstate.type eq 0 then type_str='H ' else   type_str='V '

        min_dt=localstate.inter_ntimes_min;    This a long64 number and w8_t_ave is also long 64 number.

        ;inter_ntimes=inter_ntimes/min_dt
        inter_ntimes=w8_t_ave;/min_dt
        xbin_size=localstate.xbin_size

        distribution_2ds,inter_ntimes,xx,yy,xbin_size

        subHstr=strsplit(!currentHFname,'\',/extract)
        HFname=subHstr(n_elements(subHstr)-1)
        subVstr=strsplit(!currentVFname,'\',/extract)
        VFname=subVstr(n_elements(subVstr)-1)
        HV_binfilenames=HFname + '  '+VFname


        ;total number of arrticles
        totN=strtrim((n_elements(inter_ntimes)+1L),2)
        min_dt_str=strtrim(min_dt,2)

        widget_control,LocalState.MViewID3,get_value=wid
        wset,wid
        bluecolor =GetColor("Navy", !D.Table_Size-2)
        redcolor = GetColor("Red", !D.Table_Size-2)
        blackcolor=getColor("Black",!D.Table_Size-2)
        whitecolor =GetColor("White", !D.Table_Size-2)
        greencolor =GetColor("Green", !D.Table_Size-2)
        erase,color='ffffff'x  ; get background to white
        !P.multi=[0,1,1]

        x_lower=localstate.X_lo
        x_upper=localstate.X_hi
        my_xrange=[x_lower,x_upper]
        y_upper=localstate.y_upper

        if localstate.Xlog eq 1 then begin
            my_xlog=1
            my_xrange=[10.0^floor(alog10(x_lower)),10.0^ceil(alog10(x_upper))]
        endif else begin
            my_xlog=0
            my_xrange=[x_lower,x_upper]
        endelse
        if localstate.ylog eq 1 then begin
            my_ylog=1
            my_yrange=[1.0,10.0^ceil(alog10(y_upper))]
        endif  else begin
            my_ylog=0
            my_yrange=[1.0,y_upper]
        endelse
        ;stop
        xx0=xx;   keep xx0 yy0 for re-bin-ding use.
        yy0=yy

        title_str=type_str+'Ave_all from '+Stime_str+' to '+Etime_str+'  size='+ sizes_str+'  '+groupflags

        plot,xx,yy,color=blackcolor,xrange=my_xrange,yrange=my_yrange, $; position=[0.12,0.12,0.95,0.50],$
            xlog=my_xlog,ylog=my_ylog,xstyle=1,ystyle=1,title=title_str,background= whitecolor,$
            ytitle='yy_distribution',xtitle='xx'+'    minimium_inter_arrival_dt='+min_dt_str,$
            subtitle=HV_binfilenames

        Sstr=strjoin(strsplit(Stime_str,':',/extract),'_')
        Estr=strjoin(strsplit(Etime_str,':',/extract),'_')
        SETime_str='_'+Sstr+'__'+Estr
        filename_dist=localstate.pathnm+'2Ds_'+strtrim(round(localstate.sizeLo),2)+$
            '_'+strtrim(round(localstate.sizeHi),2)+'_'+groupflags+SETime_str+'_Dt_Distrib.png'
        ; write_png,filename_dist,tvrd(true=1)

    endif;   of if localstate.dt_distribution gt 0 then begin
    ;******************************************************************

END ;end of plot the data

;=================================================================================

;================================================================================
;===============================================================================
pro Write_fast_fssp, LocalState,FILENAME=FileName

    ;Get file name from user?
    IF (not keyword_set(FileName))THEN $
        FileName = DIALOG_PICKFILE(FILTER='*.txt', TITLE="Select cond_spectra Histogram Data File")

    dotloc = rstrpos(filename,'.')
    if(dotloc eq -1)then filename = filename + '_2DS.txt'

    IF( FileName eq '') THEN RETURN

    Openw, DFileUnit, FileName, /Get_lun, ERROR = err
    IF (err NE 0) THEN BEGIN
        PRINT, !ERR_STRING
        return
    ENDIF
    group=localstate.group
    x=*localstate.px
    y1=*localstate.ptsy1
    y2=*localstate.ptsy2
    case group of
        1:group_str='0'
        2:group_str='1'
        3:group_str='2'
        4:group_str='01'
        5:group_str='02'
        6:group_str='12'
        7:group_str='012'
    endcase
    ;filename_str
    Fpart=strtrim(localstate.sizeLo,2)+'_'+strtrim(localstate.sizeHi,2)+'   flag= '+group_str
    stime_str=strtrim(localstate.starthh,2)+':'+strtrim(localstate.startmm,2)+':'+$
        strtrim(localstate.startss,2) +':'+strtrim(round(localstate.startms),2)
    Etime_str=strtrim(localstate.stophh,2)+':'+strtrim(localstate.stopmm,2)+':'+$
        strtrim(localstate.stopss,2)+':'+strtrim(round(localstate.stopms),2)

    printf,DfileUnit,'time = ',Stime_str,' to ',Etime_str, '  size= ',Fpart
    printf,DfileUnit,'Time              y1             y2'
    for i=0, n_elements(y1)-1 do printf,DfileUnit,format='(F12.4,2x,F12.4,2x,F12.4)',x(i),y1(i),y2(i)

    FREE_LUN, DFileUnit
END  ;end of writeHistorgram

;***********************************************************************************************


;function FofL, series, L

;FofL takes a series and calculates F for the
;specified value of L

;n_offsets=4
;F=fltarr(n_offsets)
;offset=0l
;for i=0,n_offsets-1 do begin
;    ser_to_var, series, L, offset, x_ave, num_of_time_bins, var
;    offset=offset+L/n_offsets
;    F[i]=((var/x_ave) - 1L) * sqrt((num_of_time_bins-1L)/2d)
;endfor
;stop;    ; L is a floating point number.   Mo found that if series is too big number, mean(F) is infinity.
;return, mean(F)
;end
;*******************************************************************************
;PRO ser_to_var, series, L, offset,X_ave,num_of_time_bins,var

;temp_series=series-offset
;somarr=where(temp_series ge 0)
;temp_series=temp_series[somarr]

;n=long64(n_elements(temp_series))
;num_of_time_bins=long64( (temp_series[n-1]/L) )
;end_time = L * num_of_time_bins
;temparr = where(temp_series ge end_time)
;if temparr[0] ne -1 then lopped_off = n_elements(temparr) else begin
;                                 lopped_off = 0
;                                 print,'SOMETHING WRONG HERE!   lopped_off = 0'
;                                 endelse
;x_ave = (double(n) - lopped_off) / double(num_of_time_bins)
;var=0d
;conc=0L
;t=0LL
;tcnt=0l
;for i = 0L, n-1L do begin
;   conc = conc + 1L
;   if (temp_series(i) GE (t+1L)*L) then begin
;      var = var + (double(conc - 1L)-x_ave)^2.0
;      t= long64(temp_series(i)/L)
;      tcnt=tcnt+1l
;      conc=1L
;    endif
;endfor

;var = var + (num_of_time_bins - tcnt)*(0 - x_ave)^2.0
;var = var/(num_of_time_bins - 1)
;stop
;end
;**********************************************************************************


;********************************************************************************
;ADD Following 3 subroutines for inputing and load 2ds data  see simple_2dsview_check.pro
;********************************************************************************
pro du_input_2ds_raw,ave_info,filenm,year,day,hhmmss_str,shh,smm,sss,sms,time0,$
    pathnm,Hntime,Hdiam,Hflags,Hw8_t,Vntime,Vdiam,Vflags,Vw8_t,Hntimetk,Vntimetk,ehh,emm,ess,ems

;this line added august 19, 2005; for tick values of the particles.
;following copied from generate_zoomed_ascii.pro
;********************************************************************************
Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
    FirstDataV,LastDataV,StripDataV
;*******************************************************************************
pathnm=!currentHPname
filenm='Time_is_from_'+ave_info.startTimeString+'_to_'+ave_info.endtimestring

struct_ascii = {_AsciiData, $
    AllMonths:0 , $
    NanoSeconds:0ULL , $
    Area: 0.0 , $
    L1n: 0 , $
    L2: 0 , $
    F1: 0 , $
    Adj1: 0.0, $
    Pc1: 0.0, $
    TAS: 0.0 }

starting_time_struct = ({_AsciiData})

device, CURSOR_STANDARD= !HOURGLASS_CURSOR  ; show hourglass while we process the data

;get Hntime Hdiam Hflags, Vntime, VDiam,Vflags  and all data
;***********************************************************************
;add in here for filter or not filtered data.
if ave_info.filter eq 1 then begin
    Hindex=where((*alldataH).nanoseconds ge ave_info.startnanoseconds and (*alldataH).reject eq 0 and $
        (*alldataH).nanoseconds le ave_info.endnanoseconds,contG)
endif else begin
    Hindex=where((*alldataH).nanoseconds ge ave_info.startnanoseconds and $
        (*alldataH).nanoseconds le ave_info.endnanoseconds,contG)
endelse

if contG gt 0 then begin
    h_array=(*alldataH)(Hindex)
    has_Hdata=1
    Hntime=h_array.nanoseconds
    Hdiam =h_array.L1n;      ;note may need to use M5 to get the size.  L1 is in unit tick 1tick=10um.
    Hflags=h_array.F1
    Hntimetk=h_array.probecounter
    Hw8_t   =h_array.w8_t
endif  else begin
    has_Hdata=0
    hntime=ave_info.startnanoseconds
    hdiam =0;      ;note may need to use M5 to get the size.
    hflags=0
    hntimetk=0
    hw8_t   =0
endelse

if ave_info.filter eq 1 then begin
    Vindex=where((*alldataV).nanoseconds ge ave_info.startnanoseconds and (*alldataV).reject eq 0 and $
        (*alldataV).nanoseconds le ave_info.endnanoseconds,contG)
endif else begin
    Vindex=where((*alldataV).nanoseconds ge ave_info.startnanoseconds and $
        (*alldataV).nanoseconds le ave_info.endnanoseconds,contG)
endelse

if contG gt 0 then begin
    v_array=(*alldataV)(Vindex)
    has_Vdata=1
    Vntime=v_array.nanoseconds
    Vdiam =v_array.L1n;      ;note may need to use M5 to get the size.
    Vflags=v_array.F1
    Vntimetk=v_array.probecounter
    Vw8_t   =v_array.w8_t
endif  else begin
    has_Vdata =0
    vntime=ave_info.startnanoseconds
    vdiam =0;      ;note may need to use M5 to get the size.
    vflags=0
    vntimetk=0
    vw8_t   =0
endelse
if has_Hdata eq 0 and has_Vdata eq 0 then begin
    rrr=dialog_message('No H data and No V data !!, try again',/information)
    return
endif

; I will sorted the data first.
index=sort(Hntime,/L64)
Hntime=Hntime(index)
Hdiam =Hdiam(index)
Hflags=Hflags(index)
Hntimetk=Hntimetk(index)
Hw8_t   =Hw8_t(index)

index=sort(Vntime,/L64)
Vntime=Vntime(index)
Vdiam =Vdiam(index)
Vflags=Vflags(index)
Vntimetk=Vntimetk(index)
Vw8_t   =Vw8_t(index)

;******************************************
;get the stop-time of the arrays
stopntime=ave_info.endnanoseconds;  max([Hntime,vntime])
SPEC_Nano2HMS,stopntime,a,hours,minutes,seconds,milli,micro,nano
stoptime=hours*3600.0+minutes*60.0+seconds+milli/1000.0+micro/1000000.0+nano/1000000000.0
ehh=floor(stoptime/(3600L))
emm=floor((stoptime mod 3600L)/60L)
ess=floor(stoptime mod 60L)
ems=round((stoptime mod 1L)*1000.0)    ;these are used for the stop time buttons.
;***********************************************
;get other parameters
;convert the start time ns(0) into hhmmss data format.
ntime0=ave_info.startnanoseconds;   min([Hntime(0),Vntime(0)])
SPEC_Nano2HMS,ntime0,a,hours,minutes,seconds,milli,micro,nano
time0=hours*3600.0+minutes*60.0+seconds+milli/1000.0+micro/1000000.0+nano/1000000000.0
shh1=floor(time0/(3600L))
smm1=floor((time0 mod 3600L)/60L)
sss1=floor(time0 mod 60L)
sms1=round((time0 mod 1L)*1000.0)
shh=shh1
smm=smm1
sss=sss1
sms=sms1;   ;this is used for the start time buttons.
if sms lt 10 then sms_str='00'+strtrim(sms,2) else begin
    if sms lt 100 then sms_str='0'+strtrim(sms,2) else sms_str=strtrim(sms,2)
endelse
hhmmss_str=strtrim(shh,2)+':'+strtrim(smm,2)+':'+strtrim(sss,2)+'.'+sms_str  ;in seconds.

;stop
year=2004
day =16

;***********************************************************************

; Widget_Control, ave_info.statusID, DYNAMIC_RESIZE=1, Set_Value= "2ds fishing data obtained: "; + fname
device, CURSOR_STANDARD= !ARROW_CURSOR  ; show hourglass while we process the data
;r = dialog_message(['ASCII file has been created:',fname],TITLE = 'Zoomed ASCII data written')
; r = dialog_message(['2ds Fishing data generated'],TITLE = '2DS fishing Data obtained')

;*********************************************************************************

widget_control,/hourglass
; filestr=filenm
; print,'done reading 2ds data'
; change the flags into 3 types. 0, 1, 2   from 0,1,2,3.
index=where(Hflags  eq 2, cont)
if cont gt 0 then Hflags(index)=1;  change 2 to 1.
index =where(Hflags eq 3, cont)
if cont gt 0 then Hflags(index)=2;     change 3 to 2.

index=where(Vflags eq 2, cont)
if cont gt 0 then Vflags(index)=1;  change 2 to 1.
index =where(Vflags eq 3, cont)
if cont gt 0 then Vflags(index)=2;     change 3 to 2.

;stop
;re-construct the time in unit of 1/16 micros seconds.
end; ;end of du_input_2ds_raw.pro for geting 2ds data
;*******************************************************************************
;*******************************************************************************
pro  input_and_load_2ds_data,ave_info,localstate
    ;read in the fast fssp data
    du_input_2ds_raw,ave_info,filenm,year,day,hhmmss_str,shh,smm,sss,sms,time0,$
        pathnm,Hntime,Hdiam,Hflags,Hw8_t,Vntime,Vdiam,Vflags,Vw8_t,Hntimetk,Vntimetk,ehh,emm,ess,ems

    intervine='n'

    if intervine eq 'y' then du_input_2ds_fake,ave_info,filenm,year,day,hhmmss_str,shh,smm,sss,sms,time0,$
        pathnm,Hntime,Hdiam,Hflags,Hw8_t,Vntime,Vdiam,Vflags,Vw8_t,Hntimetk,Vntimetk,ehh,emm,ess,ems

    ;*************************************************************
    widget_control,/hourglass

    ;next is using ntime, diam, flags to get the 7 groups of data
    ;and concentration time series and group for average all.
    ; input is ntime, diam,flags
    ; output is: yconc, xtime; ntimeg1,diamg1,flagsg1,   to *g6 and *ave.
    ; then assign them into pointers and to localstate.
    ; (1) 1111111111111111111111111111111111111111111111111111111111111

    ; now get the H data's goups
    ; now get V data 's groups
    ; now assign all pointers to localstates.

    ; now do 1 assign H data 22222222222222222222222222222222222222222222222222
    get_all_dataGroups,Hntime,Hdiam,Hflags,Hw8_t,pntime,pdiam,pflags,pw8_t,pyconc,pxtime,$
        pntimeg1,pdiamg1,pflagsg1,pw8_tg1,pntimeg2,pdiamg2,pflagsg2,pw8_tg2,pntimeg3,pdiamg3,pflagsg3,$
        pw8_tg3,pntimeg4,pdiamg4,pflagsg4,pw8_tg4,pntimeg5,pdiamg5,pflagsg5,pw8_tg5,pntimeg6,pdiamg6,$
        pflagsg6,pw8_tg6,pntimeg7,pdiamg7,pflagsg7,pw8_tg7,Hntimetk,pntimetk,pntimetkg1,pntimetkg2,$
        pntimetkg3,pntimetkg4,pntimetkg5,pntimetkg6,pntimetkg7,ave_info,$
        pHtms1,pHtms2,pHtms3,pHtms4,pHtms5,pHtms6,pHtms7;  added this line for time series.
    ; now assign then to localstate.
    localstate.pHntimeg1=pntimeg1
    localstate.pHdiamg1=pdiamg1
    localstate.pHflagsg1=pflagsg1
    localstate.pHntimeg2=pntimeg2
    localstate.pHdiamg2=pdiamg2
    localstate.pHflagsg2=pflagsg2
    localstate.pHntimeg3=pntimeg3
    localstate.pHdiamg3=pdiamg3
    localstate.pHflagsg3=pflagsg3
    localstate.pHntimeg4=pntimeg4
    localstate.pHdiamg4=pdiamg4
    localstate.pHflagsg4=pflagsg4
    localstate.pHntimeg5=pntimeg5
    localstate.pHdiamg5=pdiamg5
    localstate.pHflagsg5=pflagsg5
    localstate.pHntimeg6=pntimeg6
    localstate.pHdiamg6=pdiamg6
    localstate.pHflagsg6=pflagsg6
    localstate.pHntimeg7=pntimeg7
    localstate.pHdiamg7=pdiamg7
    localstate.pHflagsg7=pflagsg7
    localstate.pHyconc=pyconc
    localstate.pHxtime=pxtime
    ;*******************************************added august 19,2005
    localstate.pHntimetkg1=pntimetkg1
    localstate.pHntimetkg2=pntimetkg2
    localstate.pHntimetkg3=pntimetkg3
    localstate.pHntimetkg4=pntimetkg4
    localstate.pHntimetkg5=pntimetkg5
    localstate.pHntimetkg6=pntimetkg6
    localstate.pHntimetkg7=pntimetkg7
    localstate.pHw8_tg1 =pw8_tg1
    localstate.pHw8_tg2 =pw8_tg2
    localstate.pHw8_tg3 =pw8_tg3
    localstate.pHw8_tg4 =pw8_tg4
    localstate.pHw8_tg5 =pw8_tg5
    localstate.pHw8_tg6 =pw8_tg6
    localstate.pHw8_tg7 =pw8_tg7
    ;************************************************added following in May, 1, 2006.
    localstate.pHtms1 =pHtms1
    localstate.pHtms2 =pHtms2
    localstate.pHtms3 =pHtms3
    localstate.pHtms4 =pHtms4
    localstate.pHtms5 =pHtms5
    localstate.pHtms6 =pHtms6
    localstate.pHtms7 =pHtms7
    ;*******************************************************************************

    index=where(*pw8_t gt 0,contG)
    if contG gt 0 then min_dtH=min((*pw8_t)(index)) else min_dtH=9999999999LL

    ;********************************************above added august 19, 2005
    ;end of assign H data
    ;get the stop time shh, smm, sss, sms from the ave_info.
    ;*********************************************************************************
    ; Ehh=End_total_seconds/3600L
    ; Emm=(End_total_seconds mod 3600L)/60
    ; ESS =End_total_seconds mod 60
    ; ems =round((End_total_seconds -floor(End_total_seconds))*1000.0)
    widget_control,localstate.StpHr_ID,set_value=ehh
    widget_control,localstate.Stpmin_ID,set_value=emm
    widget_control,localstate.Stpsec_ID,set_value=ess
    widget_control,localstate.Stpmsc_ID,set_value=ems

    widget_control,localstate.StrHr_ID,set_value=shh
    widget_control,localstate.Strmin_ID,set_value=smm
    widget_control,localstate.Strsec_ID,set_value=sss
    widget_control,localstate.Strmsc_ID,set_value=sms
    ;assigne all above values to localstate structure.
    ;*******************************************added august 19,2005
    ;********************************************above added august 19, 2005
    localstate.year=year
    localstate.day=day
    localstate.hhmmss_str=hhmmss_str
    localstate.time0=time0
    localstate.StopHh =ehh
    localstate.Stopmm =emm
    localstate.Stopss =ess
    localstate.Stopms =ems
    localstate.Starthh =shh
    localstate.Startmm =smm
    localstate.Startss =sss
    localstate.Startms =sms
    localstate.pathnm=pathnm
    localstate.infilename=filenm

    ;stop
    ;end of 1 11111111111111111111111111111111111 asign all data (HandV) data'
    ; (3) now begin V data   333333333333333333333333333333333333333333333333
    get_all_dataGroups,Vntime,Vdiam,Vflags,Vw8_t,pntime,pdiam,pflags,pw8_t,pyconc,pxtime,$
        pntimeg1,pdiamg1,pflagsg1,pw8_tg1,pntimeg2,pdiamg2,pflagsg2,pw8_tg2,pntimeg3,pdiamg3,pflagsg3,$
        pw8_tg3, pntimeg4,pdiamg4,pflagsg4,pw8_tg4,pntimeg5,pdiamg5,pflagsg5,pw8_tg5,pntimeg6,pdiamg6,$
        pflagsg6,pw8_tg6,pntimeg7,pdiamg7,pflagsg7,pw8_tg7,Vntimetk,pntimetk,pntimetkg1,pntimetkg2,$
        pntimetkg3,pntimetkg4,pntimetkg5,pntimetkg6,pntimetkg7,ave_info,$
        pVtms1,pVtms2,pVtms3,pVtms4,pVtms5,pVtms6,pVtms7;  added this line for time series.
    ; now assign then to localstate.
    localstate.pVntimeg1=pntimeg1
    localstate.pVdiamg1=pdiamg1
    localstate.pVflagsg1=pflagsg1
    localstate.pVntimeg2=pntimeg2
    localstate.pVdiamg2=pdiamg2
    localstate.pVflagsg2=pflagsg2
    localstate.pVntimeg3=pntimeg3
    localstate.pVdiamg3=pdiamg3
    localstate.pVflagsg3=pflagsg3
    localstate.pVntimeg4=pntimeg4
    localstate.pVdiamg4=pdiamg4
    localstate.pVflagsg4=pflagsg4
    localstate.pVntimeg5=pntimeg5
    localstate.pVdiamg5=pdiamg5
    localstate.pVflagsg5=pflagsg5
    localstate.pVntimeg6=pntimeg6
    localstate.pVdiamg6=pdiamg6
    localstate.pVflagsg6=pflagsg6
    localstate.pVntimeg7=pntimeg7
    localstate.pVdiamg7=pdiamg7
    localstate.pVflagsg7=pflagsg7
    localstate.pVyconc=pyconc
    localstate.pVxtime=pxtime
    ;*******************************************added august 19,2005
    localstate.pVntimetkg1=pntimetkg1
    localstate.pVntimetkg2=pntimetkg2
    localstate.pVntimetkg3=pntimetkg3
    localstate.pVntimetkg4=pntimetkg4
    localstate.pVntimetkg5=pntimetkg5
    localstate.pVntimetkg6=pntimetkg6
    localstate.pVntimetkg7=pntimetkg7
    localstate.pVw8_tg1 =pw8_tg1
    localstate.pVw8_tg2 =pw8_tg2
    localstate.pVw8_tg3 =pw8_tg3
    localstate.pVw8_tg4 =pw8_tg4
    localstate.pVw8_tg5 =pw8_tg5
    localstate.pVw8_tg6 =pw8_tg6
    localstate.pVw8_tg7 =pw8_tg7
    ;********************************************above added august 19, 2005
    ;************************************************added following in May, 1, 2006.
    localstate.pVtms1 =pVtms1
    localstate.pVtms2 =pVtms2
    localstate.pVtms3 =pVtms3
    localstate.pVtms4 =pVtms4
    localstate.pVtms5 =pVtms5
    localstate.pVtms6 =pVtms6
    localstate.pVtms7 =pVtms7
    ;*******************************************************************************
    ;end of assign V data
    ;assugn minimium inter_ntimes
    index=where(*pw8_t gt 0,contG)
    if contG gt 0 then min_dtV=min((*pw8_t)(index)) else min_dtV=9999999999LL
    min_dt=min([min_dtH,min_dtV])
    localstate.inter_ntimes_min=min_dt
end;  ;end of input_and_load_and_assign_2ds_data
;*****************************************************************************
;*****************************************************************************
pro get_all_dataGroups,ntime,diam,flags,w8_t,pntime,pdiam,pflags,pw8_t,pyconc,pxtime,$
    pntimeg1,pdiamg1,pflagsg1,pw8_tg1,pntimeg2,pdiamg2,pflagsg2,pw8_tg2,pntimeg3,pdiamg3,pflagsg3,$
    pw8_tg3,pntimeg4,pdiamg4,pflagsg4,pw8_tg4,pntimeg5,pdiamg5,pflagsg5,pw8_tg5,pntimeg6,pdiamg6,$
    pflagsg6,pw8_tg6,pntimeg7,pdiamg7,pflagsg7,pw8_tg7,ntimetk,pntimetk,pntimetkg1,pntimetkg2,$
    pntimetkg3,pntimetkg4,pntimetkg5,pntimetkg6,pntimetkg7,ave_info,$
    ptms1,ptms2,ptms3,ptms4,ptms5,ptms6,ptms7; added may 1, 2006.

nnn=n_elements(ntime)
pntime=ptr_new(lon64arr(nnn))
pdiam =ptr_new(fltarr(nnn))
pflags=ptr_new(intarr(nnn))
pntimetk=ptr_new(lon64arr(nnn))
pw8_t   =ptr_new(lon64arr(nnn))
ptms1   =ptr_new(lon64arr(nnn))
ptms2   =ptr_new(lon64arr(nnn))
ptms3   =ptr_new(lon64arr(nnn))
ptms4   =ptr_new(lon64arr(nnn))
ptms5   =ptr_new(lon64arr(nnn))
ptms6   =ptr_new(lon64arr(nnn))
ptms7   =ptr_new(lon64arr(nnn))

*pntime=ntime;  these are group for all particles of H and V
*pdiam =diam
*pflags=flags
*pntimetk=ntimetk
*pw8_t   =w8_t

;calculate the time series
indexS=sort(ntime,/L64)
w8_tS =w8_t(indexS)

time_series=lon64arr(nnn)
time_series(0)=0LL
for i=1L, nnn-1LL do begin
    time_series(i)=time_series(i-1L)+w8_tS(i)
endfor
time_series=time_series(indexS)


;**********************************************************************************
;find out if the time intervals is greater than 1 seconds or less than 1 second
total_time_period=(ntime(nnn-1)-ntime(0))/1000000.0;  milliseconds
total_time_period=(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000.0; mili-seconds

if total_time_period lt 1000.0 then begin; total_time_period less than 1 second.

    if n_elements(ntime) ne 1 and ntime(0) ne 0.0 then begin  ; incase there is no H data or no V data.
        tstime=ntime/1000000000.0;   convert to seconds.
        ;nnn_milli_seconds=(ntime(nnn-1)-ntime(0))/1000000.0
        nnn_milli_seconds=total_time_period
        yconc=fltarr(round(nnn_milli_seconds/10.0)>2);  make it 100Hz resolution
        ;xtime=tstime(0)+indgen(nnn_milli_seconds)/1000.0
        xtime=ave_info.startnanoseconds/1000000000.0+indgen(round(nnn_milli_seconds/10.0)>2)/100.0;   change to this Feb 28.
        fffnn=round(nnn_milli_seconds/10.0)*1L-2L
        if fffnn lt 1 then  begin
            rrr= dialog_message('Time period too short, try again !',/information)
            return
        endif
        for k=0L,fffnn do begin
            indexn=where(tstime ge xtime(k) and tstime lt xtime(k+1L),contn)
            yconc(k)=contn
        endfor
        pyconc=ptr_new(yconc)
        pxtime=ptr_new(xtime);   in seconds

    endif else begin
        tstime=ntime/1000000000.0;   convert to seconds.
        nnn_milli_seconds=total_time_period
        yconc=fltarr(round(nnn_milli_seconds/10.0)>2)*0.0
        xtime=ave_info.startnanoseconds/1000000000.0+indgen(round(nnn_milli_seconds/10.0)>2)/100.0
        pyconc=ptr_new(yconc)
        pxtime=ptr_new(xtime)
    endelse
endif else begin;   total_time_period GE  1 second
    if n_elements(ntime) ne 1 and ntime(0) ne 0.0 then begin  ; incase there is no H data or no V data.
        tstime=ntime/1000000000.0;   convert to seconds.
        ;nnseconds=ceil((ntime(nnn-1)-ntime(0))/1000000000.0);  ceil(tstime(nnn-1)-tstime(0))
        nnseconds=(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000000.0

        if nnseconds le 10 then begin
            yconc=fltarr(nnseconds*100L);  make it 100Hz resolution
            ; xtime=tstime(0)+indgen(nnseconds*100)/100.0
            xtime=ave_info.startnanoseconds/1000000000.0+indgen(nnseconds*100)/100.0; change to this Feb 28.

            fffnn=nnseconds*100L-2L
            for k=0L,fffnn do begin
                indexn=where(tstime ge xtime(k) and tstime lt xtime(k+1L),contn)
                yconc(k)=contn
            endfor
            pyconc=ptr_new(fltarr(nnseconds*100L))
            pxtime=ptr_new(fltarr(nnseconds*100L))
            *pyconc=yconc
            *pxtime=xtime
        endif; if nnseconds le 10

        if nnseconds gt 10 then begin
            yconc=fltarr(nnseconds*10);  make it 10Hz resolution
            ;xtime=tstime(0)+indgen(nnseconds*10L)/10.0
            xtime=ave_info.startnanoseconds/1000000000.0+indgen(nnseconds*10)/10.0;  change to this Feb 28.
            ;cxtime=tstime(0)+indgen(nnseconds)
            fffnn=nnseconds*10L-2L
            for k=0L,fffnn do begin
                indexn=where(tstime ge xtime(k) and tstime lt xtime(k+1L),contn)
                yconc(k)=contn
            endfor
            pyconc=ptr_new(fltarr(nnseconds*10))
            pxtime=ptr_new(fltarr(nnseconds*10))
            *pyconc=yconc
            *pxtime=xtime
        endif;  if nnseconds gt 10.
    endif else begin
        tstime=ntime/1000000000.0;   convert to seconds.
        nnseconds=1
        yconc=0.0*fltarr(nnseconds*10);  make it 10Hz resolution
        xtime=ave_info.startnanoseconds/1000000000.0+indgen(nnseconds*10);xtime=tstime(0)+indgen(nnseconds)
        pyconc=ptr_new(yconc)
        pxtime=ptr_new(xtime)
    endelse
endelse;     end of    total_time_period GE  1 second
;**************************************************************************************************
; stop
;get the time series
if n_elements(ntime) ne 1 and ntime(0) ne 0.0 then begin ; if data are not zero.
    ;sort teh data out in different groups
    ;group1 is flags=(-1,0)  ;group2 is (-1,1);  group3 is (-1,2)   group4 is (-1,0,1), (-1,0,2), (-1,1,2)
    index=where( flags eq 0 and w8_t gt 0, contF)
    if contF gt 0 then begin
        ntimeg1=ntime(index)
        diamG1 =diam(index)
        flagsg1=flags(index)
        ntimetkg1=ntimetk(index)
        w8_tg1   =w8_t(index)
        tms_g1   =time_series(index)
    endif else begin
        ntimeg1=[0]
        diamG1 =[0]
        flagsg1=[0]
        ntimetkg1=[0]
        w8_tg1=[0]
        tms_g1=[0]
    endelse


    index=where( flags eq 1 and w8_t gt 0, contF)
    if contF gt 0 then begin
        ntimeg2=ntime(index)
        diamG2 =diam(index)
        flagsg2=flags(index)
        ntimetkg2=ntimetk(index)
        w8_tg2   =w8_t(index)
        tms_g2   =time_series(index)
    endif else begin
        ntimeg2=[0]
        diamG2 =[0]
        flagsg2=[0]
        ntimetkg2=[0]
        w8_tg2=[0]
        tms_g2=[0]
    endelse

    index=where(flags eq 2 and w8_t gt 0, contF)
    if contF gt 0 then begin
        ntimeg3=ntime(index)
        diamG3 =diam(index)
        flagsg3=flags(index)
        ntimetkg3=ntimetk(index)
        w8_tg3=w8_t(index)
        tms_g3   =time_series(index)
    endif else begin
        ntimeg3=[0]
        diamG3 =[0]
        flagsg3=[0]
        ntimetkg3=[0]
        w8_tg3=[0]
        tms_g3=[0]
    endelse

    index=where((flags eq 0 or flags eq 1)  and w8_t gt 0, contF)
    if contF gt 0 then begin
        ntimeg4=ntime(index)
        diamG4 =diam(index)
        flagsg4=flags(index)
        ntimetkg4=ntimetk(index)
        w8_tg4=w8_t(index)
        tms_g4   =time_series(index)
    endif else begin
        ntimeg4=[0]
        diamG4 =[0]
        flagsg4=[0]
        ntimetkg4=[0]
        w8_tg4=[0]
        tms_g4=[0]
    endelse


    index=where((flags eq 0 or flags eq 2) and w8_t gt 0, contF)
    if contF gt 0 then begin
        ntimeg5=ntime(index)
        diamG5 =diam(index)
        flagsg5=flags(index)
        ntimetkg5=ntimetk(index)
        w8_tg5=w8_t(index)
        tms_g5   =time_series(index)
    endif else begin
        ntimeg5=[0]
        diamG5 =[0]
        flagsg5=[0]
        ntimetkg5=[0]
        w8_tg5=[0]
        tms_g5=[0]
    endelse

    index=where((flags eq 1 or flags eq 2)  and w8_t gt 0, contF)
    if contF gt 0 then begin
        ntimeg6=ntime(index)
        diamG6 =diam(index)
        flagsg6=flags(index)
        ntimetkg6=ntimetk(index)
        w8_tg6=w8_t(index)
        tms_g6   =time_series(index)
    endif else begin
        ntimeg6=[0]
        diamG6 =[0]
        flagsg6=[0]
        ntimetkg6=[0]
        w8_tg6=[0]
        tms_g6=[0]
    endelse

    index=where(w8_t gt 0, contF)
    if contF gt 0 then begin
        ntimeg7=ntime(index)
        diamG7 =diam(index)
        flagsg7=flags(index)
        ntimetkg7=ntimetk(index)
        w8_tg7=w8_t(index)
        tms_g7   =time_series(index)
    endif else begin
        ntimeg7=[0]
        diamG7 =[0]
        flagsg7=[0]
        ntimetkg7=[0]
        w8_tg7=[0]
        tms_g7=[0]
    endelse

    pntimeg1=ptr_new(ntimeg1)
    pdiamg1 =ptr_new(diamg1)
    pflagsg1=ptr_new(flagsg1)
    pw8_tg1 =ptr_new(w8_tg1)
    pntimetkg1=ptr_new(ntimetkg1)

    pntimeg2=ptr_new(ntimeg2)
    pdiamg2 =ptr_new(diamg2)
    pflagsg2=ptr_new(flagsg2)
    pw8_tg2 =ptr_new(w8_tg2)
    pntimetkg2=ptr_new(ntimetkg2)

    pntimeg3=ptr_new(ntimeg3)
    pdiamg3 =ptr_new(diamg3)
    pflagsg3=ptr_new(flagsg3)
    pw8_tg3 =ptr_new(w8_tg3)
    pntimetkg3=ptr_new(ntimetkg3)

    pntimeg4=ptr_new(ntimeg4)
    pdiamg4 =ptr_new(diamg4)
    pflagsg4=ptr_new(flagsg4)
    pw8_tg4 =ptr_new(w8_tg4)
    pntimetkg4=ptr_new(ntimetkg4)

    pntimeg5=ptr_new(ntimeg5)
    pdiamg5 =ptr_new(diamg5)
    pflagsg5=ptr_new(flagsg5)
    pw8_tg5 =ptr_new(w8_tg5)
    pntimetkg5=ptr_new(ntimetkg5)

    pntimeg6=ptr_new(ntimeg6)
    pdiamg6 =ptr_new(diamg6)
    pflagsg6=ptr_new(flagsg6)
    pw8_tg6 =ptr_new(w8_tg6)
    pntimetkg6=ptr_new(ntimetkg6)

    pntimeg7=ptr_new(ntimeg7)
    pdiamg7 =ptr_new(diamg7)
    pflagsg7=ptr_new(flagsg7)
    pw8_tg7 =ptr_new(w8_tg7)
    pntimetkg7=ptr_new(ntimetkg7)
    ptms1   =ptr_new(tms_g1)
    ptms2   =ptr_new(tms_g2)
    ptms3   =ptr_new(tms_g3)
    ptms4   =ptr_new(tms_g4)
    ptms5   =ptr_new(tms_g5)
    ptms6   =ptr_new(tms_g6)
    ptms7   =ptr_new(tms_g7)
endif else begin   ; if  data are zeros.
    nnn=1;n_elements(ntimeg6)
    pntimeg1=ptr_new(lon64arr(nnn))
    pdiamg1 =ptr_new(fltarr(nnn))
    pflagsg1=ptr_new(intarr(nnn))
    pntimetkg1=ptr_new(lon64arr(nnn))
    pw8_tg1 =ptr_new(lon64arr(nnn))

    pntimeg2=ptr_new(lon64arr(nnn))
    pdiamg2 =ptr_new(fltarr(nnn))
    pflagsg2=ptr_new(intarr(nnn))
    pntimetkg2=ptr_new(lon64arr(nnn))
    pw8_tg2 =ptr_new(lon64arr(nnn))

    pntimeg3=ptr_new(lon64arr(nnn))
    pdiamg3 =ptr_new(fltarr(nnn))
    pflagsg3=ptr_new(intarr(nnn))
    pntimetkg3=ptr_new(lon64arr(nnn))
    pw8_tg3 =ptr_new(lon64arr(nnn))

    pntimeg4=ptr_new(lon64arr(nnn))
    pdiamg4 =ptr_new(fltarr(nnn))
    pflagsg4=ptr_new(intarr(nnn))
    pntimetkg4=ptr_new(lon64arr(nnn))
    pw8_tg4 =ptr_new(lon64arr(nnn))

    pntimeg5=ptr_new(lon64arr(nnn))
    pdiamg5 =ptr_new(fltarr(nnn))
    pflagsg5=ptr_new(intarr(nnn))
    pntimetkg5=ptr_new(lon64arr(nnn))
    pw8_tg5 =ptr_new(lon64arr(nnn))

    pntimeg6=ptr_new(lon64arr(nnn))
    pdiamg6 =ptr_new(fltarr(nnn))
    pflagsg6=ptr_new(intarr(nnn))
    pntimetkg6=ptr_new(lon64arr(nnn))
    pw8_tg6 =ptr_new(lon64arr(nnn))

    pntimeg7=ptr_new(lon64arr(nnn))
    pdiamg7 =ptr_new(fltarr(nnn))
    pflagsg7=ptr_new(intarr(nnn))
    pntimetkg7=ptr_new(lon64arr(nnn))
    pw8_tg7 =ptr_new(lon64arr(nnn))
    ptms1   =ptr_new(lon64arr(nnn))
    ptms2   =ptr_new(lon64arr(nnn))
    ptms3   =ptr_new(lon64arr(nnn))
    ptms4   =ptr_new(lon64arr(nnn))
    ptms5   =ptr_new(lon64arr(nnn))
    ptms6   =ptr_new(lon64arr(nnn))
    ptms7   =ptr_new(lon64arr(nnn))
endelse

end;  ;end of get_all_dataGroup
;***********************************************************************************
;*****************************************************
pro SPEC_Nano2HMS,ns,a,hours,minutes,seconds,milli,micro,nano
    ; accepts ULL values of nanoseconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    hours=ns/NanosecondsPerHour
    if hours GT 0 then  ns = ns - (hours * NanosecondsPerHour)
    minutes=ns/NanosecondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * NanosecondsPerMinute)
    seconds=ns/NanosecondsPerSecond
    if seconds GT 0 then  ns = ns - (seconds * NanosecondsPerSecond)
    milli=ns/NanosecondsPerMilli
    if milli GT 0 then  ns = ns - (milli * NanosecondsPerMilli)
    micro=ns/NanosecondsPerMicro
    if micro GT 0 then  ns = ns - (micro * NanosecondsPerMicro)
    a = string(format = '(%"%2.2d:%2.2d:%2.2d.%3.3d.%3.3d.%3.3d")',hours,minutes,seconds,milli,micro,ns)
    nano=ns
end
;**************************************************************************

pro get_the_plotxyvalues,cstoptime,cstarttime,subsetntime,subset_time_series,NperPD,x,tsy1,tsy2,tsc3
    ;first see if there are -1 flags in the data if no thne good to do all processing.
    ;if there is 1 or more points, then need to discard that period and start a new
    ;period starting from the particle right after the -1 flag.

    subsetntime_save=subsetntime
    subset_time_series_ave=subset_time_series

    if n_elements(subsetntime) gt NperPD then begin
        done=0
    endif else begin
        x=[0,100]
        tsy1=[-3.33,-3.33]
        tsy2=[0.1,0.1]
        tsc3=[0.0,0.0]
        r=dialog_message(' Too few particles to make the plots, try lesser N numbers',/information)
        return
    endelse

    cont=0L
    earlier_end_time=subsetntime(0)
    earlier_t2=subsetntime(0);   in units of nanoseconds.

    while done eq 0 do begin
        cont=cont+1
        ;get results for one subset
        t1=earlier_t2;  subsetntime(0)
        t2=subsetntime(NperPD-1LL)+long64((subsetntime(NperPD)-subsetntime(NperPD-1LL))/2LL); in nanoseconds
        earlier_end_time=subsetntime(NperPD-1LL); ;update earlier_end_time
        new_subsetntime=subsetntime(NperPD:*)

        subset_time_series_out=subset_time_series(0LL:NperPD-1LL)
        subset_time_series_outf=subset_time_series(0LL:NperPD-1LL)-subset_time_series_out(0); added Feb 27,2006.

        new_subset_time_series=subset_time_series(NperPD:*)

        this_delta_t=(t2-t1)/1000000000.0;  in seconds
        fconc=NperPD/this_delta_T

        ; basic_fish_2ds,ntime_outf,Larray,Farray,50ll; Farray, Farray, y1,y2 are the desired results.
        ; basic_fish_2ds,ntimetk_outf,Larray,Farray,50ll;   ;note that y2 will never be negative.
        basic_fish_2ds,subset_time_series_outf,Larray,Farray,1LL

        y1=max(Farray)
        somarr=where(Farray eq y1)  ; always somarr ne -1
        if somarr(0) eq -1 then begin
            y1=-1.0
            y2=2.0*0.00001
        endif else  y2=Larray(somarr(0));   note that L array is time in ticks.

        ;************************************************
        ;accumulate the result for each subset
        if cont eq 1 then begin
            x=[earlier_t2,t2];      for start-time edges;    the first time should the selected start time, not zero.
            Tsy1=[y1,y1]
            Tsy2=[y2,y2]
            Tsc3=[fconc,fconc]

        endif else begin
            x=[x,t1,t2]
            TSy1=[TSy1, y1,y1]
            TSy2=[TSy2, y2,y2]
            Tsc3=[tsc3,fconc,fconc]
        endelse
        earlier_t2=t2
        subsetntime=new_subsetntime
        subset_time_series=new_subset_time_series

        if n_elements(subsetntime) le NperPD then begin
            done=1
            nnf=n_elements(subsetntime)
            ; t_end=subsetntime(nnf-1)
            t_endf=cstoptime-cstarttime+x(0)
            ;x=[x,earlier_t2,t_end]
            x=[x,earlier_t2,t_endf]
            tsy1=[tsy1,-3.33,-3.33]
            tsy2=[tsy2,0.1,0.1]
            nnn=n_elements(x)
            max_delta_t=max([x(1:nnn-1)-x(0:nnn-2)])
            delta_Tend=((t_endf-earlier_t2) > max_delta_t)/1000000.0;  seconds
            fconc=n_elements(subsetntime)/delta_Tend
            tsc3=[tsc3,fconc,fconc]
        endif

    endwhile
    subsetntime=subsetntime_save
    subset_time_series=subset_time_series_ave
end;  ;end of get_the_plotxy_values
;*****************************************************************************

pro get_the_subsetdata,localstate,subsetntime,subsetdiam,subsettms,CstartTime,CstopTime,$
    Stime_str,Etime_str,sizes_str,groupflags,xtime,yconc

;************************************************************
;there are two cases:   type =0=H  or type=1=V
if localstate.type eq 0 then begin
    year =localstate.year
    day  =localstate.day
    time0=localstate.time0
    ;calculate the total time series

    ;**********************************************
    NperPd=localstate.NperPD

    which_group,localstate,group1,group2,group3,group4,group5,group6,group7

    if group1 eq 1 then begin
        subsetntime=*(localstate.pHntimeg1);ntime1
        subsetdiam =*(localstate.pHdiamg1);diam1
        group=1
        groupflags='Edges0'
        subsetw8_t   =*(localstate.pHw8_tg1)
        subsettms    =*(localstate.pHtms1)
    endif

    if group2 eq 1 then begin
        subsetntime=*(localstate.pHntimeg2);ntime1
        subsetdiam =*(localstate.pHdiamg2);diam1
        group=2
        groupflags='Edges1'
        subsetw8_t   =*(localstate.pHw8_tg2)
        subsettms    =*(localstate.pHtms2)
    endif

    if group3 eq 1 then begin
        subsetntime=*(localstate.pHntimeg3);ntime1
        subsetdiam =*(localstate.pHdiamg3);diam1
        group=3
        groupflags='Edges2'
        subsetw8_t   =*(localstate.pHw8_tg3)
        subsettms    =*(localstate.pHtms3)
    endif

    if group4 eq 1 then begin
        subsetntime=*(localstate.pHntimeg4);ntime1
        subsetdiam =*(localstate.pHdiamg4);diam1
        group=4
        groupflags='Edges01'
        subsetw8_t   =*(localstate.pHw8_tg4)
        subsettms    =*(localstate.pHtms4)
    endif

    if group5 eq 1 then begin
        subsetntime=*(localstate.pHntimeg5);ntime1
        subsetdiam =*(localstate.pHdiamg5);diam1
        group=5
        groupflags='Edges02'
        subsetw8_t   =*(localstate.pHw8_tg5)
        subsettms    =*(localstate.pHtms5)
    endif

    if group6 eq 1 then begin
        subsetntime=*(localstate.pHntimeg6);ntime1
        subsetdiam =*(localstate.pHdiamg6);diam1
        group=6
        groupflags='Edges12'
        subsetw8_t   =*(localstate.pHw8_tg6)
        subsettms    =*(localstate.pHtms6)
    endif

    if group7 eq 1 then begin
        subsetntime=*(localstate.pHntimeg7);ntime1
        subsetdiam =*(localstate.pHdiamg7);diam1
        group=7
        groupflags='Edges012'
        subsetw8_t   =*(localstate.pHw8_tg7)
        subsettms    =*(localstate.pHtms7)
    endif
    localstate.group=group
    yconc=*(localstate.pHyconc)
    xtime=*(localstate.pHxtime); whole file's time series

    ;further select teh aprticles in the range of size1 and size2
    size1=localstate.sizeLo
    size2=localstate.sizeHi
    sizes_str='size= '+string(size1,format='(F6.2)')+' to '+string(size2,format='(F6.2)')
    ; indexsize=where((subsetdiam ge size1 and subsetdiam lt size2) or (subsetflags eq -1),contggg)
    indexsize=where((subsetdiam ge size1 and subsetdiam lt size2),contggg)
    ;stop
    if contggg gt 0 then begin
        subsetntime =subsetntime(indexsize)
        subsetw8_t    =subsetw8_t(indexsize)
        subsetdiam =subsetdiam(indexsize)
        subsettms  =subsettms(indexsize)
    endif else begin
        subsetntime=[-99.9]
        subsetw8_t   =[-99.9]
        subsetdiam  =[-99.9]
        subsettms   =[0]
    endelse

    ;further select the particles in the range of chosen startTime and stopTIME

    ;note that time0=hhmmss+time(0)/1000.0=hh*3600+mm*60+45.6+ 0.1 seconds.
    cStartTime=LONG64(localstate.starthh*3600L+localstate.startmm*60L+$
        localstate.startss)*1000000000L+(localstate.startms)*1000000L
    cStopTime =LONG64(localstate.stophh*3600L+localstate.stopmm*60L+$
        localstate.stopss)*1000000000L+(localstate.stopms)*1000000L
    stime_str=strtrim(localstate.starthh,2)+':'+strtrim(localstate.startmm,2)+':'+$
        strtrim(localstate.startss,2) +':'+strtrim(round(localstate.startms),2)
    Etime_str=strtrim(localstate.stophh,2)+':'+strtrim(localstate.stopmm,2)+':'+$
        strtrim(localstate.stopss,2)+':'+strtrim(round(localstate.stopms),2)
    ;therefore cstarttime  and cstoptime is seconds from the ntime(0)

    indextime=where(subsetntime ge cStartTime and subsetntime le cStoptime,contggg)
    if contggg gt 0 then begin
        subsetntime =subsetntime(indextime)
        subsetw8_t    =subsetw8_t(indextime)
        subsetdiam =subsetdiam(indextime)
        subsettms  =subsettms(indextime)
    endif else begin
        subsetntime=[-99.9]
        subsetw8_t   =[-99.9]
        subsetdiam  =[-99.9]
        subsettms=[0]
    endelse


    ;!!!!!!! important,  The time is not monotonic !!!!  this can be done in the very beginning of the input
    ;        2ds raw data part.
    ; I will sorted the data first.
    ; index=sort(subsetntime,/L64)
    ; subsetntime=subsetntime(index)
    ; subsetw8_t   =subsetw8_t(index)
    ; subsetdiam =subsetdiam(index)

    ;tempary make this so that it can be compared
    ; subsetntimef=subsetntime
    ; CstartTimef=CstartTime
    ; CstopTimef = CstopTime
    ; Stime_strf =Stime_str
    ; Etime_strf =Etime_str
    ;sizes_strf  =sizes_str
    ; subsetw8_tf   =subsetw8_t
endif;  ;endif of if tyep eq 1 for H type
;******************************************************************************
; now for V type particles
if localstate.type eq 1 then begin
    year =localstate.year
    day  =localstate.day
    time0=localstate.time0

    ;calculate the total time series

    ;**********************************************
    NperPd=localstate.NperPD

    which_group,localstate,group1,group2,group3,group4,group5,group6,group7

    if group1 eq 1 then begin
        subsetntime=*(localstate.pVntimeg1);ntime1
        subsetdiam =*(localstate.pVdiamg1);diam1
        group=1
        groupflags='Edges0'
        subsetw8_t   =*(localstate.PVw8_tg1)
        subsettms    =*(localstate.pVtms1)
    endif

    if group2 eq 1 then begin
        subsetntime=*(localstate.pVntimeg2);ntime1
        subsetdiam =*(localstate.pVdiamg2);diam1
        group=2
        groupflags='Edges1'
        subsetw8_t   =*(localstate.PVw8_tg2)
        subsettms    =*(localstate.pVtms2)
    endif

    if group3 eq 1 then begin
        subsetntime=*(localstate.pVntimeg3);ntime1
        subsetdiam =*(localstate.pVdiamg3);diam1
        group=3
        groupflags='Edges2'
        subsetw8_t   =*(localstate.PVw8_tg3)
        subsettms    =*(localstate.pVtms3)
    endif

    if group4 eq 1 then begin
        subsetntime=*(localstate.pVntimeg4);ntime1
        subsetdiam =*(localstate.pVdiamg4);diam1
        group=4
        groupflags='Edges01'
        subsetw8_t   =*(localstate.PVw8_tg4)
        subsettms    =*(localstate.pVtms4)
    endif

    if group5 eq 1 then begin
        subsetntime=*(localstate.pVntimeg5);ntime1
        subsetdiam =*(localstate.pVdiamg5);diam1
        group=5
        groupflags='Edges02'
        subsetw8_t   =*(localstate.PVw8_tg5)
        subsettms    =*(localstate.pVtms5)
    endif

    if group6 eq 1 then begin
        subsetntime=*(localstate.pVntimeg6);ntime1
        subsetdiam =*(localstate.pVdiamg6);diam1
        group=6
        groupflags='Edges12'
        subsetw8_t   =*(localstate.PVw8_tg6)
        subsettms    =*(localstate.pVtms6)
    endif

    if group7 eq 1 then begin
        subsetntime=*(localstate.pVntimeg7);ntime1
        subsetdiam =*(localstate.pVdiamg7);diam1
        group=7
        groupflags='Edges012'
        subsetw8_t   =*(localstate.PVw8_tg7)
        subsettms    =*(localstate.pVtms7)
    endif
    localstate.group=group
    yconc=*(localstate.pVyconc)
    xtime=*(localstate.pVxtime); whole file's time series

    ;further select teh aprticles in the range of size1 and size2
    size1=localstate.sizeLo
    size2=localstate.sizeHi
    sizes_str='size= '+string(size1,format='(F6.2)')+' to '+string(size2,format='(F6.2)')
    ;indexsize=where((subsetdiam ge size1 and subsetdiam lt size2) or (subsetflags eq -1),contggg)
    indexsize=where((subsetdiam ge size1 and subsetdiam lt size2),contggg)
    ;stop
    if contggg gt 0 then begin
        subsetntime =subsetntime(indexsize)
        subsetw8_t    =subsetw8_t(indexsize)
        subsettms     =subsettms(indexsize)
    endif else begin
        subsetntime=[-99.9]
        subsetw8_t  =[-99.9]
        subsettms   =[0L]
    endelse

    ;further select the particles in the range of chosen startTime and stopTIME

    ;note that time0=hhmmss+time(0)/1000.0=hh*3600+mm*60+45.6+ 0.1 seconds.
    cStartTime=LONG64(localstate.starthh*3600L+localstate.startmm*60L+$
        localstate.startss)*1000000000L+(localstate.startms)*1000000L
    cStopTime =LONG64(localstate.stophh*3600L+localstate.stopmm*60L+$
        localstate.stopss)*1000000000L+(localstate.stopms)*1000000L
    stime_str=strtrim(localstate.starthh,2)+':'+strtrim(localstate.startmm,2)+':'+$
        strtrim(localstate.startss,2) +':'+strtrim(round(localstate.startms),2)
    Etime_str=strtrim(localstate.stophh,2)+':'+strtrim(localstate.stopmm,2)+':'+$
        strtrim(localstate.stopss,2)+':'+strtrim(round(localstate.stopms),2)
    ;therefore cstarttime  and cstoptime is seconds from the ntime(0)

    indextime=where(subsetntime ge cStartTime and subsetntime le cStoptime,contggg)
    if contggg gt 0 then begin
        subsetntime =subsetntime(indextime)
        subsetw8_t    =subsetw8_t(indextime)
        subsettms     =subsettms(indextime)
    endif else begin
        subsetntime=[-99.9]
        subsetw8_t   =[-99.9]
        subsettms    =[0L]
    endelse

    ;!!!!!!! important,  The time is not monotonic !!!!
    ; I will sorted the data first.
    ; index=sort(subsetntime,/L64)
    ; subsetntime=subsetntime(index)
    ; subsetw8_t   =subsetw8_t(index)

    ;tempary make this so that it can be compared
    ; subsetntimef=subsetntime
    ; CstartTimef=CstartTime
    ; CstopTimef = CstopTime
    ; Stime_strf =Stime_str
    ; Etime_strf =Etime_str
    ; sizes_strf  =sizes_str
    ; subsetw8_tf=subsetw8_t
endif;  ;endif of if tyep eq 2 for V type
;*****************************************************************************
end; ;end of get_subsetdata
;*****************************************************************************
pro which_group,localstate,group1,group2,group3,group4,group5,group6,group7
    flag0=localstate.flag0
    flag1=localstate.flag1
    flag2=localstate.flag2
    group1=(flag0) and not(flag1) and not(flag2)
    group2=not(flag0) and (flag1) and not(flag2)
    group3=not(flag0) and not(flag1) and (flag2)
    group4=(flag0) and (flag1) and not(flag2)
    group5=(flag0) and not(flag1) and (flag2)
    group6=not(flag0) and (flag1) and (flag2)
    group7=(flag0) and (flag1) and (flag2)
end
;*****************************************************************************

;******************************************************************************

pro get_ntime_ave,localstate,ntime_ave,time_series,w8_t_ave,Stime_str,Etime_str,groupflags,sizes_str
    which_group,localstate,group1,group2,group3,group4,group5,group6,group7

    if localstate.type eq 0 then begin  ;for H type
        ;select the particles having the flag group.
        if group1 eq 1 then begin
            ntime_ave=*localstate.pHntimeg1
            diam_ave =*localstate.pHdiamg1
            w8_t_ave =*localstate.pHw8_tg1
            time_series=*localstate.PHtms1
            groupflags='Edges0'
            group=1
        endif

        if group2 eq 1 then begin
            ntime_ave=*localstate.pHntimeg2
            diam_ave =*localstate.pHdiamg2
            w8_t_ave =*localstate.pHw8_tg2
            time_series=*localstate.PHtms2
            groupflags='Edges1'
            group=2
        endif

        if group3 eq 1 then begin
            ntime_ave=*localstate.pHntimeg3
            diam_ave =*localstate.pHdiamg3
            w8_t_ave =*localstate.pHw8_tg3
            time_series=*localstate.PHtms3
            groupflags='Edges2'
            group=3
        endif

        if group4 eq 1 then begin
            ntime_ave=*localstate.pHntimeg4
            diam_ave =*localstate.pHdiamg4
            w8_t_ave =*localstate.pHw8_tg4
            time_series=*localstate.PHtms4
            groupflags='Edges01'
            group=4
        endif


        if group5 eq 1 then begin
            ntime_ave=*localstate.pHntimeg5
            diam_ave =*localstate.pHdiamg5
            w8_t_ave =*localstate.pHw8_tg5
            time_series=*localstate.PHtms5
            groupflags='Edges02'
            group=5
        endif


        if group6 eq 1 then begin
            ntime_ave=*localstate.pHntimeg6
            diam_ave =*localstate.pHdiamg6
            w8_t_ave =*localstate.pHw8_tg6
            time_series=*localstate.PHtms6
            groupflags='Edges12'
            group=6
        endif
        if group7 eq 1 then begin
            ntime_ave=*localstate.pHntimeg7
            diam_ave =*localstate.pHdiamg7
            w8_t_ave =*localstate.pHw8_tg7
            time_series=*localstate.PHtms7
            groupflags='Edges012'
            group=7
        endif
    endif

    if localstate.type eq 1 then begin  ;for V type
        if group1 eq 1 then begin
            ntime_ave=*localstate.pVntimeg1
            diam_ave =*localstate.pVdiamg1
            w8_t_ave =*localstate.pVw8_tg1
            time_series=*localstate.PVtms1
            groupflags='Edges0'
            group=1
        endif

        if group2 eq 1 then begin
            ntime_ave=*localstate.pVntimeg2
            diam_ave =*localstate.pVdiamg2
            w8_t_ave =*localstate.pVw8_tg2
            time_series=*localstate.PVtms2
            groupflags='Edges1'
            group=2
        endif

        if group3 eq 1 then begin
            ntime_ave=*localstate.pVntimeg3
            diam_ave =*localstate.pVdiamg3
            w8_t_ave =*localstate.pVw8_tg3
            time_series=*localstate.PVtms3
            groupflags='Edges2'
            group=3
        endif

        if group4 eq 1 then begin
            ntime_ave=*localstate.pVntimeg4
            diam_ave =*localstate.pVdiamg4
            w8_t_ave =*localstate.pVw8_tg4
            time_series=*localstate.PVtms4
            groupflags='Edges01'
            group=4
        endif


        if group5 eq 1 then begin
            ntime_ave=*localstate.pVntimeg5
            diam_ave =*localstate.pVdiamg5
            w8_t_ave =*localstate.pVw8_tg5
            time_series=*localstate.PVtms5
            groupflags='Edges02'
            group=5
        endif


        if group6 eq 1 then begin
            ntime_ave=*localstate.pVntimeg6
            diam_ave =*localstate.pVdiamg6
            w8_t_ave =*localstate.pVw8_tg6
            time_series=*localstate.PVtms6
            groupflags='Edges12'
            group=6
        endif
        if group7 eq 1 then begin
            ntime_ave=*localstate.pVntimeg7
            diam_ave =*localstate.pVdiamg7
            w8_t_ave =*localstate.pVw8_tg7
            time_series=*localstate.PVtms7
            groupflags='Edges012'
            group=7
        endif
    endif
    ;!!!!!!! important,  The time is not monotonic !!!!
    ; I will sorted the data first.
    ; index=sort(ntime_ave,/L64)
    ;; ntime_ave=ntime_ave(index)
    ; diam_ave=diam_ave(index)
    ; w8_t_ave=w8_t_ave(index)

    ;select the particles within the time interval
    ;further select the particles in the range of chosen startTime and stopTIME
    ;note that time0=hhmmss+time(0)/1000.0=hh*3600+mm*60+45.6+ 0.1 seconds.
    cStartTime=long64(localstate.starthh*3600L+localstate.startmm*60L+$
        localstate.startss)*1000000000L+(localstate.startms)*1000000L
    cStopTime =long64(localstate.stophh*3600L+localstate.stopmm*60L+$
        localstate.stopss)*1000000000L+(localstate.stopms)*1000000L
    stime_str=strtrim(fix(localstate.starthh),2)+':'+strtrim(fix(localstate.startmm),2)+$
        ':'+strtrim(fix(localstate.startss),2)+':'+strtrim(fix(localstate.startms),2)
    Etime_str=strtrim(fix(localstate.stophh),2)+':'+strtrim(fix(localstate.stopmm),2)+$
        ':'+strtrim(fix(localstate.stopss),2)+':'+strtrim(fix(localstate.stopms),2)
    ;therefore cstarttime  and cstoptime is seconds from the ntime(0)
    indextime=where(ntime_ave ge cStartTime and ntime_ave le cStoptime,contggg)

    if contggg gt 0 then begin
        ntime_ave =ntime_ave(indextime)
        diam_ave  =diam_ave(indextime)
        w8_t_ave   =w8_t_ave(indextime)
        time_series=time_series(indextime)
    endif else begin
        ntime_ave=[-99.9]
        diam_ave =[-99.9]
        w8_t_ave   =[-99.9]
        time_series=[0L]
    endelse

    ;***********************************************add following in May, 1, 2006.
    ;now calculate the time series first and then select the time series
    ; of the chosen particles.
    ; nnnn=n_elements(w8_t_ave)
    ;time_series=lon64arr(nnnn)
    ; time_series(0)=0LL
    ; for i=0LL,nnnn-1LL  do begin
    ;time_series(i+1LL)=time_series(i)+w8_t(i+1LL)
    ; endfor

    ;**************************************************
    ;select the particles within the size interval
    ;further select teh aprticles in the range of size1 and size2
    size1=localstate.sizeLo
    size2=localstate.sizeHi

    sizes_str=string(size1,format='(F7.1)')+' to '+string(size2,format='(F7.1)')
    indexsize=where(diam_ave ge size1 and diam_ave lt size2 ,contggg)
    ;I must include the deadtime-marks to keep the deadtime marks for true
    ; particle inter-arrive-time.
    if contggg gt 0 then begin
        ntime_ave =ntime_ave(indexsize)
        w8_t_ave=w8_t_ave(indexsize)
        diam_ave=diam_ave(indexsize)
        time_series=time_series(indexsize)
    endif else begin
        ntime_ave=[-99.9]
        w8_t_ave=[0.0]
        diam_ave=[0.0]
        time_series=[0LL]
    endelse

    ;now we must take away the deadtime markers  and shrink the time-ticks-to get the true
    ;inter-arrrivel times of the particles.
    index=where(diam_ave gt 0,contGgt0)
    if contGgt0 gt 0 then begin
        ntime_ave=ntime_ave(index)
        w8_t_ave=w8_t_ave(index)
        diam_ave=diam_ave(index)
        time_series=time_series(index)
    endif
    ;stop

    localstate.group=group

end;  end of get_ntime_ave; ntime_ave
;**************************************************************************
pro replot_old_plots,localstate
    nanoseconds_per_second=1000000000.0
    if ptr_valid(localstate.pHyconc) eq 0 then begin
        rrrmo=dialog_message('No data, load data file first !',/information)
        return
    endif
    ;zoomed ave_info.startnanosecond ave_info.endnanosecond period.
    Hyconc=*(localstate.pHyconc);  These are for top pananel two curve plots.
    Hxtime=*(localstate.pHxtime); whole fishing's time series
    Vyconc=*(localstate.pVyconc)
    Vxtime=*(localstate.pVxtime); whole fishing's time series

    cStartTime=LONG64(localstate.starthh*3600L+localstate.startmm*60L+$
        localstate.startss)*1000000000L+(localstate.startms)*1000000L
    cStopTime =LONG64(localstate.stophh*3600L+localstate.stopmm*60L+$
        localstate.stopss)*1000000000L+(localstate.stopms)*1000000L
    stime_str=strtrim(localstate.starthh,2)+':'+strtrim(localstate.startmm,2)+':'+$
        strtrim(localstate.startss,2) +':'+strtrim(round(localstate.startms),2)
    Etime_str=strtrim(localstate.stophh,2)+':'+strtrim(localstate.stopmm,2)+':'+$
        strtrim(localstate.stopss,2)+':'+strtrim(round(localstate.stopms),2)

    widget_control,LocalState.MViewID1,get_value=wid
    wset,wid
    bluecolor =GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    blackcolor=getColor("Black",!D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)
    greencolor =GetColor("Green", !D.Table_Size-2)
    erase,color='ffffff'x  ; get background to white
    !P.multi=[0,4,1]

    ;get the my_ytitle  depending on time resolution
    maxyconc=max([Hyconc,Vyconc])
    if Hxtime(1)-Hxtime(0) eq 0.1 then begin
        my_ytitle='#/(0.1s)'
        my_title=' Normalized #/(0.1S) Series  Max='+strtrim(long(maxyconc),2)+' per_100ms H:blue V:black'
    endif

    if Hxtime(1)-Hxtime(0) gt 0.01 then begin
        my_ytitle='#/(0.01s)'
        my_title=' Normalized #/(0.01S) Series  Max='+strtrim(long(maxyconc),2)+' per_10_ms H:blue V:black'
    endif

    if Hxtime(1)-Hxtime(0) gt 0.001 then begin
        my_ytitle='#/(0.001s)'
        my_title=' Normalized #/(0.001S) Series  Max='+strtrim(long(maxyconc),2)+' per_1ms H:blue V:black'
    endif
    ; stop
    if maxyconc ne 0.0 then begin
        Hyconc=Hyconc/maxyconc
        Vyconc=Vyconc/maxyconc
    endif else begin
        Hyconc=Hyconc*0.0
        Vyconc=Vyconc*0.0
    endelse

    xtimep=Hxtime-Hxtime(0)
    infilename=localstate.infilename
    substr=strsplit(infilename,'\',/extract)
    infilename=substr(n_elements(substr)-1)

    PLOT,xtimep,Hyconc, COLOR=bluecolor, XRANGE=[xtimep(0),max(xtimep)],$
        yrange=[0.0,1.02],title=my_title,background= whitecolor,$
        YTITLE=my_ytitle, Xstyle = 1,THICK=1, Ystyle=1,charsize=2.0,$
        position=[0.12,0.86,0.97,0.96],xtitle='Time, (s)----'+infilename
    oplot,xtimep,Vyconc,color=redcolor
    ;select the zoomed part of concentration time series
    CstartS=CstartTime/nanoseconds_per_second-Hxtime(0)
    CstopS=CstopTime/nanoseconds_per_second-Hxtime(0)
    oplot,[CstartS,CstartS],[0.0,1.02],linestyle=2,color=greencolor
    oplot,[CstopS,  CstopS],[0.0,1.02],linestyle=2,color=greencolor

end
;***********************************************************************
;******************************************************************
pro update_Stime_by_Nsecond,N,localstate
    shh=localstate.starthh
    smm=localstate.startmm
    sss=localstate.startss
    if N ge 0 then begin
        sss=sss+N
        if sss gt 59 then begin
            pmm=sss/60
            sss=sss mod 60
            smm=smm+pmm
        endif

        if smm gt 59 then begin
            phh=smm/60
            smm=smm mod 60
            shh=shh + phh
        endif
    endif

    if N lt 0 then begin
        sss=sss+N
        if sss lt 0 then begin
            sss=sss+60
            smm=smm-1
        endif
        if smm lt 0 then begin
            smm=smm+60
            shh=shh-1
        endif
        if shh lt 0 then shh=shh+24

    endif; end of if N lt 0

    localstate.starthh=shh
    localstate.startmm=smm
    localstate.startss=sss

    widget_control,localstate.StrHr_ID,set_value=shh
    widget_control,localstate.Strmin_ID,set_value=smm
    widget_control,localstate.Strsec_ID,set_value=sss

end;  end of update_time_by_Nsecond,
;******************************************************************
pro update_Etime_by_Nsecond,N,localstate
    ehh=localstate.stophh
    emm=localstate.stopmm
    ess=localstate.stopss
    if N ge 0 then begin
        ess=ess+N
        if ess gt 59 then begin
            pmm=ess/60
            ess=ess mod 60
            emm=emm+pmm
        endif

        if emm gt 59 then begin
            phh=emm/60
            emm=emm mod 60
            ehh=ehh + phh
        endif
    endif

    if N lt 0 then begin
        ess=ess+N
        if ess lt 0 then begin
            ess=ess+60
            emm=emm-1
        endif
        if emm lt 0 then begin
            emm=emm+60
            ehh=ehh-1
        endif
        if ehh lt 0 then ehh=ehh+24

    endif; end of if N lt 0

    localstate.stophh=ehh
    localstate.stopmm=emm
    localstate.stopss=ess

    widget_control,localstate.StpHr_ID,set_value=ehh
    widget_control,localstate.Stpmin_ID,set_value=emm
    widget_control,localstate.Stpsec_ID,set_value=ess

end;  end of update_Etime_by_Nsecond
;*************************************************************************
pro plot_subsetdiam_psd,subsetdiam,localstate
    if n_elements(subsetdiam) eq 0 then return
    adj=subsetdiam*0.0+1.0
    mincntsperbin=1
    minbinwid=1.0

    if n_elements(subsetdiam) lt 2 then begin  ;added Feb. 21 2005
        rrrr=dialog_message('Too few particles to make the plots',/information)
        return
    endif

    unihist_adj, subsetdiam,mincntsperbin,minbinwid,xpts,vals,adj

    WSET, LocalState.psdViewID
    bluecolor =GetColor("Navy", !D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)
    erase,color='ffffff'x  ; get background to white
    !P.thick=1
    !P.CHARSIZE=1
    !P.multi=[0,1,1]
    xpts=xpts*10.0;   1 pixel =10 um.
    vals=vals/10.0
    plot,xpts,vals,color=bluecolor,xrange=[10.0^floor(alog10(min(xpts))),10.0^ceil(alog10(max(xpts)))],$
        yrange=[10.0^floor(alog10(min(vals))),10.0^ceil(alog10(max(vals)))],background=whitecolor,$
        xmargin=[4,2],xtitle='Size,um',ytitle='#/um',/xlog,/ylog,title='PSD_of_Zoomed_Part'
    wait,0.2

end
;**********************************************************************************
;PRO unihist_adj, sizes,mincntsperbin,minbinwid,xpts,vals,adj
;mincntsperbin=ceil(mincntsperbin)
;soszs=sizes[reverse(sort(sizes))]
;adj_local=adj[reverse(sort(sizes))]
;maxnbins=ceil(n_elements(sizes)/float(mincntsperbin))
;vals=dblarr(2*maxnbins)
;xpts=dblarr(2*maxnbins)

;if n_elements(where(adj ne 0)) lt mincntsperbin then begin
;    print,'too few particles in unihist_adj'
;    temp=temporary(xpts)
;    temp=temporary(vals)
;endif else begin

;cnts=0.0
;xpts(0)=soszs(0)
;k=0l
;k2=0l
;denom=0.0d
;while (k2 lt mincntsperbin or denom lt minbinwid) and k lt n_elements(soszs)-1 do begin
;    cnts=cnts + 1*adj_local[k]
;    xpts(1)=(soszs(k)+soszs(k+1))/2.0
;   denom=xpts(0)-xpts(1)
;   if adj_local[k] ne 0.0 then k2=k2+1l
;   k=k+1l
;endwhile
;vals(0)=double(cnts)/denom
;vals(1)=double(cnts)/denom
;print, cnts, denom

;j=0l
;while k lt n_elements(soszs)-1 do begin

;  j=j+2
;  cnts=0.0
;  xpts(j)=xpts(j-1)
;  kj=0
;  denom=0.0d
;  while (kj lt mincntsperbin or denom lt minbinwid or soszs[k] eq soszs[k-1]) and k lt n_elements(soszs)-1 do begin
;  ;while (kj lt mincntsperbin or denom lt minbinwid) and k lt n_elements(soszs)-1 do begin
;     if adj_local[k] ne 0.0 then kj=kj+1
;     cnts=cnts + 1*adj_local[k]
;     xpts(j+1)=(soszs(k)+soszs(k+1))/2.0
;     denom=xpts(j)-xpts(j+1)
;     k=k+1l
;  endwhile
;  vals(j)=double(cnts)/denom
; ; vals(j+1)=double(cnts)/denom
;  print, cnts, denom

;endwhile
;xpts(j+1)=soszs(k)
;denom=xpts(j)-xpts(j+1)
;;print, cnts, denom
;vals(j)=double(cnts+1.0)/denom
;vals(j+1)=double(cnts+1.0)/denom

;I could look back here and if last bin has less than 1/2 required counts combine it with the 2nd last bin
;note last bin always has at least 2 counts
;first xpt is the smallest size and last xpt is the largest size and remaining xpts are mean of last and first of previous and next bins respectively

;xpts=reverse(xpts[0:j+1])
;vals=reverse(vals[0:j+1])

;endelse

;plot,xpts,vals,color=0;,psym=10;,yrange=[1,max(vals)]

;END  ;end of uni_hist_adjl
;********************************************************************************************
;***********************************************************************
pro re_binning,xx0,yy0,binsize,xx,yy
    n_bins=max(xx0); binsize=1
    nn_bins=ceil(float(n_bins)/float(binsize+0.0))
    ;find new bin edges
    xx=fltarr(2LL*nn_bins)
    yy=fltarr(2LL*nn_Bins)
    xx(0)=0
    for k=0LL,nn_bins-2LL do begin
        xx(2*k+1:2*k+2)=k*binsize
    endfor
    xx(2*nn_bins-1LL)=nn_bins*binsize

    for j=0,nn_bins-2LL do begin
        yy(2LL*j:2LL*j+1)=total(yy0(2LL*j*binsize:2ll*j*binsize+2*binsize-1L))/2.0
    endfor
    j=nn_bins-1LL
    yy(2LL*j:2LL*j+1)=total(yy0(2*j*binsize:*))/2.0

end
;************************************************************************
