PRO Mofishing_TextBox_Event, event


    Widget_Control, event.top, Get_UValue=info
    WIDGET_CONTROL, event.ID, GET_UVALUE=uval

    case uval of
        'DeadTimeEstimate': ;widget_control,event.id, get_value=uval

        'MinNumPart': ;widget_control,event.id, get_value=uval

        'PerBINHabsTMS': ;widget_control,event.id, get_value=uval
        'BinSize':   

        'Accept': begin
            widget_control,info.DT_estaimate_Select, get_value=uval
            abcdeff=strtrim(uval,2)

            widget_control,info.Binsize, get_value=uval
            abcdeff=[abcdeff+'/'+strtrim(uval,2)]

            widget_control,info.min_num_of_particles, get_value=uval
            abcdeff=[abcdeff+'/'+strtrim(uval,2)]

            widget_control,info.Per_Bin_Habits_Tms, get_value=uval
            abcdeff=[abcdeff+'/'+strtrim(uval,2)]

            (*info.ptr).text = abcdeff; theText[0]
            ;(*info.ptr).initstate=info.initstate
            Widget_Control, event.top, /Destroy
        end
    endcase

END ;-----------------------------------------------------

;******************************************************************************************************************

FUNCTION Mofishing_TextBox, Title=title, Label=label, Cancel=cancel, $
    Group_Leader=groupleader, XSize=xsize, Value=value

; Return to caller if there is an error. Set the cancel
; flag and destroy the group leader if it was created.

Catch, theError
IF theError NE 0 THEN BEGIN
    Catch, /Cancel
    ok = Dialog_Message(!Error_State.Msg)
    IF destroy_groupleader THEN Widget_Control, groupleader, /Destroy
    cancel = 1
    RETURN, ""
ENDIF

; Check parameters and keywords.

IF N_Elements(title) EQ 0 THEN title = 'Provide Input:'
IF N_Elements(label) EQ 0 THEN label = ""
IF N_Elements(value) EQ 0 THEN value = ""
IF N_Elements(xsize) EQ 0 THEN xsize = 600

IF N_Elements(groupleader) EQ 0 THEN BEGIN
    groupleader = Widget_Base(Map=0)
    Widget_Control, groupleader, /Realize
    destroy_groupleader = 1
ENDIF ELSE destroy_groupleader = 0

tlb = Widget_Base(Title=title, /col, $
    /Base_Align_Center, Group_Leader=groupleader,xsize=250)

labelbase = Widget_Base(tlb, row=1)
IF label NE "" THEN label = Widget_Label(labelbase, Value=label)

b1 = widget_base(tlb,/col,/frame)
b11= widget_base(b1,/row)
butns = ['Xlog','linear'] ;added wysiswyg_r on october 11, 2004
DT_estaimate_Select = CW_BGroup(b11,butns,/exclusive,/row, label_left='X-Axis Scale:',$
    /no_release,button_uvalue=[0,1],uvalue = 'DeadTimeEstimate') ;added oct 11th, 2004.
;my_label='Default is linear in x-axis'
; dtText=widget_text(b11,value=my_label,ysize=0.8,xsize=20)
Widget_Control,  dT_estaimate_Select, set_value=value(0); 0; set the initial input.

b10= widget_base(b1,/row)
Binsize = CW_field(b10,title='X_bin_size:',value=value(1),/int, xsize=5,uvalue = 'BinSize',/all) 


b12= widget_base(b1,/row)
min_num_of_particles = CW_field(b12,title='X-Range Lo_limit:',value=value(2),/int, xsize=5,uvalue = 'MinNumPart',/all) 

b15= widget_base(b1,/row)
Per_Bin_Habits_Tms   = CW_field(b15,title='X-Range Up_Limit:',value=value(3),/int, xsize=5,uvalue = 'PerBINHabsTMS',/all) 


;-----------------------------------------------------------------
b38 = widget_base(tlb,/col)
done=widget_button(b38,value='Accept',uvalue='Accept')
; label=widget_label(b411,value='Enter any strings to make output data files unique, or leave them empty')

;******************************************************************

; Center the widgets on display.

;TextBox_CenterTLB, tlb
Widget_Control, tlb, /Realize

ptr = Ptr_New({text:"", cancel:1})
info = {ptr:ptr,$
    DT_estaimate_Select:DT_estaimate_Select,$
    Binsize:Binsize,$
    min_num_of_particles:min_num_of_particles,$
    Per_Bin_Habits_Tms:Per_Bin_Habits_Tms}

Widget_Control, tlb, Set_UValue=info, /No_Copy

; Blocking or modal widget, depending upon group leader.

XManager, 'Mofishing_textbox', tlb

theText = (*ptr).text
cancel = (*ptr).cancel

;initstate=(*ptr).initstate
Ptr_Free, ptr
IF destroy_groupleader THEN Widget_Control, groupleader, /Destroy

RETURN, theText

END ;-----------------------------------------------------
;*********************************************************************************

