PRO unihist_adj, sizes,mincntsperbin,minbinwid,xpts,vals,adj
    mincntsperbin=ceil(mincntsperbin)
    soszs=sizes[reverse(sort(sizes))]
    adj_local=adj[reverse(sort(sizes))]
    maxnbins=ceil(n_elements(sizes)/float(mincntsperbin))
    vals=dblarr(2*maxnbins)
    xpts=dblarr(2*maxnbins)

    if n_elements(where(adj ne 0)) lt mincntsperbin then begin
        print,'too few particles in unihist_adj'
        temp=temporary(xpts)
        temp=temporary(vals)
    endif else begin

        cnts=0.0
        xpts(0)=soszs(0)
        k=0l
        k2=0l
        denom=0.0d
        while (k2 lt mincntsperbin or denom lt minbinwid) and k lt n_elements(soszs)-1 do begin
            cnts=cnts + 1*adj_local[k]
            xpts(1)=(soszs(k)+soszs(k+1))/2.0
            denom=xpts(0)-xpts(1)
            if adj_local[k] ne 0.0 then k2=k2+1l
            k=k+1l
        endwhile
        vals(0)=double(cnts)/denom
        vals(1)=double(cnts)/denom
        ;print, cnts, denom

        j=0l
        while k lt n_elements(soszs)-1 do begin

            j=j+2
            cnts=0.0
            xpts(j)=xpts(j-1)
            kj=0
            denom=0.0d
            while (kj lt mincntsperbin or denom lt minbinwid or soszs[k] eq soszs[k-1]) and k lt n_elements(soszs)-1 do begin
                ;while (kj lt mincntsperbin or denom lt minbinwid) and k lt n_elements(soszs)-1 do begin
                if adj_local[k] ne 0.0 then kj=kj+1
                cnts=cnts + 1*adj_local[k]
                xpts(j+1)=(soszs(k)+soszs(k+1))/2.0
                denom=xpts(j)-xpts(j+1)
                k=k+1l
            endwhile
            vals(j)=double(cnts)/denom
            vals(j+1)=double(cnts)/denom
            print, cnts, denom

        endwhile
        xpts(j+1)=soszs(k)
        denom=xpts(j)-xpts(j+1)
        ;print, cnts, denom
        vals(j)=double(cnts+1.0)/denom
        vals(j+1)=double(cnts+1.0)/denom

        ;I could look back here and if last bin has less than 1/2 required counts combine it with the 2nd last bin
        ;note last bin always has at least 2 counts
        ;first xpt is the smallest size and last xpt is the largest size and remaining xpts are mean of last and first of previous and next bins respectively

        xpts=reverse(xpts[0:j+1])
        vals=reverse(vals[0:j+1])

    endelse

    ;plot,xpts,vals,color=0;,psym=10;,yrange=[1,max(vals)]

END
